c **********************************************************************
c *   Vertical profiles of vorticity budgets                           *
c *                                                                    *
c *                                   Dec/2006  M. Nakanishi (N.D.A)   *
c **********************************************************************
c
      include  "sub/graph.f"
      include  "sub/ziestm.f"
      include  "sub/vordif.f"
      include  "../src/Parameter.h"
c
      parameter ( mf=5, mg=3, me=3, mt=5 )
      character (len=4)  :: f_name(mf+mg)
      character (len=20) :: e_lab (me)
      character (len=3)  :: s_lab (me)
      character (len=10) :: z_lab
      character (len=8)  :: l_lab
      character (len=6)  :: t_lab (mt,me)
      character (len=5)  :: r_name
      character (len=30) :: line
      double precision  dat(mx,mz,my,mf), da2(mx,my,mg)
      double precision  wk (mx,mz,my, 6)
      double precision  av1, av2, av3, av4, del
      dimension  vpro(mz,mt,me)
      dimension  xx(mz), yy(mz)
      dimension  newp(mt)
c
      data  f_name/ 'u___', 'v___', 'w___', 'fm__', 'fub_',
     :              'flt_', 'flq_', 'flm_'/
      data  e_lab / '$<#x> budget (s^-^2)',
     :              '$<#h> budget (s^-^2)',
     :              '$<#z> budget (s^-^2)'/
      data  s_lab /  '(a)',  '(b)',  '(c)'/
      data  z_lab / 'Height (m)'/, l_lab / '0000 LST'/
      data  t_lab / '$St_#x', '$Ti_#x', '$T_#x ', '$C_#x ', '$D_#x ',
     :              '$St_#h', '$Ti_#h', '$T_#h ', '$C_#h ', '$D_#h ',
     :              '$St_#z', '$Ti_#z', '$T_#z ', '$C_#z ', '$D_#z '/
      data  newp  /   4,  14,  54,  34,  44/
c
      namelist  /les1/  nrun, nstep,  iout,  jout,  lout
      namelist  /les2/  isgs,  isfc,  irad,  icon,  isca,
     :                  jmin,  rlat,    dt,    dx,    dy,    dz,
     :                         ugsf,  vgsf,         aglw,  agmd,
     :                  gulw,  gvlw,  gumd,  gvmd,
     :                  tref,   tsf,   qsf,   psf,  hglw,  hgmd,
     :                  gtlw,  gqlw,  gtmd,  gqmd,  gamt,  gamq,
     :                   z0m,   z0h,  tfmx,  qfmx, phour, dhour,
     :                 tdeep,  swet,  crso,  fkso,
     :                  elat,  albd,  clov,  ulov,
     :                 nflay, frate,
     :                  nspl,  nspu,   csp, nstot
c
      radi = 100000.0
c
c     open (1,file='/home/naka/les_for_es/figure/meanscale.dat')
c     do i = 1,999
c       read (1,'(a)',end=10) line
c       if ( line(1:1) .ne. 'V' ) cycle
c       read (line(10:30),*) xsta, xend, lbx
c       exit
c     end do
c  10 close(1)
      xsta = -1.0
      xend =  1.0
      lbx  =  520
c
      write(6,*) 'Run + Restart number (xx.xx) =?'
      read (5,'(a)')  r_name
      write(6,*) 'Record number =?'
      read (5,*)  idmy, idmy, itplt
c
      open (10,file='para'//r_name,status='old',iostat=ios)
      if ( ios .ne. 0 ) stop 'Para-file not found.'
c
      read (10,nml=les1)
      read (10,nml=les2)
      close(10)
c
      rsum = 1.0/dble((nx-2)*(ny-2))
c
      tlat = rlat * 3.141593/180.0
      fs   = 2.0*7.292e-5*sin( tlat )
      fc   = 2.0*7.292e-5*cos( tlat )
c
      do m = 1,mf+mg
        open (m+10,file=f_name(m)//r_name,form='unformatted',
     :             status='old',iostat=ios)
        if ( ios .ne. 0 ) stop 'Data-file not found.'
      end do
c
      do ll = 1,itplt
        jhour = ( jmin +nint(ll*jout*dt)/60 )/60
c
        do m = 1,mf
          read (m+10,   end=100) (((dat(i,k,j,m),i=1,mx),k=1,mz),j=1,my)
        end do
        do m = 1,mg
          read (m+10+mf,end=100) ( (da2(i,  j,m),i=1,mx),        j=1,my)
        end do
      end do
c
  100   continue
c
c  ***  for vorticity  ***
        call vordif ( 1, dat(1,1,1,1), dat(1,1,1,2), dat(1,1,1,3),
     :                   dat(1,1,1,4), da2(1,1,3),
     :               mx, mz, nx, nz, ny, dx, dz, dy,
     :               wk (1,1,1,1), wk (1,1,1,2), wk (1,1,1,3),
     :               wk (1,1,1,4), wk (1,1,1,5), wk (1,1,1,6),
     :               vpro(1,5,1), vpro(1,5,2), vpro(1,5,3) )
c
        do j = 2,ny
        do k = 2,nz+1
        do i = 2,nx
          wk(i, k ,j,1) = ( dat(i, k ,j,3)-dat( i , k ,j-1,3) ) / dy
     :                   -( dat(i, k ,j,2)-dat( i ,k-1, j ,2) ) / dz
          wk(i, k ,j,2) = ( dat(i, k ,j,1)-dat( i ,k-1, j ,1) ) / dz
     :                   -( dat(i, k ,j,3)-dat(i-1, k , j ,3) ) / dx
          wk(i,k-1,j,3) = ( dat(i,k-1,j,2)-dat(i-1,k-1, j ,2) ) / dx
     :                   -( dat(i,k-1,j,1)-dat( i ,k-1,j-1,1) ) / dy
        end do
        end do
        end do
c
        do k = 2,nz
          av1 = 0.0
          av2 = 0.0
          av3 = 0.0
          av4 = 0.0
          do j = 2,ny-1
          do i = 2,nx-1
            del =      0.5 *( dat( i , k , j ,1)-dat(i,k-1, j ,1)
     :                       +dat( i , k ,j-1,1)-dat(i,k-1,j-1,1) )/dz
c
c?          av1 = av1 +0.25*( wk ( i ,k+1,j+1,1)+wk (i,k+1,j,1)
c?   :                       +wk ( i , k ,j+1,1)+wk (i, k ,j,1) )
c?   :                     *( dat(i+1, k , j ,1)-dat(i, k ,j,1) ) / dx
            av1 = av1 +0.25*( wk ( i , k ,j+1,1)+wk (i, k , j ,1) )
     :                     *( dat(i+1, k , j ,1)-dat(i, k , j ,1)
     :                       +dat(i+1,k-1, j ,1)-dat(i,k-1, j ,1) )/dx
            av2 = av2 +0.25*( wk ( i , k ,j+1,2)+wk (i, k , j ,2) )
     :                     *( dat( i , k ,j+1,1)-dat(i, k , j ,1)
     :                       +dat( i ,k-1,j+1,1)-dat(i,k-1, j ,1) )/dy
     :                *0.5 *( wk ( i , k , j ,3)+wk (i,k-1, j ,3) )*del
            av3 = av3 +0.5 *( wk ( i , k ,j+1,1)+wk (i, k , j ,1) )
     :                     *  dat( i , k , j ,3)
            av4 = av4 +del *( fs
     :                +0.25*( dat( i , k , j ,2)+dat( i ,k-1,j,2)
     :                       +dat(i-1, k , j ,2)+dat(i-1,k-1,j,2) )
     :                     /  radi )
     :                +0.5 *( dat( i , k , j ,2)-dat( i ,k-1,j,2)
     :                       +dat(i-1, k , j ,2)-dat(i-1,k-1,j,2) )/dz
     :                *0.25*( dat( i , k , j ,1)+dat(i,k-1, j ,1)
     :                       +dat( i , k ,j-1,1)+dat(i,k-1,j-1,1) )
     :                     /  radi
          end do
          end do
c
          vpro(k,1,1) = av1 * rsum
          vpro(k,2,1) = av2 * rsum
          vpro(k,3,1) = av3 * rsum
          vpro(k,4,1) = av4 * rsum
c
          av1 = 0.0
          av2 = 0.0
          av3 = 0.0
          av4 = 0.0
          do j = 2,ny-1
          do i = 2,nx-1
            del =      0.5 *( dat( i , k , j ,2)-dat( i ,k-1,j,2)
     :                       +dat(i-1, k , j ,2)-dat(i-1,k-1,j,2) )/dz
c
            av1 = av1 +0.25*( wk (i+1, k , j ,2)+wk ( i , k ,j,2) )
     :                     *( dat( i , k ,j+1,2)-dat( i , k ,j,2)
     :                       +dat( i ,k-1,j+1,2)-dat( i ,k-1,j,2) )/dy
            av2 = av2 +0.25*( wk (i+1, k , j ,1)+wk ( i , k ,j,1) )
     :                     *( dat(i+1, k , j ,2)-dat( i , k ,j,2)
     :                       +dat(i+1,k-1, j ,2)-dat( i ,k-1,j,2) )/dx
     :                *0.5 *( wk ( i , k , j ,3)+wk ( i ,k-1,j,3) )*del
            av3 = av3 +0.5 *( wk (i+1, k , j ,2)+wk (i, k , j ,2) )
     :                     *  dat( i , k , j ,3)
            av4 = av4 +del *( fs
     :                +0.5 *( dat( i , k , j ,2)+dat( i ,k-1,j,2)
     :                       +dat(i-1, k , j ,2)+dat(i-1,k-1,j,2) )
     :                     /  radi )
          end do
          end do
c
          vpro(k,1,2) = av1 * rsum
          vpro(k,2,2) = av2 * rsum
          vpro(k,3,2) = av3 * rsum
          vpro(k,4,2) = av4 * rsum
        end do
c
        do k = 1,nz
          av1 = 0.0
          av2 = 0.0
          av3 = 0.0
          av4 = 0.0
          do j = 2,ny-1
          do i = 2,nx-1
            av1 = av1 +0.25*( dat(i,k+1, j ,3)+dat(i-1,k+1, j ,3)
     :                       +dat(i,k+1,j-1,3)+dat(i-1,k+1,j-1,3)
     :                       -dat(i, k , j ,3)-dat(i-1, k , j ,3)
     :                       -dat(i, k ,j-1,3)-dat(i-1, k ,j-1,3) )/dz
     :                     *  wk (i, k , j ,3)
          end do
          end do
c
          vpro(k,1,3) = av1 * rsum
          vpro(k,2,3) = av2 * rsum
          vpro(k,3,3) = av3 * rsum
          vpro(k,4,3) = av4 * rsum
        end do
c
        do k = 2,nz
          vpro(k,3,1) = -( vpro(k+1,3,1)-vpro(k,3,1) ) / dz
          vpro(k,3,2) = -( vpro(k+1,3,2)-vpro(k,3,2) ) / dz
          vpro(k,3,3) = -( vpro(k+1,3,3)-vpro(k,3,3) ) / dz
        end do
c
        do l = 1,mt
        do m = 1,me
        do k = 1,mz
          vpro(k,l,m) = vpro(k,l,m) * 1.0e4
        end do
        end do
        end do
c
      wx   = 6.0
      wy   = 8.0
      shft = 0.2
c
      xmv  = wx +0.6
      x0   = 4.5
      y0   = 7.0
c
      kz   = nz
c     kz   = 40
      zmax = dz * kz
      lbz  = nint( zmax/100.0 ) +400
c
      write(l_lab(1:2),'(i2.2)') jhour
c
cx    call winnam( 'Budget' )
      call winfac( 2.5 )
      call plots ( 0.0, 0.0, -2 )
      call factor( 10.0 )
      call plot  (  x0,  y0, -3 )
      call newfnt( 4 )
c
        scl = ( xend-xsta )/mod(lbx,100)*max(lbx/100,2)
                                      lnx  = -1
                                      lny  = -1
        if ( scl .ne. int(scl)      ) lnx  =  1
c
c     do m = 1,me
      do m = 1,2
        if ( m   .gt. 1             ) lny  = -9
c
        call newpen( 3 )
        call symbol( 0.80,  wy-1.0, 0.60, s_lab (m), 0.0,  3 )
        call symbol( wx-0.6,wy-1.0, 0.45, l_lab,     0.0,208 )
        if ( m .eq. 1 )
     :  call symbol(-1.50,  wy*0.5, 0.50, z_lab,    90.0,110 )
        call symbol( 0.5*wx, -1.20, 0.50, e_lab (m), 0.0,120 )
        call graph ( wx, wy, xsta, xend, 0.0, zmax, facx, facy,
     :        lbx,lbz,lnx,lny, '      ', '      ', 0, 999.0, shft )
c
        if ( xsta .lt. 0.0 ) then
          call newpen( 0 )
          call plot  ( -xsta*facx, 0.0, 3 )
          call plot  ( -xsta*facx,  wy, 2 )
        end if
c
        call rclip( 1, 0.0, 0.0, wx, wy )
c
        do l = 1,mt
          if ( t_lab(l,m)(1:1) .eq. ' ' ) cycle
c
          call newpen( newp(l) )
c
            call plot  (0.6,wy-l*0.5-1.3+ypls, 3)
            call plot  (1.3,wy-l*0.5-1.3+ypls, 2)
            call symbol(1.5,wy-l*0.5-1.3+ypls,0.45,t_lab(l,m),0.0,306)
c
                          zst = 1.0
          if ( l .ge. 3 ) zst = 0.5
c
          do k = 2,kz
            xx(k) = ( vpro(k,l,m)-xsta )*facx
            yy(k) = ( k-zst )*dz        *facy +shft
          end do
c
          call polygn( xx(2), yy(2), kz-1, 0 )
c
        end do
c
        call rclip( 0, 0.0, 0.0, wx, wy )
c
          call plot (  xmv,  0.0, -3 )
c
      end do
c
      call cls  ( 1 )
      call plote
c
      stop
      end
