c **********************************************************************
c *   Momentum flux terms (Advection term + Reynolds stress term)      *
c **********************************************************************
c
      subroutine  flux_moment
c
      include  "Declare.h"
c
      do j = 1,ny-1
      do k = 1,nz
        gamk = gam(k)
      do i = 1,nx-1
        f0   = 2.0 *( gamk*  fm(i,k,j) +anyu )
c
        uu(i,k,j) = -0.25*( u (i+1, k , j )+u (i,k,j) )**2
     :              +f0  *( u (i+1, k , j )-u (i,k,j) ) / dx
        vv(i,k,j) = -0.25*( v ( i , k ,j+1)+v (i,k,j) )**2
     :              +f0  *( v ( i , k ,j+1)-v (i,k,j) ) / dy
        ww(i,k,j) = -0.25*( w ( i ,k+1, j )+w (i,k,j) )**2
     :              +f0  *( w ( i ,k+1, j )-w (i,k,j) ) / dz
      end do
      end do
      end do
c
      do j = 2,ny
      do k = 1,nz
        gamk = gam(k)
c
        m    = k +1
        gamm = 0.5*( gam(m)+gam(m-1) )
        f11  = fwu(m)
        f22  = fvw(m)
      do i = 2,nx
        f0   = 0.25*gamk*( fm( i , k , j )+fm(i-1, k , j )
     :                    +fm( i , k ,j-1)+fm(i-1, k ,j-1) ) +anyu
c
        uv(i,k,j) = -0.25*( u (i,k,j)+u ( i , k ,j-1) )
     :                   *( v (i,k,j)+v (i-1, k , j ) )
     :              +f0*( ( u (i,k,j)-u ( i , k ,j-1) ) / dy
     :                   +( v (i,k,j)-v (i-1, k , j ) ) / dx )
c
        f1   = 0.25*gamm*( fm( i , m , j )+fm(i-1, m , j )
     :                    +fm( i ,m-1, j )+fm(i-1,m-1, j ) ) +anyu
        f2   = 0.25*gamm*( fm( i , m , j )+fm( i , m ,j-1)
     :                    +fm( i ,m-1, j )+fm( i ,m-1,j-1) ) +anyu
c
        wu(i,m,j) = -0.25*( u (i,m,j)+u ( i ,m-1, j ) )
     :                   *( w (i,m,j)+w (i-1, m , j ) )
     :              +f1*( ( u (i,m,j)-u ( i ,m-1, j ) ) / dz
     :                   +( w (i,m,j)-w (i-1, m , j ) ) / dx )
     :              +f11
        vw(i,m,j) = -0.25*( v (i,m,j)+v ( i ,m-1, j ) )
     :                   *( w (i,m,j)+w ( i , m ,j-1) )
     :              +f2*( ( v (i,m,j)-v ( i ,m-1, j ) ) / dz
     :                   +( w (i,m,j)-w ( i , m ,j-1) ) / dy )
     :              +f22
      end do
      end do
      end do
c
c  ***  Lower boundary condition  ***
      do j = 2,ny-1
      do i = 2,nx-1
        wu(i,1,j) = -0.5*( flm(i,j)+flm(i-1, j ) )*u (i,1,j)
        vw(i,1,j) = -0.5*( flm(i,j)+flm( i ,j-1) )*v (i,1,j)
      end do
      end do
c
      return
      end
