c **********************************************************************
c *   Scalar flux terms (Advection term + Diffusion term)              *
c *                                                                    *
c *   Variables:                                                       *
c *     m             : Parameter                                      *
c *                   : = 4,       for potential temperature           *
c *                   : = 5,       for specific humidity               *
c *                   : otherwise, for turbulent kinetic energy        *
c **********************************************************************
c
      subroutine  flux_scalar ( m )
c
      include  "Declare.h"
c
      fac1 = 1.0
      fac2 = 2.0
c
      if     ( m .eq. 4 ) then
        do j = 2,ny-1
        do k = 1,nz
        do i = 1,mx
          uv(i,k,j) = rhr( i ,k+1, j )
     :               -2.0*ev/( pi0( i ,k+1, j )+pi0(i,k,j) )
     :               *gno*( ql( i ,k+1, j )**gpw
     :                     -ql( i , k , j )**gpw ) / dz
        end do
        end do
        end do
c
        do j = 2,ny-1
        do i = 2,nx-1
          ww(i,1,j) = -flt(i,j)
        end do
        end do
c
        call sub_flux_scalar ( t, fh, fac1, tnyu )
c
      elseif ( m .eq. 5 ) then
        do j = 2,ny-1
        do k = 1,nz
        do i = 1,mx
          uv(i,k,j) = gno*( ql( i ,k+1, j )**gpw
     :                     -ql( i , k , j )**gpw ) / dz
        end do
        end do
        end do
c
        do j = 2,ny-1
        do i = 2,nx-1
          ww(i,1,j) = -flq(i,j)
        end do
        end do
c
        call sub_flux_scalar ( q, fh, fac1, tnyu )
c
      else
        do j = 2,ny-1
        do i = 2,nx-1
          ww(i,1,j) = 0.0
        end do
        end do
c
        call sub_flux_scalar ( tk, fm, fac2, anyu )
c
      end if
c
      return
      end
c
      subroutine  sub_flux_scalar ( tq, fq, fac, qnyu )
c
      include  "Declare.h"
c
      dimension  tq(mx,mz,my), fq(mx,mz,my)
!hpf$ distribute (*,*,block) :: tq, fq
c
      do j = 2,ny
      do k = 1,nz
      do i = 2,nx
c  ***  Upstream difference scheme  ***
cx      f1 = 0.5*fac*( fq(i,k,j)+fq(i-1,k, j ) ) +0.5*dx*abs(u(i,k,j))
cx      f2 = 0.5*fac*( fq(i,k,j)+fq( i ,k,j-1) ) +0.5*dy*abs(v(i,k,j))
c
        f1 = 0.5*fac*( fq(i,k,j)+fq(i-1, k , j ) ) +qnyu
        f2 = 0.5*fac*( fq(i,k,j)+fq( i , k ,j-1) ) +qnyu
c
        uu(i,k,j) = -0.5*( tq(i,k,j)+tq(i-1, k , j ) ) * u(i,k,j)
     :              +f1 *( tq(i,k,j)-tq(i-1, k , j ) ) / dx
        vv(i,k,j) = -0.5*( tq(i,k,j)+tq( i , k ,j-1) ) * v(i,k,j)
     :              +f2 *( tq(i,k,j)-tq( i , k ,j-1) ) / dy
      end do
      end do
      end do
c
      do j = 2,ny-1
      do k = 2,nz+1
      do i = 1,mx
c  ***  Upstream difference scheme  ***
cx      f1 = 0.5*fac*( fq(i,k,j)+fq(i,k-1,j) ) +0.5*dz*abs(w(i,k,j))
c
        f1 = 0.5*fac*( fq(i,k,j)+fq( i ,k-1, j ) ) +qnyu
c
        ww(i,k,j) = -0.5*( tq(i,k,j)+tq( i ,k-1, j ) ) * w(i,k,j)
     :              +f1 *( tq(i,k,j)-tq( i ,k-1, j ) ) / dz
      end do
      end do
      end do
c
      return
      end
