c **********************************************************************
c *   Horizontal distributions of quantities at a height specified     *
c *                                                                    *
c *                                   May/2005  M. Nakanishi (N.D.A)   *
c **********************************************************************
c
      include  "contln.f"
      include  "../src/Parameter.h"
c
      parameter ( me=5, mv=11, mvh=mv/2 )
      character (len=4)  :: e_name(me)
      character (len=5)  :: r_name
      double precision  dat(mx,mz,my)
      dimension  hdis(mx,my,me), zeta(mx,my)
      dimension  vave(me), vmax(me), xx(mx), yy(my)
      dimension  val(mv,me), iro(mv)
      data  iro /mv*-1/
c
      data  e_name/ 'u___', 'v___', 'w___', 't___', 'ql__'/
c
      namelist  /les2/  isgs,  isfc,  irad,  icon,  isca,
     :                  jmin,  rlat,    dt,    dx,    dy,    dz,
     :                         ugsf,  vgsf,         aglw,  agmd,
     :                  gulw,  gvlw,  gumd,  gvmd,
     :                  tref,   tsf,   qsf,   psf,  hglw,  hgmd,
     :                  gtlw,  gqlw,  gtmd,  gqmd,  gamt,  gamq,
     :                   z0m,   z0h,  tfmx,  qfmx, dhour,
     :                 tdeep,  swet,  crso,  fkso,
     :                  elat,  albd,  clov,  ulov,
     :                 nflay, frate,
     :                  nspl,  nspu,   csp, nstot
c
      write(6,*) 'Run + Restart number (xx.xx) =?'
      read (5,'(a)')  r_name
      write(6,*) 'Vertical grid number =?'
      read (5,*)  izplt, idmy, itplt
c
      open (10,file='para'//r_name,status='old',iostat=ios)
      if ( ios .ne. 0 ) stop
c
      read (10,nml=les2)
      close(10)
c
      ne = me
c
      rsum = 1.0/dble((nx-2)*(ny-2))
c
      do m = 1,me
        open (11,file=e_name(m)//r_name,form='unformatted',
     :           status='old',iostat=ios)
        if ( ios .ne. 0 ) then
          ne = m -1
          exit
        end if
c
        do it = 1,itplt
          read (11,end=100) dat
        end do
c
  100   itplt = it -1
c
        close(11)
c
                                     ad = 0.0
        if ( e_name(m) .eq. 'w___' ) ad = 0.5
                                     bd = 1.0 -ad
c
          vave(m) =   0.0
          vmax(m) = -99.0
        do j = 2,ny-1
        do i = 2,nx-1
          dd      = ad*dat(i,izplt+1,j) + bd*dat(i,izplt,j)
          vave(m) =      vave(m) +dd
          vmax(m) = max( vmax(m), dd )
        end do
        end do
          vave(m) = vave(m) * rsum
          vmax(m) = vmax(m) - vave(m)
c
        do j = 1,ny
        do i = 1,nx
          dd      = ad*dat(i,izplt+1,j) + bd*dat(i,izplt,j)
          hdis(i,j,m) = dd - vave(m)
        end do
        end do
c
        if ( e_name(m) .eq. 't___' ) vave(m) = vave(m) +tref
c
        write(6,*) e_name(m), ' ave, max =', vave(m), vmax(m)
      end do
c ***
      e_name(2) = 'Z___'
c
        vave(2) =   0.0
        vmax(2) = -99.0
      do j = 2,ny-1
      do i = 2,nx-1
        zeta(i,j) = ( hdis(i+1,j+1,2)+hdis(i+1, j ,2)
     :               -hdis(i-1,j+1,2)-hdis(i-1, j ,2) )/( 4.0*dx )
     :             -( hdis(i+1,j+1,1)+hdis( i ,j+1,1)
     :               -hdis(i+1,j-1,1)-hdis( i ,j-1,1) )/( 4.0*dy )
        vmax(2) = max( vmax(2), zeta(i,j) )
      end do
      end do
        vmax(2) = vmax(2) - vave(2)
c
      do j = 1,ny
        zeta( 1, j) = zeta(nx-1,   j)
        zeta(nx, j) = zeta(   2,   j)
      end do
      do i = 1,nx
        zeta( i, 1) = zeta(   i,ny-1)
        zeta( i,ny) = zeta(   i,   2)
      end do
c
      do j = 1,ny
      do i = 1,nx
        hdis(i,j,2) = zeta(i,j)
      end do
      end do
c ***
      wx   = 6.5
      wy   = wx*( dy*ny )/( dx*nx )
c
      xmv  = wx +1.0
      ymv  = wy +2.0
      x0   =  3.5
      y0   = 18.0
c
      do m = 1,ne
        vl   = log10( vmax(m) )
        colm = 10.0**( int(vl)-1+int(vl-int(vl)+1) )
        del  = colm*int( vmax(m)/colm ) / dble(mvh)
      do i = 1,mv
        val(i,m) = del*(i-mvh-1)
      end do
      end do
c
      facx = wx/( dx*nx )
      facy = wy/( dy*ny )
c
      do i = 1,nx
        xx(i) = dx*( i-0.5 ) * facx
      end do
      do j = 1,ny
        yy(j) = dy*( j-0.5 ) * facy
      end do
c
cx    call winnam( 'Horizontal' )
      call winfac( 2.0 )
      call plots ( 0.0, 0.0,  2 )
      call factor( 10.0 )
      call plot  (  x0,  y0, -3 )
      call newfnt( 4 )
c
      do m = 1,ne
        call newpen( 2 )
        call symbol( 0.2, wy+0.2, 0.45, e_name(m),         0.0, 2 )
        call number( 1.4, wy+0.2, 0.45, vave(m),           0.0, 3 )
        call number( 3.2, wy+0.2, 0.45, val(2,m)-val(1,m), 0.0, 3 )
        call number( 4.8, wy+0.2, 0.45, real(izplt),       0.0,-1 )
        call number( 5.8, wy+0.2, 0.45, real(itplt),       0.0,-1 )
        call rect  ( 0.0, 0.0, wx, wy, 0.0, 0 )
c
        call newpen( 50 )
        call contln( hdis(1,1,m), mx, nx, ny, xx, yy,
     :               val(1,m),     iro,        mvh, 0.2, 2, 0 )
        call newpen( 0 )
        call contln( hdis(1,1,m), mx, nx, ny, xx, yy,
     :               val(mvh+2,m), iro(mvh+2), mvh, 0.2, 2, 0 )
        call newpen( 2 )
        call contln( hdis(1,1,m), mx, nx, ny, xx, yy,
     :               0.0, -1, 1, 0.2, -1, 0 )
c
        if ( mod(m,2) .eq. 1 ) then
          call plot (  xmv,  0.0, -3 )
        else
          call plot ( -xmv, -ymv, -3 )
        end if
      end do
c
      call cls  ( 1 )
      call plote
c
      stop
      end
