c **********************************************************************
c *   Buoyant force & expedient, hydrostatic pressure                  *
c *                                                                    *
c *   # Normally the hydrostatic pressure may be computed by using     *
c *     horizontally averaged values. This pressure is applied to      *
c *     the condensation and radiation processes.                      *
c **********************************************************************
c
      subroutine  buoyancy
c
      include  "Declare.h"
c
      gtr = g   /tref
      gtz = gtr /tref*dz
      tv0 = 0.61*tref
      tv1 = 1.61*tref
      ak  = 1.0 /pk
c
      do j = 2,ny-1
      do k = nz,1,-1
      do i = 2,nx-1
        pp  = 2.0*ev/( pi0( i ,k+1, j )+pi0(i,k,j) )
        tvv = ( t(i,k,j) +tref +pp*ql(i,k,j) )
     :       *( 1.0 +0.61*q(i,k,j) -1.61*ql(i,k,j) ) -tref
c
c  ***  Approximated expression  ***
cx      tvv = t(i,k,j) +tv0*q(i,k,j) +( pp-tv1 )*ql(i,k,j)
c
        bv(i,k,j) = gtr*tvv
        pi(i,k,j) = pi( i ,k+1, j ) -gtz*tvv
      end do
      end do
      end do
c
      do j = 2,ny-1
      do k = 1,nz+1
      do i = 1,mx
        p(i,k,j) = p0*( ( pi(i,k,j)+pi0(i,k,j) )/cp )**ak
      end do
      end do
      end do
c
      call bc_lat_scalar ( pi )
      call bc_lat_scalar ( p  )
c
      return
      end
