c **********************************************************************
c *   Subtraction of the hydrostatic balance and the horizontal mean   *
c *   from the equation for the vertical velocity                      *
c *                                                                    *
c *   # If this procedure is omitted, pd results in containing the     *
c *     hydrostatic pressure. This result has no influence on the      *
c *     other statistical quantities. Considering that p_h >> p_d,     *
c *     however, this procedure may be to be carried out.              *
c **********************************************************************
c
      subroutine  hydro_subtraction
c
      include  "Declare.h"
c
      dimension  bav(mz), wav(mz), pav(mz)
c
      rsum = 1.0 /dble((nx-2)*(ny-2))
c
      do k = 1,nz
        bav(k) = 0.0
        wav(k) = 0.0
        pav(k) = 0.0
      end do
c
      do j = 2,ny-1
      do k = 1,nz
      do i = 2,nx-1
        bav(k) = bav(k) +bv(i,k,j)
        wav(k) = wav(k) +ww(i,k,j)
        pav(k) = pav(k) +pd(i,k,j)
      end do
      end do
      end do
c
      do k = 1,nz
        bav(k) = bav(k) * rsum
        wav(k) = wav(k) * rsum
        pav(k) = pav(k) * rsum
      end do
c
      do j = 1,ny-1
      do k = 1,nz
      do i = 1,nx-1
        bv(i,k,j) = bv(i,k,j) -bav(k)
        ww(i,k,j) = ww(i,k,j) -wav(k)
        pd(i,k,j) = pd(i,k,j) -pav(k)
      end do
      end do
      end do
c
      return
      end
