c **********************************************************************
c *   Vertical distributions of quantities                             *
c *                                                                    *
c *                                   May/2005  M. Nakanishi (N.D.A)   *
c **********************************************************************
c
      include  "contln.f"
      include  "vector.f"
      include  "../src/Parameter.h"
c
      parameter ( mxy=max(mx,my) )
      parameter ( me=5, mv=17, mvh=mv/2 )
      character (len=4)  :: f_name(me)
      character (len=5)  :: r_name
      double precision  dat(mx,mz,my)
      dimension  vdis(mxy,mz,me)
      dimension  vave(mz,me), vmax(me), xx(mxy), zz(mz)
      dimension  val(mv,me), iro(mv)
      data  iro /mv*-1/
c
      data  f_name/ 'u___', 'v___', 'w___', 't___', 'ql__'/
c
      namelist  /les2/  isgs,  isfc,  irad,  icon,  isca,
     :                  jmin,  rlat,    dt,    dx,    dy,    dz,
     :                         ugsf,  vgsf,         aglw,  agmd,
     :                  gulw,  gvlw,  gumd,  gvmd,
     :                  tref,   tsf,   qsf,   psf,  hglw,  hgmd,
     :                  gtlw,  gqlw,  gtmd,  gqmd,  gamt,  gamq,
     :                   z0m,   z0h,  tfmx,  qfmx, dhour,
     :                 tdeep,  swet,  crso,  fkso,
     :                  elat,  albd,  clov,  ulov,
     :                 nflay, frate,
     :                  nspl,  nspu,   csp, nstot
c
      write(6,*) 'Run + Restart number (xx.xx) =?'
      read (5,'(a)')  r_name
      write(6,*) 'Horizontal grid number (ix*1000+iy) =?'
      read (5,*)  idmy, ihplt, itplt
c
      ixplt =     ihplt/1000
      iyplt = mod(ihplt,1000)
c
      if ( r_name(4:5) .eq. '00' ) then
        open (10,file='para'//r_name(1:3)//'01',status='old',iostat=ios)
      else
        open (10,file='para'//r_name,status='old',iostat=ios)
      end if
      if ( ios .ne. 0 ) stop
c
      read (10,nml=les2)
      close(10)
c
      ne = me
c
      rsum = 1.0/dble((nx-2)*(ny-2))
c
      do m = 1,me
      do k = 1,nz
        vave(k,m) = 0.0
      end do
      end do
c
      do m = 1,me
        open (11,file=f_name(m)//r_name,form='unformatted',
     :           status='old',iostat=ios)
        if ( ios .ne. 0 ) then
          ne = m -1
          exit
        end if
c
        do it = 1,itplt
          read (11,end=100) dat
        end do
c
  100   itplt = it -1
c
        close(11)
c
                                     ad = 0.0
        if ( f_name(m) .eq. 'w___' ) ad = 0.5
                                     bd = 1.0 -ad
c                                    ae = 0.0
c       if ( f_name(m) .eq. 'u___' .or. f_name(m) .eq. 'v___' )
c    :                               ae = 0.5
c                                    be = 1.0 -ae
c
        vmax(m) = -1.0e10
c
        if ( iyplt .ne. 0 ) then
          nxy = nx
          dxy = dx
c
          do k = 1,nz
          do i = 1,nx
            vdis(i,k,m) = ad*dat(i,k+1,iyplt) + bd*dat(i,k,iyplt)
            vmax(m) = max( vmax(m), vdis(i,k,m) )
          end do
          end do
        else
          nxy = ny
          dxy = dy
c
          do j = 1,ny
          do k = 1,nz
            vdis(j,k,m) = ad*dat(ixplt,k+1,j) + bd*dat(ixplt,k,j)
            vmax(m) = max( vmax(m), vdis(j,k,m) )
          end do
          end do
        end if
c
        do j = 2,ny-1
        do k = 1,nz
        do i = 2,nx-1
          vave(k,m) = vave(k,m) + ad*dat(i,k+1,j) + bd*dat(i,k,j)
        end do
        end do
        end do
      end do
c
      do m = 1,ne
      do k = 1,nz
        vave(k,m) = vave(k,m) * rsum
      end do
      end do
c
      do k = 1,nz
      do i = 1,nxy
        vdis(i,k,1) = vdis(i,k,1) -vave(k,1)
        vdis(i,k,2) = vdis(i,k,2) -vave(k,2)
c
        vdis(i,k,4) = vdis(i,k,4) -vave(k,4)
      end do
      end do
c
      wx   = 13.0
      wy   = wx*( dz*nz )/( dxy*nxy )
c
      ymv  = wy +1.5
      x0   =  4.0
      y0   = 19.0
c
      do m = 1,ne
c       if     ( f_name(m) .eq. 't___' ) then
c         vl   = int( vmax(m)*2.0 )/2.0
c         do i = 1,mv
c           val(i,m) = vl -0.5   *(i-1)
c         end do
c       elseif ( f_name(m) .eq. 'ql__' ) then
c         do i = 1,mv
c           val(i,m) =     0.5e-4* i
c         end do
c       else
          vl   = log10( vmax(m) )
          colm = 10.0**( int(vl)-1+int(vl-int(vl)+1) )
          del  = colm*int( vmax(m)/colm ) / dble(mvh)
          do i = 1,mv
            val(i,m) = del*(i-mvh-1)
          end do
c       end if
      end do
c
      facx = wx/( dxy*nxy )
      facy = wy/( dz *nz  )
c
      do i = 1,nxy
        xx(i) = dxy*( i-0.5 ) * facx
      end do
      do j = 1,nz
        zz(j) = dz *( j-0.5 ) * facy
      end do
c
cx    call winnam( 'Vertical' )
      call winfac( 2.0 )
      call plots ( 0.0, 0.0,  2 )
      call factor( 10.0 )
      call plot  (  x0,  y0, -3 )
      call newfnt( 4 )
c
      do m = 3,ne
        call newpen( 2 )
        call symbol( 0.6, wy+0.2, 0.45, f_name(m),         0.0, 2 )
        call number( 3.6, wy+0.2, 0.45, val(2,m)-val(1,m), 0.0, 3 )
        call number( 5.2, wy+0.2, 0.45, real(ihplt),       0.0,-1 )
        call number( 6.6, wy+0.2, 0.45, real(itplt),       0.0,-1 )
        call rect  ( 0.0, 0.0, wx, wy, 0.0, 0 )
c
        if ( f_name(m) .eq. 't___' ) then
          call newpen( 2 )
          call contln( vdis(1,1,m), mxy, nxy, nz, xx, zz,
     :                 val(1,m),     iro,        mv,  0.25, 2, 0 )
        else
          call newpen( 50 )
          call contln( vdis(1,1,m), mxy, nxy, nz, xx, zz,
     :                 val(1,m),     iro,        mvh, 0.25, 2, 0 )
          call newpen( 0 )
          call contln( vdis(1,1,m), mxy, nxy, nz, xx, zz,
     :                 val(mvh+2,m), iro(mvh+2), mvh, 0.25, 2, 0 )
          call newpen( 2 )
          call contln( vdis(1,1,m), mxy, nxy, nz, xx, zz,
     :                 0.0, -1, 1, 0.25, -1, 0 )
        end if
c
        call vector( 10.2, wy+0.3, 1.0, 0.0, 0.5, 0 )
        call symbol( 11.0, wy+0.2, 0.45, '1 m/s', 0.0, 5 )
c
                            k = 2
        if ( iyplt .ne. 0 ) k = 1
c
        do j = 1,nz, 2
        do i = 1,nxy,2
          call vector( xx(i),zz(j), vdis(i,j,k),vdis(i,j,3), 0.1,1 )
        end do
        end do
c
        call plot ( 0.0, -ymv, -3 )
      end do
c
      call cls  ( 1 )
      call plote
c
      stop
      end
