/***********************************************************
 *  A package of 'Calcomp' plotter subroutine (Ver.2)      *
 *                                                         *
 *    Include file.                                        *
 *                                                         *
 *                        Oct/1995.  coded by M.Nakanishi  *
 ***********************************************************/

#define  IBM   0
#define  SJIS  0

#define  PMAX  8000   /* Maximum length of the points */
#define  CMAX  64     /* Maximum length of the string */
#define  WMAX  861    /* Maximum length of the window width & height */
#define  BMAX  10     /* Maximum number of the Push-button */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define  PLOTS   0
#define  PLOTE   1
#define  PLOT    2
#define  SYMBOL  3
#define  NUMBER  4
#define  NKANJI  5
#define  RECT    6
#define  POLYGN  7
#define  CIRCLE  8
#define  CIRCLS  9
#define  CLS     10
#define  NEWPEN  11
#define  NEWFNT  12
#define  COLOR   13
#define  COLOR2  14
#define  FACTOR  15
#define  GET     16
#define  PUT     17
#define  NOMASK  18
#define  CHILDS  19
#define  CHILDE  20
#define  RECTPT  21
#define  COLSR   22
#define  RCLIP   23

/* Macro function for the pen position */
#define  XPOS(x,f,x0)  (x0+(int)((x)*(f)+(x>0.0?(0.5):(-0.5)))+0.5)
#define  YPOS(y,f,y0)  (y0-(int)((y)*(f)+(y>0.0?(0.5):(-0.5)))+0.5)

#define  MAX(x,y)      (x>y?x:y)
#define  MIN(x,y)      (x<y?x:y)
#define  ABS(x)        (x<0?-(x):(x))
#define  NINT(x)       (x+(x>0.0?(0.5):(-0.5)))

#define  DTR   0.017453292   /* pi/180 */

char  routine;

#if  META_IO
    FILE  *meta_fp;
    int   fpcon = 1;   /* 0: read, others: write */
    char  meta_name[CMAX+1] = "META.dat";
#else
    extern FILE  *meta_fp;
    extern int   fpcon;
    extern char  meta_name[];
#endif

#if  CALCOMP || LIPS || PS
    unsigned int   mnwx, mnwy;     /* Window width & height */
    unsigned int   mnpw, mnph;     /* Pixmap width & height */
    unsigned long  mnfrc, mnbkc;   /* Foreground & Background color */
    float  mnx0, mny0;             /* Graphic origin from window origin */
    int    mnxs, mnys;             /* Position of the pen */
    float  mnfac, mnwfac = 1.0;    /* Graphic & Window factor */
    int    mnlw;                   /* Line width */
    int    mndiv = 8;              /* Number of partition for the gray-scale */
    float  mnx0bak, mny0bak;
    float  mnfacbak, mnwfacbak;

                          /* B4H  A4H  B5H   *   B5V  A4V  B4V */
    static int  xsize[] = {  354, 287, 247, 200, 172, 200, 247  };
    static int  ysize[] = {  247, 200, 172, 287, 247, 287, 354  };
#else
    extern unsigned int   mnwx, mnwy;
    extern unsigned int   mnpw, mnph;
    extern unsigned long  mnfrc, mnbkc;
    extern float  mnx0, mny0;
    extern int    mnxs, mnys;
    extern float  mnfac, mnwfac;
    extern int    mnlw;
    extern int    mndiv;
#endif

#if    CALCOMP
    char  mnname[CMAX+1] = "Calcomp";    /* Default window name */
#elif  LIPS
    char  mnname[CMAX+1] = "LIPS.dat";   /* Default LIPS_file name */
#elif  PS
    char  mnname[CMAX+1] = "PS.dat";     /* Default PS_file name */
#else
    extern char  mnname[];
#endif

#if  !IBM
#define  plots   plots_
#define  plote   plote_
#define  plot    plot_
#define  symbol  symbol_
#define  number  number_
#define  nkanji  nkanji_
#define  rect    rect_
#define  polygn  polygn_
#define  circle  circle_
#define  circls  circls_
#define  cls     cls_
#define  newpen  newpen_
#define  newfnt  newfnt_
#define  color   color_
#define  color2  color2_
#define  factor  factor_
#define  get     get_
#define  put     put_
#define  nomask  nomask_
#define  childs  childs_
#define  childe  childe_
#define  rectpt  rectpt_
#define  conper  conper_
#define  contpt  contpt_
#define  colsr   colsr_
#define  rclip   rclip_
#define  metnam  metnam_
#define  winnam  winnam_
#define  winfac  winfac_
#define  where   where_
#define  locate  locate_
#define  pbattr  pbattr_
#define  pbtn    pbtn_
#define  ibtn    ibtn_
#define  xwdout  xwdout_
#define  xwdin   xwdin_
#define  jpnmap  jpnmap_
#define  conzs2  conzs2_
#define  mnstrlen  mnstrlen_
#define  triang  triang_
#define  cross   cross_
#endif
