/***********************************************************
 *  A package of 'Calcomp' plotter subroutine (Ver.2)      *
 *                                                         *
 *    Function file.                                       *
 *                                                         *
 *                        Oct/1995.  coded by M.Nakanishi  *
 ***********************************************************/

#if  SJIS   /* Convert SJIS to JIS */
    void  sj2jis( str )
	unsigned char  *str;
    {
	unsigned char  *c1, *c2;
	int  n, adjust;
	int  rowOffset, cellOffset;
        register int  i;

	n  = strlen( (char *)str );

	for ( i = 0 ; i < n ; i += 2 )
	{
	    c1 = str; str++;
	    c2 = str; str++;

	    adjust = *c2 < 159;
	    rowOffset  = *c1 < 160 ? 112 : 176;
	    cellOffset = adjust ? (*c2 > 127 ? 32 : 31) : 126;

	    *c1  = ((*c1-rowOffset) << 1) -adjust;
	    *c2 -= cellOffset;
	}
    }
#else       /* Convert EUC  to JIS */
    void  euc2jis( str )
	unsigned char  *str;
    {
	while( *str != '\0' ) { *str -= 128; str++; }
    }
#endif

int  mnstrlen( str, len )  /* Request the string length */
    char  str[];
    int   len;
{
    register int  i, m = 0;

    for ( i = 0 ; i < len ; i++ ) {
	if ( str[i] == ' ' ) continue;
	m = i;
    }

    return( m+1 );
}

void  winnam( nam, len )   /* Specify the window or the LIPS_file name */
    char  *nam;
    int   len;
{
    if ( len > CMAX ) len = CMAX;
    strncpy( mnname, nam, len ); mnname[len] = '\0';
}

void  winfac( f )          /* Change factor for the window */
    float  *f;
{
    mnwfac = *f;
}

void  factor( f )          /* Change factor for the graphic */
    float  *f;
{
    if ( fpcon%10 ) io_factor( f );

    mnfac = (*f)*mnwfac;
}

void  where( x, y, f )     /* Request position of the pen & factor */
    float  *x, *y, *f;
{
    *x = ( mnxs-(int)(mnx0+0.5) )/mnfac;
    *y = ( (int)(mny0+0.5)-mnys )/mnfac;
    *f =  mnfac/mnwfac;
}

static char  mnmask = 0;

void  nomask( m )          /* Masking-flag for background of the number */
    int  *m;
{
    if ( fpcon%10 ) io_nomask( m );

    mnmask = *m;
}

void  number( x, y, h, no, th, m )  /* Draw number */
    float  *x, *y, *h, *th, *no;
    int    *m;
{
    char   ch[CMAX+1], format[6] = "%d";
    float  nb;
    int    n;
    void   symbol();

    if ( *m < 0 ) {
	nb = (*no)*pow( 10.0, (double)((*m)%100+1) );
	nb = nb +(nb > 0.0 ? 0.5 : -0.5);

	sprintf( ch, format, (int)nb );
    }
    else {
	sprintf( &format[1], ".%df", (*m)%100 );
	sprintf( ch, format, *no );
    }

    n  = strlen( ch ) +100*(ABS(*m)/100);

    symbol( x, y, h, ch, th, &n );
}

static int    mnper = 0;
static float  cosa, sina, cosz, sinz, dis, eye_z = 0.0;

void  coneye( ip, az, ev, d )
    int    *ip;
    float  *az, *ev, *d;
{
    mnper = *ip; if ( !mnper ) return;

    cosa = cos( (double)(*az)*DTR );
    sina = sin( (double)(*az)*DTR );
    cosz = cos( (double)(*ev)*DTR );
    sinz = sin( (double)(*ev)*DTR );
    dis  = *d;
}

void  conzmv( z )
    float  *z;
{
    eye_z = *z;
}

void  con_trans( x, y, z, g, e )
    float  x, y, z, *g, *e;
{
    float  a, b;

    a  = y*sina +x*cosa;
    b  = dis/( dis-z*sinz-a*cosz );
    *g = b*( y*cosa-x*sina );
    *e = b*( z*cosz-a*sinz );
}

static int    mnzst = 0;
static float  mnzg[101], mnztop;

void  contpt( alt, mx, nx, ny, x, y, h, c, n, zn )   /* Painting */
    float  *alt, x[], y[], h[], *zn;
    int    *mx, *nx, *ny, c[], *n;
{
    int    sg, kr, kn = (*zn == 0.0 ? 1 : 2);
    int    r, g, b, l, m, kp[9];
    float  grd, tzn, amax, amin, hlw, hup, dd;
    float  xp[9], yp[9];
    static   int    ip[4] = { 1,1,0,0 }, jp[4] = { 0,1,1,0 };
    register int    in, jn, io, jo, p, i, j, k;
    register float  *alt_n, *alt_o, *alt_p;
    void   color2(), polygn(), colsr();

    tzn = tan( (double)(*zn+90.0)*DTR );

    m = 1; colsr( &m );

    for ( kr = 0 ; kr < kn ; kr++ ) {
	sg = 1 -2*kr; if ( *zn > 0.0 ) sg = -sg;

	for ( k = 0 ; k < *n ; k++ ) {
	    if ( c[k] < 0 ) {
		m = c[k]; if ( kr > 0 ) m--;
	    }
	    else {
		m =  -c[k]/1000000L; if ( m == 0 ) m = -mndiv;

		r = ( c[k]%1000000L )/10000L *256.0/99.0 +0.5;
		g = ( c[k]%10000L   )/100L   *256.0/99.0 +0.5;
		b =   c[k]%100L              *256.0/99.0 +0.5;
		if ( kr > 0 ) {
		    r *= 0.66; g *= 0.66; b *= 0.66;
		}
		color2( &r, &g, &b );
	    }

	    hlw = h[k];
	    if ( k < *n-1 ) hup = h[k+1];
	    else            hup = 1.0e10;

	    for ( j = 0 ; j < *ny-1 ; j++ ) {
	      alt_p = alt + j*(*mx);

	      for ( i = 0 ; i < *nx-1 ; i++,alt_p++ ) {
		grd = ( *(alt_p+1) - *alt_p )/( x[i+1]-x[i] );
		if ( sg*grd > sg*tzn ) continue;

		amax = MAX( *alt_p, *(alt_p+1)       );
		amax = MAX( amax,   *(alt_p+(*mx))   );
		amax = MAX( amax,   *(alt_p+(*mx)+1) );
		amin = MIN( *alt_p, *(alt_p+1)       );
		amin = MIN( amin,   *(alt_p+(*mx))   );
		amin = MIN( amin,   *(alt_p+(*mx)+1) );
		if ( amax < hlw || amin >= hup ) continue;

		l  = 0;
		io = i;
		jo = j;
		alt_o = alt_p;
/*
		if ( *alt_p >= hlw ) {
		    kp[l] = i;
		    xp[l] = x[i];
		    yp[l] = y[j]; l++;
		}
 */
		for ( p = 0 ; p < 4 ; p++ ) {
		  in = i +ip[p];
		  jn = j +jp[p];
		  alt_n = alt + jn*(*mx) + in;

		  if      ( *alt_o >= hlw ) {
		    if ( *alt_n >= hlw ) {
			kp[l] = in;
			xp[l] = x[in];
			yp[l] = y[jn]; l++;
		    }
		    else {
			dd = ( hlw-(*alt_o) )/( (*alt_n)-(*alt_o) );
			kp[l] = MIN( in, io );
			xp[l] = x[io] +dd*( x[in]-x[io] );
			yp[l] = y[jo] +dd*( y[jn]-y[jo] ); l++;
		    }
		  }
		  else if ( *alt_n >= hlw ) {
			dd = ( hlw-(*alt_o) )/( (*alt_n)-(*alt_o) );
			kp[l] = MIN( in, io );
			xp[l] = x[io] +dd*( x[in]-x[io] );
			yp[l] = y[jo] +dd*( y[jn]-y[jo] ); l++;
			kp[l] = in;
			xp[l] = x[in];
			yp[l] = y[jn]; l++;
		  }

		  io = in;
		  jo = jn;
		  alt_o = alt_n;
		}

		if ( mnzst )
		  for ( p = 0 ; p < l ; p++ ) {
		    in  = MIN( kp[p], *nx-2 );
		    dd  = ( xp[p]-x[in] )/( x[in+1]-x[in] );
		    grd = mnzg[in+1]*dd +mnzg[in]*( 1.0-dd );
		    yp[p] = yp[p]*( mnztop-grd )/mnztop +grd;
		  }

		if      ( mnper > 0 )
		  for ( p = 0 ; p < l ; p++ )
		    con_trans( xp[p], yp[p], eye_z, &xp[p], &yp[p] );
		else if ( mnper < 0 )
		  for ( p = 0 ; p < l ; p++ )
		    con_trans( xp[p], eye_z, yp[p], &xp[p], &yp[p] );

		polygn( xp, yp, &l, &m );
	      }
	    }
	}
    }

    m = 0; colsr( &m );
}

void  conzs2( izst, zg, n, ztop )
    int    *izst, *n;
    float  *zg, *ztop;
{
    register int  i;

    mnzst  = *izst;
    mnztop = *ztop;
    for ( i = 0 ; i < *n ; i++ ) mnzg[i] = zg[i];
}

/*  The variable t is a half length of a side of the triangle  */

void  triang( x, y, t, m )
    float  *x, *y, *t;
    int    *m;
{
    float  xp[4], yp[4];
    int    l = 4;
    void   polygn();

    xp[0] = (*x) -(*t); yp[0] = (*y) -(*t)/1.732051;
    xp[1] = (*x) +(*t); yp[1] = yp[0];
    xp[2] = (*x);       yp[2] = (*y) +(*t)/0.866025;
    xp[3] = xp[0];      yp[3] = yp[0];

    polygn( xp, yp, &l, m );
}

void  cross( x, y, c )
    float  *x, *y, *c;
{
    float  xy;
    int    m2 = 2, m3 =3;
    void   plot();

    xy = (*x) -(*c); plot( &xy, y, &m3 );
    xy = (*x) +(*c); plot( &xy, y, &m2 );
    xy = (*y) +(*c); plot( x, &xy, &m3 );
    xy = (*y) -(*c); plot( x, &xy, &m2 );
}
