/***********************************************************
 *  A package of 'Calcomp' plotter subroutine (Ver.2)      *
 *                                                         *
 *    Plot function file.                                  *
 *                                                         *
 *                        Oct/1995.  coded by M.Nakanishi  *
 ***********************************************************/

static int  page = 1;

int  calplot( prn )
    int  prn;
{
    float  x[PMAX], y[PMAX], w, h, f, as, ae;
    char   ch[CMAX*2];
    int    l, m, n = 0, m3 = -3;
    float  *alt, *z;
    int    *c, k;

    if ( prn <    1 ) return( 0 );

    if ( prn < page )
    {
	page = 1;
	fclose( meta_fp );
	io_plots( x, y, &m, &f );   /* ǂ݂Ƃ΂ */

	newpen( &n );               /* Zbg */
	color ( &n );
    }

    while( fread( &routine, sizeof(char), 1, meta_fp ) )
    {
	if ( routine == CLS )
	{
	    page++;
	    if ( page > prn ) { cls( &m3 ); return( 0 ); }
	    else                continue;
	}

	switch( routine )
	{
	    case  PLOTE:
		return( 999 );

	    case  PLOT:
		io_plot( x, y, &m );
		n  = ABS(m);
		if ( page == prn ) plot( x, y, &n  );
		if ( m    <  0   ) plot( x, y, &m3 );
		break;

	    case  SYMBOL:
		io_symbol( x, y, &h, ch, &f, &n );
		if ( page == prn ) symbol( x, y, &h, ch, &f, &n );
		break;

	    case  NKANJI:
		io_nkanji( x, y, &h, ch, &f, &n );
		if ( page == prn ) nkanji( x, y, &h, ch, &f, &n );
		break;

	    case  RECT:
		io_rect( x, y, &w, &h, &f, &m );
		if ( page == prn ) rect( x, y, &w, &h, &f, &m );
		break;

	    case  POLYGN:
		io_polygn( x, y, &n, &m );
		if ( page == prn ) polygn( x, y, &n, &m );
		break;

	    case  CIRCLE:
		io_circle( x, y, &w, &h, &as, &ae, &m );
		if ( page == prn ) circle( x, y, &w, &h, &as, &ae, &m );
		break;

	    case  CIRCLS:
		io_circls( x, y, &n, &w, &h, &as, &ae, &m );
		if ( page == prn ) circls( x, y, &n, &w, &h, &as, &ae, &m );
		break;

	    case  NEWPEN:
		io_newpen( &m );
		newpen( &m );
		break;

	    case  NEWFNT:
		io_newfnt( &m );
		newfnt( &m );
		break;

	    case  COLOR:
		io_color( &m );
		color( &m );
		break;

	    case  COLOR2:
		io_color2( &l, &m, &n );
		color2( &l, &m, &n );
		break;

	    case  FACTOR:
		io_factor( &f );
		factor( &f );
		break;

	    case  GET:
		io_get( x, y, &w, &h );
		if ( page == prn ) get( x, y, &w, &h );
		break;

	    case  PUT:
		io_put( x, y );
		if ( page == prn ) put( x, y );
		break;

	    case  NOMASK:
		io_nomask( &m );
		nomask( &m );
		break;

	    case  CHILDS:
		io_childs( x, y, &w, &h );
		if ( page == prn ) childs( x, y, &w, &h );
		break;

	    case  CHILDE:
		if ( page == prn ) childe();
		break;

	    case  RECTPT:
		alt = malloc( 800*800 * sizeof(float) );
		z   = malloc( 256     * sizeof(float) );
		c   = malloc( 256     * sizeof(int) );
		io_rectpt( alt, &l, &m, &n, x, y, z, c, &k, &f );
		if ( page == prn ) rectpt( alt, &l,&m,&n, x,y, z,c, &k, &f );
		free( alt );
		free( z );
		free( c );
		break;

	    case  COLSR:
		io_colsr( &m );
		colsr( &m );
		break;

	    case  RCLIP:
		io_rclip( &m, x, y, &w, &h );
		rclip( &m, x, y, &w, &h );
		break;

	    default:
		printf( "Error : Unknown parameter is in META-file.\n" );
		exit( 1 );
	}
    }

    return( 999 );
}
