/***********************************************************
 *  A package of 'Calcomp' plotter subroutine (Ver.2)      *
 *                                                         *
 *    Input & Output of META-file.                         *
 *                                                         *
 *                        Oct/1995.  coded by M.Nakanishi  *
 ***********************************************************/

#define  META_IO  1

#include "calcomp.h"

void  metnam( nam, len )
    char  *nam;
    int   len;
{
    if ( len > CMAX ) len = CMAX;
    strncpy( meta_name, nam, len ); meta_name[len] = '\0';
}

void  io_plots( x, y, m, winfac )
    float  *x, *y, *winfac;
    int    *m;
{
    if ( fpcon )
    {
	routine = PLOTS;

	meta_fp = fopen( meta_name, "w" );

	fwrite( &routine, sizeof(char),  1, meta_fp );
	fwrite( winfac,   sizeof(float), 1, meta_fp );
	fwrite( x, sizeof(float), 1, meta_fp );
	fwrite( y, sizeof(float), 1, meta_fp );
	fwrite( m, sizeof(int),   1, meta_fp );
    }
    else
    {
	if ( !(meta_fp = fopen( meta_name, "r" )) )
	{
	    printf( "Error : File(%s) does not exist.\n", meta_name );
	    exit( 1 );
	}

	fread ( &routine, sizeof(char),  1, meta_fp );

	if ( routine != PLOTS )
	{
	    printf( "Error : Invalid parameter is in META-file.\n" );
	    exit( 1 );
	}

	fread ( winfac,   sizeof(float), 1, meta_fp );
	fread ( x, sizeof(float), 1, meta_fp );
	fread ( y, sizeof(float), 1, meta_fp );
	fread ( m, sizeof(int),   1, meta_fp );
    }
}

void  io_plote()
{
    if ( fpcon )
    {
	routine = PLOTE;

	fwrite( &routine, sizeof(char), 1, meta_fp );
    }

    fclose( meta_fp );
}

void  io_plot( x, y, m )
    float  *x, *y;
    int    *m;
{
    if ( fpcon )
    {
	routine = PLOT;

	fwrite( &routine, sizeof(char), 1, meta_fp );
	fwrite( x, sizeof(float), 1, meta_fp );
	fwrite( y, sizeof(float), 1, meta_fp );
	fwrite( m, sizeof(int),   1, meta_fp );
    }
    else
    {
	fread ( x, sizeof(float), 1, meta_fp );
	fread ( y, sizeof(float), 1, meta_fp );
	fread ( m, sizeof(int),   1, meta_fp );
    }
}

void  io_factor( f )
    float  *f;
{
    if ( fpcon )
    {
	routine = FACTOR;

	fwrite( &routine, sizeof(char), 1, meta_fp );
	fwrite( f, sizeof(float), 1, meta_fp );
    }
    else
	fread ( f, sizeof(float), 1, meta_fp );
}

void  io_color( m )
    int  *m;
{
    if ( fpcon )
    {
	routine = COLOR;

	fwrite( &routine, sizeof(char), 1, meta_fp );
	fwrite( m, sizeof(int), 1, meta_fp );
    }
    else
	fread ( m, sizeof(int), 1, meta_fp );
}

void  io_color2( cr, cg, cb )
    int  *cr, *cg, *cb;
{
    if ( fpcon )
    {
	routine = COLOR2;

	fwrite( &routine, sizeof(char), 1, meta_fp );
	fwrite( cr, sizeof(int), 1, meta_fp );
	fwrite( cg, sizeof(int), 1, meta_fp );
	fwrite( cb, sizeof(int), 1, meta_fp );
    }
    else
    {
	fread ( cr, sizeof(int), 1, meta_fp );
	fread ( cg, sizeof(int), 1, meta_fp );
	fread ( cb, sizeof(int), 1, meta_fp );
    }
}

void  io_newpen( m )
    int  *m;
{
    if ( fpcon )
    {
	routine = NEWPEN;

	fwrite( &routine, sizeof(char), 1, meta_fp );
	fwrite( m, sizeof(int), 1, meta_fp );
    }
    else
	fread ( m, sizeof(int), 1, meta_fp );
}

void  io_newfnt( m )
    int  *m;
{
    if ( fpcon )
    {
	routine = NEWFNT;

	fwrite( &routine, sizeof(char), 1, meta_fp );
	fwrite( m, sizeof(int), 1, meta_fp );
    }
    else
	fread ( m, sizeof(int), 1, meta_fp );
}

void  io_cls( m )
    int  *m;
{
    if ( fpcon )
    {
 	routine = CLS;

	fwrite( &routine, sizeof(char), 1, meta_fp );
    }
}

void  io_get( xs, ys, xe, ye )
    float  *xs, *ys, *xe, *ye;
{
    if ( fpcon )
    {
	routine = GET;

	fwrite( &routine, sizeof(char), 1, meta_fp );
	fwrite( xs, sizeof(float), 1, meta_fp );
	fwrite( ys, sizeof(float), 1, meta_fp );
	fwrite( xe, sizeof(float), 1, meta_fp );
	fwrite( ye, sizeof(float), 1, meta_fp );
    }
    else
    {
	fread ( xs, sizeof(float), 1, meta_fp );
	fread ( ys, sizeof(float), 1, meta_fp );
	fread ( xe, sizeof(float), 1, meta_fp );
	fread ( ye, sizeof(float), 1, meta_fp );
    }
}

void  io_put( x, y )
    float  *x, *y;
{
    if ( fpcon )
    {
	routine = PUT;

	fwrite( &routine, sizeof(char), 1, meta_fp );
	fwrite( x, sizeof(float), 1, meta_fp );
	fwrite( y, sizeof(float), 1, meta_fp );
    }
    else
    {
	fread ( x, sizeof(float), 1, meta_fp );
	fread ( y, sizeof(float), 1, meta_fp );
    }
}

void  io_symbol( x, y, h, ch, th, n )
    float  *x, *y, *h, *th;
    char   ch[];
    int    *n;
{
    int    nn;

    if ( fpcon )
    {
	routine = SYMBOL;

	nn = MAX( (*n)%100, 1 );

	fwrite( &routine, sizeof(char), 1, meta_fp );
	fwrite( x,  sizeof(float), 1, meta_fp );
	fwrite( y,  sizeof(float), 1, meta_fp );
	fwrite( h,  sizeof(float), 1, meta_fp );
	fwrite( th, sizeof(float), 1, meta_fp );
	fwrite( n,  sizeof(int),   1, meta_fp );
	fwrite( ch, sizeof(char), nn, meta_fp );
    }
    else
    {
	fread ( x,  sizeof(float), 1, meta_fp );
	fread ( y,  sizeof(float), 1, meta_fp );
	fread ( h,  sizeof(float), 1, meta_fp );
	fread ( th, sizeof(float), 1, meta_fp );
	fread ( n,  sizeof(int),   1, meta_fp );

	nn = MAX( (*n)%100, 1 );

	fread ( ch, sizeof(char), nn, meta_fp );
    }
}

void  io_nkanji( x, y, h, ch, th, n )
    float  *x, *y, *h, *th;
    char   ch[];
    int    *n;
{
    int    nn;

    if ( fpcon )
    {
	routine = NKANJI;

	nn = 2*(ABS(*n)%100);

	fwrite( &routine, sizeof(char), 1, meta_fp );
	fwrite( x,  sizeof(float), 1, meta_fp );
	fwrite( y,  sizeof(float), 1, meta_fp );
	fwrite( h,  sizeof(float), 1, meta_fp );
	fwrite( th, sizeof(float), 1, meta_fp );
	fwrite( n,  sizeof(int),   1, meta_fp );
	fwrite( ch, sizeof(char), nn, meta_fp );
    }
    else
    {
	fread ( x,  sizeof(float), 1, meta_fp );
	fread ( y,  sizeof(float), 1, meta_fp );
	fread ( h,  sizeof(float), 1, meta_fp );
	fread ( th, sizeof(float), 1, meta_fp );
	fread ( n,  sizeof(int),   1, meta_fp );

	nn = 2*(ABS(*n)%100);

	fread ( ch, sizeof(char), nn, meta_fp );
    }
}

void  io_polygn( x, y, n, m )
    float  x[], y[];
    int    *n, *m;
{
    if ( fpcon )
    {
	routine = POLYGN;

	fwrite( &routine, sizeof(char), 1, meta_fp );
	fwrite( n, sizeof(int),    1, meta_fp );
	fwrite( m, sizeof(int),    1, meta_fp );
	fwrite( x, sizeof(float), *n, meta_fp );
	fwrite( y, sizeof(float), *n, meta_fp );
    }
    else
    {
	fread ( n, sizeof(int),    1, meta_fp );
	fread ( m, sizeof(int),    1, meta_fp );
	fread ( x, sizeof(float), *n, meta_fp );
	fread ( y, sizeof(float), *n, meta_fp );
    }
}

void  io_circle( x, y, rx, ry, as, ae, m )
    float  *x, *y, *rx, *ry, *as, *ae;
    int    *m;
{
    if ( fpcon )
    {
	routine = CIRCLE;

	fwrite( &routine, sizeof(char), 1, meta_fp );
	fwrite( x,  sizeof(float), 1, meta_fp );
	fwrite( y,  sizeof(float), 1, meta_fp );
	fwrite( rx, sizeof(float), 1, meta_fp );
	fwrite( ry, sizeof(float), 1, meta_fp );
	fwrite( as, sizeof(float), 1, meta_fp );
	fwrite( ae, sizeof(float), 1, meta_fp );
	fwrite( m,  sizeof(int),   1, meta_fp );
    }
    else
    {
	fread ( x,  sizeof(float), 1, meta_fp );
	fread ( y,  sizeof(float), 1, meta_fp );
	fread ( rx, sizeof(float), 1, meta_fp );
	fread ( ry, sizeof(float), 1, meta_fp );
	fread ( as, sizeof(float), 1, meta_fp );
	fread ( ae, sizeof(float), 1, meta_fp );
	fread ( m,  sizeof(int),   1, meta_fp );
    }
}

void  io_circls( x, y, n, rx, ry, as, ae, m )
    float  x[], y[], *rx, *ry, *as, *ae;
    int    *n, *m;
{
    if ( fpcon )
    {
	routine = CIRCLS;

	fwrite( &routine, sizeof(char), 1, meta_fp );
	fwrite( n,  sizeof(int),    1, meta_fp );
	fwrite( x,  sizeof(float), *n, meta_fp );
	fwrite( y,  sizeof(float), *n, meta_fp );
	fwrite( rx, sizeof(float),  1, meta_fp );
	fwrite( ry, sizeof(float),  1, meta_fp );
	fwrite( as, sizeof(float),  1, meta_fp );
	fwrite( ae, sizeof(float),  1, meta_fp );
	fwrite( m,  sizeof(int),    1, meta_fp );
    }
    else
    {
	fread ( n,  sizeof(int),    1, meta_fp );
	fread ( x,  sizeof(float), *n, meta_fp );
	fread ( y,  sizeof(float), *n, meta_fp );
	fread ( rx, sizeof(float),  1, meta_fp );
	fread ( ry, sizeof(float),  1, meta_fp );
	fread ( as, sizeof(float),  1, meta_fp );
	fread ( ae, sizeof(float),  1, meta_fp );
	fread ( m,  sizeof(int),    1, meta_fp );
    }
}

void  io_rect( x, y, w, h, r, m )
    float  *x, *y, *w, *h, *r;
    int    *m;
{
    if ( fpcon )
    {
	routine = RECT;

	fwrite( &routine, sizeof(char), 1, meta_fp );
	fwrite( x, sizeof(float), 1, meta_fp );
	fwrite( y, sizeof(float), 1, meta_fp );
	fwrite( w, sizeof(float), 1, meta_fp );
	fwrite( h, sizeof(float), 1, meta_fp );
	fwrite( r, sizeof(float), 1, meta_fp );
	fwrite( m, sizeof(int),   1, meta_fp );
    }
    else
    {
	fread ( x, sizeof(float), 1, meta_fp );
	fread ( y, sizeof(float), 1, meta_fp );
	fread ( w, sizeof(float), 1, meta_fp );
	fread ( h, sizeof(float), 1, meta_fp );
	fread ( r, sizeof(float), 1, meta_fp );
	fread ( m, sizeof(int),   1, meta_fp );
    }
}

void  io_nomask( m )
    int  *m;
{
    if ( fpcon )
    {
	routine = NOMASK;

	fwrite( &routine, sizeof(char), 1, meta_fp );
	fwrite( m, sizeof(int), 1, meta_fp );
    }
    else
	fread ( m, sizeof(int), 1, meta_fp );
}

void  io_childs( x, y, w, h )
    float  *x, *y, *w, *h;
{
    if ( fpcon )
    {
	routine = CHILDS;

	fwrite( &routine, sizeof(char), 1, meta_fp );
	fwrite( x, sizeof(float), 1, meta_fp );
	fwrite( y, sizeof(float), 1, meta_fp );
	fwrite( w, sizeof(float), 1, meta_fp );
	fwrite( h, sizeof(float), 1, meta_fp );
    }
    else
    {
	fread ( x, sizeof(float), 1, meta_fp );
	fread ( y, sizeof(float), 1, meta_fp );
	fread ( w, sizeof(float), 1, meta_fp );
	fread ( h, sizeof(float), 1, meta_fp );
    }
}

void  io_childe()
{
    if ( fpcon )
    {
	routine = CHILDE;

	fwrite( &routine, sizeof(char), 1, meta_fp );
    }
}

void  io_rectpt( alt, mx, nx, ny, x, y, h, c, n, zn )
    float  *alt, x[], y[], h[], *zn;
    int    *mx, *nx, *ny, c[], *n;
{
    if ( fpcon )
    {
	routine = RECTPT;

	fwrite( &routine, sizeof(char), 1, meta_fp );
	fwrite( mx,  sizeof(int),            1 , meta_fp );
	fwrite( nx,  sizeof(int),            1 , meta_fp );
	fwrite( ny,  sizeof(int),            1 , meta_fp );
	fwrite( n,   sizeof(int),            1 , meta_fp );
	fwrite( alt, sizeof(float), (*mx)*(*ny), meta_fp );
	fwrite( x,   sizeof(float),        *nx , meta_fp );
	fwrite( y,   sizeof(float),        *ny , meta_fp );
	fwrite( h,   sizeof(float),         *n , meta_fp );
	fwrite( c,   sizeof(int),           *n , meta_fp );
	fwrite( zn,  sizeof(float),          1 , meta_fp );
    }
    else
    {
	fread ( mx,  sizeof(int),            1 , meta_fp );
	fread ( nx,  sizeof(int),            1 , meta_fp );
	fread ( ny,  sizeof(int),            1 , meta_fp );
	fread ( n,   sizeof(int),            1 , meta_fp );
	fread ( alt, sizeof(float), (*mx)*(*ny), meta_fp );
	fread ( x,   sizeof(float),        *nx , meta_fp );
	fread ( y,   sizeof(float),        *ny , meta_fp );
	fread ( h,   sizeof(float),         *n , meta_fp );
	fread ( c,   sizeof(int),           *n , meta_fp );
	fread ( zn,  sizeof(float),          1 , meta_fp );
    }
}

void  io_colsr( m )
    int  *m;
{
    if ( fpcon )
    {
	routine = COLSR;

	fwrite( &routine, sizeof(char), 1, meta_fp );
	fwrite( m, sizeof(int), 1, meta_fp );
    }
    else
	fread ( m, sizeof(int), 1, meta_fp );
}

void  io_rclip( m, x, y, w, h )
    float  *x, *y, *w, *h;
    int    *m;
{
    if ( fpcon )
    {
	routine = RCLIP;

	fwrite( &routine, sizeof(char), 1, meta_fp );
	fwrite( m, sizeof(int),   1, meta_fp );
	fwrite( x, sizeof(float), 1, meta_fp );
	fwrite( y, sizeof(float), 1, meta_fp );
	fwrite( w, sizeof(float), 1, meta_fp );
	fwrite( h, sizeof(float), 1, meta_fp );
    }
    else
    {
	fread ( m, sizeof(int),   1, meta_fp );
	fread ( x, sizeof(float), 1, meta_fp );
	fread ( y, sizeof(float), 1, meta_fp );
	fread ( w, sizeof(float), 1, meta_fp );
	fread ( h, sizeof(float), 1, meta_fp );
    }
}
