/***********************************************************
 *  A package of 'Calcomp' plotter subroutine (Ver.2)      *
 *                                                         *
 *    Convert META_file to PS_file & Print out.            *
 *                                                         *
 *                        Oct/1995.  coded by M.Nakanishi  *
 ***********************************************************/

#include "calcomp.h"
#include "calplot.h"

static int    st_page = 1, ed_page = 999;
static float  fct = 0.0;
static int    xo = -999, yo = -999, pno = -999;
static char   *progname;

void  usage()
{
    printf( "usage: %s [-s <start page>] [-e <end page>] [-p <paper no.>]\n", progname );
    printf( "               [-f <factor>] [-x <x origin(mm)>] [-y <y origin(mm)>]\n" );
    printf( "               [-mf <meta_file(in)>] [-pf <ps_file(out)>]\n" );
    exit( 1 );
}

void  init_prn()
{
    float  x, y, f;
    int    m;

    fpcon = 0;   /* Read mode */

    io_plots( &x, &y, &m, &f ); if ( pno > -999 ) m = pno;
    plots( &x, &y, &m );

    if ( xo  > -999 )   mnx0 += mnfac*xo;
    if ( yo  > -999 )   mny0 += mnfac*yo;   /* For PS */
    if ( fct >  0.0 ) { mnfac = mnwfac *= fct; }
}

main( argc, argv )
    int    argc;
    char   *argv[];
{
    char   comstr[64];
    register int  i;

    progname = argv[0];

    for ( i = 1 ; i < argc ; i++ )
    {
	if ( strcmp(argv[i], "-s") == 0 )
	{
	    if ( ++i >= argc ) usage();
	    st_page = atoi( argv[i] );
	    continue;
	}
	if ( strcmp(argv[i], "-e") == 0 )
	{
	    if ( ++i >= argc ) usage();
	    ed_page = atoi( argv[i] ) +1;
	    continue;
	}
	if ( strcmp(argv[i], "-p") == 0 )
	{
	    if ( ++i >= argc ) usage();
	    pno = atoi( argv[i] );
	    continue;
	}
	if ( strcmp(argv[i], "-f") == 0 )
	{
	    if ( ++i >= argc ) usage();
	    fct = atof( argv[i] );
	    continue;
	}
	if ( strcmp(argv[i], "-x") == 0 )
	{
	    if ( ++i >= argc ) usage();
	    xo = atoi( argv[i] );
	    continue;
	}
	if ( strcmp(argv[i], "-y") == 0 )
	{
	    if ( ++i >= argc ) usage();
	    yo = atoi( argv[i] );
	    continue;
	}
	if ( strcmp(argv[i], "-mf") == 0 )
	{
	    if ( ++i >= argc ) usage();
	    strcpy( meta_name, argv[i] );
	    continue;
	}
	if ( strcmp(argv[i], "-pf") == 0 )
	{
	    if ( ++i >= argc ) usage();
	    strcpy( mnname, argv[i] );
	    continue;
	}
	usage();
    }

    init_prn();

    for ( i = st_page ; i < ed_page ; i++ ) if ( calplot(i) ) break;

    plote();

/*
#if  IBM
    sprintf( comstr, "qprt -dp -Pqms %s", mnname );
    system( comstr );
#endif
 */
}
