/***********************************************************
 *  A package of 'Calcomp' plotter subroutine (Ver.2)      *
 *                                                         *
 *    For QMS Printer (PostScript).                        *
 *                                                         *
 *                        Oct/1995.  coded by M.Nakanishi  *
 ***********************************************************/

#define  PS  1

#include "meta_io.c"
#include "calfunc.h"

#define  FCT  100    /* 0.01mm PʂƂt@N^[ */
#define  SPC  550    /* 󎚗̗̈]T (0.01mm) */

#define  RTN  '\n'
#define  PGN  "%%Page:"

/* Code number of the special sign */
static unsigned char  mnsign[] = { 0xA3, 0xA5, 0xA6, 0xB1, 0xB3,
				   0xB6, 0xB0, 0xD5, 0xE5, 0xF2 };

static char  ps_level[] = "%!PS-Adobe-2.0";   /* PS Version */

static char  *ps_def[] = {
	"/bd{bind def} bind def",
	"/em{3 1 roll sp mul sub def} bd",
	"/ep{3 1 roll sp mul add def} bd",
	"/ld{load def} bd",
	"/sf{findfont exch dup 15 div /sp exch def scalefont setfont} bd",
	"/A /arc ld",
	"/AC{arcto 4 {pop} repeat} bd",
	"/C /closepath ld",
	"/CP/currentpoint ld",
	"/CT{clip newpath translate 0 0 moveto} bd",
	"/E {/CM matrix currentmatrix def scale arc CM setmatrix} bd",
	"/F {gsave setrgbcolor fill grestore currentpoint newpath moveto} bd",
	"/FS/show ld",
	"/FO{gsave true charpath LS0 currentpoint stroke grestore moveto} bd",
	"/GS/gsave ld",
	"/GR/grestore ld",
	"/L /lineto ld",
	"/M /moveto ld",
	"/MR{2 div 0 rmoveto} bd",
	"/R {moveto lineto lineto lineto closepath} bd",
	"/S {currentpoint stroke moveto} bd",
	"/SC/setrgbcolor ld",
	"/SM{3 -1 roll stringwidth pop mul exch rmoveto} bd",
	"/Z {gsave setrgbcolor fill grestore currentpoint stroke moveto} bd",
	"/NM{gsave true charpath flattenpath pathbbox 1 /y2 ep 1 /x2 ep",
	" 1 /y1 em 1 /x1 em x2 y1 x2 y2 x1 y2 x1 y1 R SC fill grestore} bd",
	"/OB{gsave true charpath flattenpath pathbbox 2.1 /y2 ep 1 /x2 ep pop",
" 1 /x1 em newpath 1.1 sp mul setlinewidth x1 y2 M x2 y2 L stroke grestore} bd",
	"/FN1{/Courier sf} bd",
	"/FN2{/Times-Roman sf} bd",
	"/FN3{/Times-Bold sf} bd",
	"/FN4{/Helvetica-Bold sf} bd",
	"/FN5{/Symbol sf} bd",
	"/FN6{/Ryumin-Light-H sf} bd",       /*  */
	"/FN7{/Ryumin-Light-V sf} bd",       /* c */
	"/FN8{/GothicBBB-Medium-H sf} bd",   /* SVbN */
	"/FN9{/GothicBBB-Medium-V sf} bd",   /* SVbNc */

	"End"
	};

static FILE   *ps_fp, *fb;
static int    mnfntmx = 5;   /* Maximum length of 1-bite Font set */
static int    mnfntno = 1;
static char   mnfntpr[] = "FS";
static float  mnfr, mnfg, mnfb;
static float  mnbr, mnbg, mnbb;

static int    page_no = 1;

static int    hsbak, fsbak;

char  GOMI = 0, POUT = 1;

/* ---------------------------------------------------------
    QMS Printer open
      m(int)   : sheet size = 1(B5)
                              2(A4)
                              3(B4)
                 vertical when m > 0, horizontal when m < 0
 */
void  plots( x, y, m )
    float  *x, *y;
    int    *m;
{
    int    mm, i;
    int    wunit = (int)(0.08*FCT+0.5);   /* ̂PP */
    int    sunit = (int)(0.25*FCT+0.5);   /* ̂PP */

    fpcon = 0;   /* Read mode */

    mm    = MAX( (*m)%10+3, 0 ); if ( mm > 6 ) mm = 6;

    mnwx  = ( xsize[mm]+10 )*FCT -2*SPC;
    mnwy  = ( ysize[mm]+10 )*FCT -2*SPC;
    mnx0  = SPC;
    mny0  = SPC;   /* PS ̍Wn͒ʏ̍Wnł */
    mnfac = mnwfac = FCT;
    mnlw  = 1;

    mnfrc =   0;
    mnbkc = 999;
    mnfr  = mnfg = mnfb = 0.0;
    mnbr  = mnbg = mnbb = 1.0;

    ps_fp = fopen( mnname, "w+" );

    fprintf( ps_fp, "%s\n", ps_level );   /* PS ̊Jn */

    if ( *m < 0 )
	fprintf( ps_fp, "%%%%IncludeFeature:orientation(landscape)\n" );

    fprintf( ps_fp, "/FACT 72 25.4 div %d div def ", FCT );
    fprintf( ps_fp, "/sp 0.2 %d mul def\n",          FCT );

    for ( i = 0 ; i < 999 ; i++ ) {
	if ( strcmp(ps_def[i], "End") == 0 ) break;

	fprintf( ps_fp, "%s\n", ps_def[i] );
    }

    fprintf( ps_fp, "/LW1{%d setlinewidth} bd\n", wunit   );
    fprintf( ps_fp, "/LW2{%d setlinewidth} bd\n", wunit*3 );
    fprintf( ps_fp, "/LW3{%d setlinewidth} bd\n", wunit*5 );
    fprintf( ps_fp, "/LW4{%d setlinewidth} bd\n", wunit*7 );
    fprintf( ps_fp, "/LW5{%d setlinewidth} bd\n", wunit/2 );

    fprintf( ps_fp, "/LS0{[] 0 setdash} bd\n" );
    fprintf( ps_fp, "/LS1{[%d %d] 0 setdash} bd\n", sunit*5, sunit*3 );
    fprintf( ps_fp, "/LS2{[%d %d] 0 setdash} bd\n", sunit,   sunit*3 );
    fprintf( ps_fp, "/LS3{[%d %d %d %d] 0 setdash} bd\n",
             sunit*8, sunit*2, sunit*2, sunit*2 );
    fprintf( ps_fp, "/LS4{[%d %d %d %d %d %d] 0 setdash} bd\n",
             sunit*8, sunit*2, sunit, sunit*2, sunit, sunit*2 );
    fprintf( ps_fp, "/LS5{[%d %d] 0 setdash} bd\n",sunit*2 , sunit*4 );
    fprintf( ps_fp, "/LS6{[%d %d] 0 setdash} bd\n",sunit*10, sunit*3 );

    fprintf( ps_fp, "FACT FACT scale " );            /* t@N^[̐ݒ */
    fprintf( ps_fp, "3 setmiterlimit LW1 newpath 0 0 M\n" );   /*  */

    fprintf( ps_fp, "%s %d %d\n", PGN, page_no, page_no ); page_no++;
}

/* ---------------------------------------------------------
    QMS Printer close
 */
void  plote()
{
    if ( POUT ) fprintf( ps_fp, "showpage\n" );

    fclose( ps_fp );

    if ( GOMI ) system( "\\rm GOMIdesu" );
}

/* ---------------------------------------------------------
    line plotting & pen moving
      x(float) : end position of the pen (x-coordinate)
      y(float) : end position of the pen (y-coordinate)
      m(int)   : pen down when m = 2
 */
void  plot( x, y, m )
    float  *x, *y;
    int    *m;
{
    int    ixe, iye;

    ixe = XPOS( *x, mnfac, mnx0 );
    iye = XPOS( *y, mnfac, mny0 );   /* PS ̍Wn͒ʏ̍Wnł */

    if ( ABS(*m) == 2 )
	fprintf( ps_fp, "%d %d L S\n", ixe, iye );
    else
	fprintf( ps_fp, "%d %d M\n",   ixe, iye );

    if ( *m < 0 )
    {
	mnx0 = mnx0 +(*x)*mnfac;
	mny0 = mny0 +(*y)*mnfac;
    }
}

/* ---------------------------------------------------------
    change line_style & line_width
      m(int)   : m = style*10 + width
                 style = 0(solid line)
                         1(dashed line )
                         2(dotted line )
                         3(one dot-dashed line )
                         4(two dot-dashed line )
                 width = 1 to 4
 */
void  newpen( m )
    int  *m;
{
    int  mm;

    mm = ABS(*m);

    mnlw = MIN( mm%10, 5 ); if ( mnlw < 1 ) mnlw = 1;
    mm   = MIN( mm/10, 6 );

    fprintf( ps_fp, "LW%d LS%d\n", mnlw, mm );
}

/* ---------------------------------------------------------
    print out
 */
void  cls()
{
    fprintf( ps_fp, "GS showpage GR\n" ); POUT = 0; fsbak = 0;
    fprintf( ps_fp, "%s %d %d\n", PGN, page_no, page_no ); page_no++;

    if ( mnbkc != 999 )
	fprintf( ps_fp, "GS %f %f %f SC clippath fill GR\n", mnbr, mnbg, mnbb );
}

/* ---------------------------------------------------------
    set the font & print the string
 */
void  mnsetfont( height, font )
    float  height;
    int    font;
{
    int    h;

    h = ABS(height)*mnfac +0.5;

    if ( h != hsbak || font != fsbak )
	fprintf( ps_fp, "%d FN%d\n", h, font );

    hsbak = h; fsbak = font;
}

void  mnprint( str, n )
    char  *str;
    int   n;
{
    register int  i;

    fprintf( ps_fp, "("  );

    for ( i = 0 ; i < n ; i++,str++ ) {
	if ( *str == '(' || *str == ')' || *str == '\\' )
	    putc ( '\\', ps_fp );
	    putc ( *str, ps_fp );
    }

    fprintf( ps_fp, ") " );
}

void  mnscript( str, n, m, h )
    char   *str;
    int    n, m;
    float  h;
{
    int    ori[3], mbs = 0, f, font = ABS(mnfntno);
    float  hbs[4], hh = ABS(h)*0.365*mnfac, hm = (m/3)*hh;
    char   ch[CMAX];
    register int  i, j, k;

    strncpy( ch, str, n );

    for ( i = 0 ; i < n ; i++ ) {
	if ( ch[i] == '#' ) { mbs = 1; continue; }
	if ( mbs   ==  1  )
	  if ( ch[i] >= 48 && ch[i] < 58 ) ch[i] = mnsign[ch[i]-48];
	mbs = 0;
    }

    mbs = 0; f = font;

    ori[0] =  0;
    ori[1] =  hh                +0.5; /* the origin of the superscript */
    ori[2] = -ABS(h)*0.22*mnfac +0.5; /* the origin of the subscript */
    hbs[0] = hbs[2] = ABS(h);
    hbs[1] = hbs[3] = ABS(h)*0.75;    /* the height of such a script */

    if ( m > 0 ) {   /* centering */
	int   nbs[4] = {0,0,0,0};
	char  cbs[4][CMAX];

	for ( i = 0 ; i < n ; i++ ) {
	  if ( ch[i] == '{' || ch[i] == '}' )		  continue;
	  if ( ch[i] == '^' || ch[i] == '_' ) { mbs  = 1; continue; }
          if ( ch[i] == '#' )                 { mbs += 2; continue; }

	  cbs[mbs][nbs[mbs]] = ch[i];
	  nbs[mbs]++;
	  mbs = 0;
	}

	for ( i = 0 ; i < 4 ; i++ ) {
	  if ( nbs[i] == 0 ) continue;
	  if ( i      >  1 ) f = 5;

	  mnsetfont( hbs[i], f );
	  mnprint( &cbs[i][0], nbs[i] );
/*
	  if ( i == 0 )
	    fprintf( ps_fp, "-%f -%f SM\n", (m/3)*hh, (m%3)*0.5 );
	  else
	    fprintf( ps_fp,  ".0 -%f SM\n", (m%3)*0.5 );
 */
	  fprintf( ps_fp, "-%f -%f SM\n", hm, (m%3)*0.5 );
	  hm = 0.0;
	}
    }

    mbs = 0; f = font;

    for ( i = 0 ; i < n ; i++ ) {
	if ( ch[i] == '{' ) {
	  for ( j = i+1,k = 0 ; j < n ; j++,k++ )
		if ( ch[j] == '}' ) break;
	  if ( k ) {
	    mnsetfont( hbs[(mbs+1)/2], f );
	    fprintf( ps_fp, "0 %d rmoveto " ,  ori[mbs] );
	    mnprint( &ch[i+1], k ); fprintf( ps_fp, "OB " );
	    fprintf( ps_fp, "0 %d rmoveto\n", -ori[mbs] );
	  }
	  continue;
	}
	if ( ch[i] == '}' )	       continue;
	if ( ch[i] == '^' ) { mbs = 1; continue; }
	if ( ch[i] == '_' ) { mbs = 2; continue; }
	if ( ch[i] == '#' ) { f   = 5; continue; }

	if ( mbs == 0 ) {
	    mnsetfont( hbs[0], f );
	    mnprint( &ch[i], 1 ); fprintf( ps_fp, "%s\n", mnfntpr );
	}
	else {
	    mnsetfont( hbs[1], f );
	    fprintf( ps_fp, "0 %d rmoveto " ,  ori[mbs] );
	    mnprint( &ch[i], 1 ); fprintf( ps_fp, "%s " , mnfntpr );
	    fprintf( ps_fp, "0 %d rmoveto\n", -ori[mbs] );
	}

	mbs = 0; f = font;
    }
}

/* ---------------------------------------------------------
    draw string
      x(float)  : plot start (x-coordinate)
      y(float)  : plot start (y-coordinate)
      h(float)  : string height
      ch(char)  : string
      th(float) : string angle (degree)
      n(int)    : string length
 */
void  symbol( x, y, h, ch, th, n )
    float  *x, *y, *h, *th;
    char   ch[];
    int    *n;
{
    int    ix, iy, nn, mm, dr;
    int    font = ABS(mnfntno);
    float  hh = ABS(*h)*0.365*mnfac;

    ix = XPOS( *x, mnfac, mnx0 );
    iy = XPOS( *y, mnfac, mny0 );

    if ( *x > 9998.9*mnwfac/mnfac ) fprintf( ps_fp, "CP pop " );
    else                            fprintf( ps_fp, "%d ",    ix );
    if ( *y > 9998.9*mnwfac/mnfac ) fprintf( ps_fp, "CP exch pop M\n" );
    else                            fprintf( ps_fp, "%d M\n", iy );

    nn = MAX( (*n)%100, 1 );
    nn = mnstrlen( ch, nn );
    mm = (*n)/100;

    dr = *th +(*th > 0.0 ? 0.5 : -0.5);

    mnsetfont( *h, font );

    if ( dr != 0 ) fprintf( ps_fp, "%d rotate\n",  dr );

    if ( *n > 0 ) {
	if ( *ch == '$' ) mnscript( ch+1, nn-1, mm, *h );
	else {
	  if ( mm > 0 ) {   /* centering */
	    mnprint( ch, nn );
	    fprintf( ps_fp, "-%f -%f SM\n", (mm/3)*hh, (mm%3)*0.5 );
	  }

	    if ( mnmask ) {
		fprintf( ps_fp, "%f %f %f ", mnbr, mnbg, mnbb );
		mnprint( ch, nn ); fprintf( ps_fp, "NM\n" );
	    }

	  mnprint( ch, nn ); fprintf( ps_fp, "%s\n", mnfntpr );
	}
    }
    else {   /* Centered symbol */
	mnprint( ch, nn ); fprintf( ps_fp, "-%f -.5 SM\n", hh );
	mnprint( ch, nn ); fprintf( ps_fp, "FS\n" );
    }

    if ( dr != 0 ) fprintf( ps_fp, "%d rotate\n", -dr );
}

/* ---------------------------------------------------------
    draw japanese
 */
void  nkanji( x, y, h, ch, th, n )
    float  *x, *y, *h, *th;
    char   ch[];
    int    *n;
{
    int    ix, iy, nn, mm, dr;
    int    font = mnfntmx+1;
    float  hh = ABS(*h)*0.5*mnfac;
    unsigned char  jis[CMAX*2+1];

    ix = XPOS( *x, mnfac, mnx0 );
    iy = XPOS( *y, mnfac, mny0 );

    if ( *x > 9998.9*mnwfac/mnfac ) fprintf( ps_fp, "CP pop " );
    else                            fprintf( ps_fp, "%d ",    ix );
    if ( *y > 9998.9*mnwfac/mnfac ) fprintf( ps_fp, "CP exch pop M\n" );
    else                            fprintf( ps_fp, "%d M\n", iy );

    nn = ABS(*n)%100; nn = 2*MIN( nn, CMAX );
    nn = mnstrlen( ch, nn );
    mm = ABS(*n)/100;
    if ( *n           < 0 ) font += 1;
    if ( ABS(mnfntno) > 2 ) font += 2;

    dr = *th +(*th > 0.0 ? 0.5 : -0.5);

    mnsetfont( *h, font );

    strncpy( (char *)jis, ch, nn ); jis[nn] = '\0';
#if  SJIS
    sj2jis ( jis );
#else
    euc2jis( jis );
#endif

    if ( dr != 0 ) fprintf( ps_fp, "%d rotate\n",  dr );

    if ( *n <  0 ) fprintf( ps_fp, "%d MR\n", (int)(ABS(*h)*mnfac+0.5) );

    if ( mm >  0 ) {   /* centering */
	mnprint( jis, nn );
	if ( *n < 0 )
		fprintf( ps_fp,  "%f -%f SM\n", (mm%3)*0.5, (mm/3)*hh );
	else
		fprintf( ps_fp, "-%f -%f SM\n", (mm/3)*hh, (mm%3)*0.5 );
    }
    mnprint( jis, nn ); fprintf( ps_fp, "%s\n", mnfntpr );

    if ( dr != 0 ) fprintf( ps_fp, "%d rotate\n", -dr );
}

void  mnstyle( m )
    int  m;
{
    float  gray, r, g, b;

    gray = (float)( mndiv-ABS(m) )/( mndiv-1 );
    if ( gray > 1.0 || gray < 0.0 ) gray = 0.0;
/*
    gray = (float)( mndiv-ABS(m)%10 )/( mndiv-1 );
    gray = 1.0 -pow((double)(1.0-gray),1.2);
 */
    r = mnfr +( mnbr-mnfr )*gray;
    g = mnfg +( mnbg-mnfg )*gray;
    b = mnfb +( mnbb-mnfb )*gray;

    fprintf( ps_fp, "%f %f %f ", r, g, b );
}

/* ---------------------------------------------------------
    draw polygon
      x(float) : polygon points (x-coordinate)
      y(float) : polygon points (y-coordinate)
      n(int)   : the number of points
      m(int)   : the pattern of fill area when m != 0
 */
void  polygn( x, y, n, m )
    float  x[], y[];
    int    *n, *m;
{
    int    ix, iy;
    register int  j;

    ix = XPOS( x[0], mnfac, mnx0 );
    iy = XPOS( y[0], mnfac, mny0 );

    fprintf( ps_fp, "%d %d M\n", ix, iy );

    for ( j = 1 ; j < *n ; j++ )
    {
	ix = XPOS( x[j], mnfac, mnx0 );
	iy = XPOS( y[j], mnfac, mny0 );

	fprintf( ps_fp, "%d %d L\n", ix, iy );
    }

    if ( *m )
    {
	mnstyle( *m );

	if ( *m > 0 ) fprintf( ps_fp, "C Z\n" );
	else          fprintf( ps_fp, "C F\n" );
    }
    else              fprintf( ps_fp, "S\n"   );
}

/* ---------------------------------------------------------
    draw circle
      x(float)  : circle centered points (x-coordinate)
      y(float)  : circle centered points (y-coordinate)
      rx(float) : radius for x-coordinate
      ry(float) : radius for y-coordinate
      as(float) : start angle (degree)
      ae(float) : end   angle (degree)
      m(int)    : the pattern of fill area when m != 0
 */
void  circle( x, y, rx, ry, as, ae, m )
    float  *x, *y, *rx, *ry, *as, *ae;
    int    *m;
{
    int    ix, iy, irx, iry, ias, iae, i;

    ix  = XPOS( *x, mnfac, mnx0 );
    iy  = XPOS( *y, mnfac, mny0 );
    irx = (*rx)*mnfac +0.5;
    iry = (*ry)*mnfac +0.5;
    ias = *as +0.5;
    iae = *ae +0.5;

    if ( *m && iae < 360 ) fprintf( ps_fp, "%d %d M ", ix, iy );
    else                   fprintf( ps_fp, "newpath " );

    if ( irx == iry )
	fprintf( ps_fp, "%d %d %d %d %d A\n", ix, iy, irx, ias, iae );
    else
	fprintf( ps_fp, "GS %d %d %d %d %d 1 %d %d div E\n",
	         ix, iy, irx, ias, iae, iry, irx );

    if ( *m && iae < 360 ) fprintf( ps_fp, "C " );

    if ( *m )
    {
	mnstyle( *m );

	if ( *m > 0 ) fprintf( ps_fp, "Z\n" );
	else          fprintf( ps_fp, "F\n" );
    }
    else              fprintf( ps_fp, "S\n" );

    if ( irx != iry ) fprintf( ps_fp, "CP GR M\n" );
}

void  circls( x, y, n, rx, ry, as, ae, m )
    float  x[], y[], *rx, *ry, *as, *ae;
    int    *n, *m;
{
    register int  i;

    for ( i = 0 ; i < *n ; i++ )
	circle( &x[i], &y[i], rx, ry, as, ae, m );
}

/* ---------------------------------------------------------
    draw rectangle
      x(float) : rectangle lower left x-coordinate
      y(float) : rectangle lower left y-coordinate
      w(float) : rectangle width
      h(float) : rectangle height
      r(float) : corner radius
      m(int)   : the pattern of fill area when m != 0
 */
void  rect( x, y, w, h, r, m )
    float  *x, *y, *w, *h, *r;
    int    *m;
{
    int    ix, iy, jx, jy, ir, rmax;

    ix = XPOS(  *x,       mnfac, mnx0 );
    iy = XPOS(  *y,       mnfac, mny0 );
    jx = XPOS( (*x)+(*w), mnfac, mnx0 );
    jy = XPOS( (*y)+(*h), mnfac, mny0 );

    rmax = MIN( jx-ix, jy-iy )/2;
    ir   = (*r)*mnfac +0.5; if ( ir > rmax ) ir = rmax;

    if ( ir <= 0 )
	fprintf( ps_fp, "%d %d %d %d %d %d %d %d R\n",
	         jx, iy, jx, jy, ix, jy, ix, iy );
    else
    {
	int  ky = iy+ir;

	fprintf( ps_fp, "%d %d M\n", ix, ky );
	fprintf( ps_fp, "%d %d %d %d %d AC ",  ix, jy, jx, jy, ir );
	fprintf( ps_fp, "%d %d %d %d %d AC\n", jx, jy, jx, iy, ir );
	fprintf( ps_fp, "%d %d %d %d %d AC ",  jx, iy, ix, iy, ir );
	fprintf( ps_fp, "%d %d %d %d %d AC\n", ix, iy, ix, jy, ir );
    }

    if ( *m )
    {
	mnstyle( *m );

	if ( *m > 0 ) fprintf( ps_fp, "Z\n" );
	else          fprintf( ps_fp, "F\n" );
    }
    else              fprintf( ps_fp, "S\n" );
}

/* ---------------------------------------------------------
    change font set
 */
void  newfnt( m )
    int  *m;
{
    mnfntno = *m;
    if ( mnfntno == 0       ) mnfntno = 1;
    if ( mnfntno >  mnfntmx ) mnfntno =  mnfntmx;
    if ( mnfntno < -mnfntmx ) mnfntno = -mnfntmx;

    if ( mnfntno > 0 ) mnfntpr[1] = 'S';   /* FS */
    else               mnfntpr[1] = 'O';   /* FO */
}

/* ---------------------------------------------------------
    get graphic image
      xs(float) : lower left  x-coordinate
      ys(float) : lower left  y-coordinate
      xe(float) : upper right x-coordinate
      ye(float) : upper right y-coordinate
 */
static int  pxs, pys;

void  get( xs, ys, xe, ye )
    float  *xs, *ys, *xe, *ye;
{
    char   str[128];
    int    ixe, iye;
    int    c;

    pxs  = XPOS( *xs, mnfac, mnx0 ); if ( pxs <  SPC ) pxs = SPC;
    pys  = XPOS( *ys, mnfac, mny0 ); if ( pys <  SPC ) pys = SPC;
    ixe  = XPOS( *xe, mnfac, mnx0 ); if ( ixe > mnwx ) ixe = mnwx;
    iye  = XPOS( *ye, mnfac, mny0 ); if ( iye > mnwy ) iye = mnwy;

    mnpw = ixe -pxs;
    mnph = iye -pys;

    fb = fopen( "GOMIdesu", "w" ); GOMI = 1;

    rewind( ps_fp );

    while( fgets(str, 128, ps_fp) )
    {
	fprintf( fb, "%s", str );
	if ( !strncmp(str, PGN, 7) ) {
	    fclose( fb ); fb = fopen( "GOMIdesu", "w" );
	}
    }

    fclose( fb );
}

/* ---------------------------------------------------------
    put graphic image
      x(float) : lower left  x-coordinate
      y(float) : lower left  y-coordinate
 */
void  put( x, y )
    float  *x, *y;
{
    int    ix, iy, jx, jy;
    char   comstr[64];

    ix = XPOS( *x, mnfac, mnx0 ); if ( ix <  SPC ) ix = SPC;
    iy = XPOS( *y, mnfac, mny0 ); if ( iy <  SPC ) iy = SPC;
    jx = ix +mnpw;
    jy = iy +mnph;

    fprintf( ps_fp, "GS %d %d %d %d %d %d %d %d R ",
             jx, iy, jx, jy, ix, jy, ix, iy );
    fprintf( ps_fp, "%d %d CT\n", ix-pxs, iy-pys );

    fclose( ps_fp );

    sprintf( comstr, "cat GOMIdesu >> %s", mnname );
    system( comstr );

    ps_fp = fopen( mnname, "a+" );

    fprintf( ps_fp, "GR\n" );

    fsbak = 0;
}

/* ---------------------------------------------------------
    Child-window open
      x(float) : window upper left x-coordinate
      y(float) : window upper left y-coordinate
      w(float) : window width
      h(float) : window height
 */
void  childs( x, y, w, h )
    float  *x, *y, *w, *h;
{
    float  wx, wy, xx, yy, r = 0.0;
    float  del = 1.0*mnwfac/mnfac;
    int    m1 = -mndiv, m2 = -1;

    wx = (*w) +2.0*del;
    wy = (*h) +2.0*del;
    xx = (*x);
    yy = (*y) -wy;
    if ( xx+wx > (mnwx-mnx0)/mnfac ) xx = (mnwx-mnx0)/mnfac -wx;
    if ( yy    < (SPC -mny0)/mnfac ) yy = (SPC -mny0)/mnfac;

    rect( &xx, &yy, &wx, &wy, &r, &m1 );
    xx += del;
    yy += del;
    rect( &xx, &yy, w,   h,   &r, &m2 );

    mnx0bak  = mnx0;
    mny0bak  = mny0;
    mnfacbak = mnfac;
    mnx0     = mnx0 +xx*mnfac;
    mny0     = mny0 +yy*mnfac;
}

void  childe()
{
    mnx0  = mnx0bak;
    mny0  = mny0bak;
    mnfac = mnfacbak;

    cls();
}

void  color( m )
    int  *m;
{
    int    mm;
    float  r, g, b;

    mm = ABS(*m); if ( *m < 0 ) mm--;
    if ( mm > 999 ) { mndiv = mm/1000; return; }

    r =   ( mm/100 )     /9.0;
    g = ( ( mm%100 )/10 )/9.0;
    b =   ( mm%10  )     /9.0;

    if ( *m >= 0 )
    {
	mnfr  = r;
	mnfg  = g;
	mnfb  = b;
	fprintf( ps_fp, "%f %f %f SC\n", r, g, b );
    }
    else
    {
	mnbkc = mm;
	mnbr  = r;
	mnbg  = g;
	mnbb  = b;
	fprintf( ps_fp, "GS %f %f %f SC clippath fill GR\n", r, g, b );
    }
}

void  color2( cr, cg, cb )
    int  *cr, *cg, *cb;
{
    mnfr = MIN( *cr, 256 )/256.0;
    mnfg = MIN( *cg, 256 )/256.0;
    mnfb = MIN( *cb, 256 )/256.0;

    fprintf( ps_fp, "%f %f %f SC\n", mnfr, mnfg, mnfb );
}

/* ---------------------------------------------------------
    paint rectangles ---> paint contours
 */
void  rectpt( alt, mx, nx, ny, x, y, h, c, n, zn )
    float  *alt, x[], y[], h[], *zn;
    int    *mx, *nx, *ny, c[], *n;
{
    fprintf( ps_fp, "GS\n" );

    contpt( alt, mx, nx, ny, x, y, h, c, n, zn );

    fprintf( ps_fp, "GR\n" );
}

void  colsr( m )
    int  *m;
{
    static float  mnfr_c, mnfg_c, mnfb_c;

    if ( *m ) {
	mnfr_c = mnfr;
	mnfg_c = mnfg;
	mnfb_c = mnfb;
    }
    else {
	mnfr = mnfr_c;
	mnfg = mnfg_c;
	mnfb = mnfb_c;
	fprintf( ps_fp, "%f %f %f SC\n", mnfr, mnfg, mnfb );
    }
}

void  rclip( m, x, y, w, h )
    float  *x, *y, *w, *h;
    int    *m;
{
    int    ix, iy, jx, jy;

    ix = XPOS(  *x,       mnfac, mnx0 );
    iy = XPOS(  *y,       mnfac, mny0 );
    jx = XPOS( (*x)+(*w), mnfac, mnx0 );
    jy = XPOS( (*y)+(*h), mnfac, mny0 );

    if ( !(*m) ) {
	fprintf( ps_fp, "GR\n" ); fsbak = 0;
    }
    else
	fprintf( ps_fp, "GS %d %d %d %d %d %d %d %d R clip newpath\n",
	         jx, iy, jx, jy, ix, jy, ix, iy );
}
