c **********************************************************************
c *   Calculates B_2/B_1                                               *
c *                                                                    *
c *                                   Dec/2005  M. Nakanishi (N.D.A)   *
c **********************************************************************
c
      include  "sub/epestm.f"
      include  "sub/etestm.f"
      include  "sub/t2estm.f"
      include  "../src/Parameter.h"
c
      parameter ( mf=8 )
      character (len=4)  :: f_name(mf)
      character (len=5)  :: r_name
      double precision  dat(mx,mz,my,mf), ave, std, uavk, vavk
      double precision  wk (mx,mz,my, 6), uav(mz), vav(mz), tav(mz)
      dimension  eps(mz), ept(mz), qsq(mz), tsq(mz)
c
      data  f_name/ 't___', 'q___', 'u___', 'v___',
     :              'fm__', 'fh__', 'w___', 'pd__'/
c
      namelist  /les1/  nrun, nstep,  iout,  jout,  lout
      namelist  /les2/  isgs,  isfc,  irad,  icon,  isca,
     :                  jmin,  rlat,    dt,    dx,    dy,    dz,
     :                         ugsf,  vgsf,         aglw,  agmd,
     :                  gulw,  gvlw,  gumd,  gvmd,
     :                  tref,   tsf,   qsf,   psf,  hglw,  hgmd,
     :                  gtlw,  gqlw,  gtmd,  gqmd,  gamt,  gamq,
     :                   z0m,   z0h,  tfmx,  qfmx, phour, dhour,
     :                 tdeep,  swet,  crso,  fkso,
     :                  elat,  albd,  clov,  ulov,
     :                 nflay, frate,
     :                  nspl,  nspu,   csp, nstot
c
      write(6,*) 'Run + Restart number (xx.xx) =?'
      read (5,'(a)')  r_name
c
      open (10,file='para'//r_name,status='old',iostat=ios)
      if ( ios .ne. 0 ) stop 'Para-file not found.'
c
      read (10,nml=les1)
      read (10,nml=les2)
      close(10)
c
      do m = 1,mf
        open (m+10,file=f_name(m)//r_name,form='unformatted',
     :             status='old',iostat=ios)
        if ( ios .ne. 0 ) stop 'Data-file not found.'
      end do
c
      rsum = 1.0/dble((nx-2)*(ny-2))
      cel  =( 0.1*(dx*dy*dz)**(1.0/3.0) )**2
c
      do l = 1,999
        jhour = ( jmin +nint(l*jout*dt)/60 )/60
c
        do m = 1,mf
          read (m+10,end=200) (((dat(i,k,j,m),i=1,mx),k=1,mz),j=1,my)
        end do
c
        call epestm( 1, dat(1,1,1,3), dat(1,1,1,4), dat(1,1,1,7),
     :                  dat(1,1,1,1), dat(1,1,1,5), dat(1,1,1,6),
     :               mx, mz, nx, nz, ny, dx, dz, dy, 9.81, tref,
     :               wk (1,1,1,1), wk (1,1,1,2), wk (1,1,1,3),
     :               wk (1,1,1,4), wk (1,1,1,5), wk (1,1,1,6),
     :               uav, vav, eps )
        call etestm( 1, dat(1,1,1,1), dat(1,1,1,5), dat(1,1,1,6),
     :               mx, mz, nx, nz, ny, dx, dz, dy,
     :               wk (1,1,1,1), wk (1,1,1,2), wk (1,1,1,3),
     :               tav, ept )
        call t2estm( 1, dat(1,1,1,1), dat(1,1,1,5), dat(1,1,1,6),
     :               mx, mz, nx, nz, ny, dx, dz, dy,
     :               wk (1,1,1,1), wk (1,1,1,2), wk (1,1,1,3),
     :               wk (1,1,1,4),
     :               tsq )
c
        do k = 1,nz
          uavk = 2.0*uav(k)
          vavk = 2.0*vav(k)
c
          ave = 0.0
          do j = 2,ny-1
          do i = 2,nx-1
            ave = ave +        dat(i,k,j,5)**2/cel
     :                +0.125*( dat(i,k,j,3)+dat(i+1,k,j,3)-uavk )**2
     :                +0.125*( dat(i,k,j,4)+dat(i,k,j+1,4)-vavk )**2
     :                +0.125*( dat(i,k,j,7)+dat(i,k+1,j,7)      )**2
          end do
          end do
          ave = ave * rsum
c
          qsq(k) = ave * 2.0
        end do
c
        write(6,*) jhour
          ave = 0.0
        do k = 2,24
          std = eps(k)*tsq(k)/( ept(k)*qsq(k) )
          ave = ave +std
          write(6,*) 'B_2/B_1 =', std
        end do
        write(6,*) 'ave =', ave/23.0
c
      end do
c
  200 continue
c
      stop
      end
