c **********************************************************************
c *   Vertical profiles of TKE budget                                  *
c *                                                                    *
c *                                   Dec/2005  M. Nakanishi (N.D.A)   *
c **********************************************************************
c
      include  "sub/graph.f"
      include  "sub/ziestm.f"
      include  "sub/epestm.f"
      include  "sub/etestm.f"
      include  "../src/Parameter.h"
c
      parameter ( mf=9, mg=2, me=2, mt=4 )
      character (len=4)  :: f_name(mf+mg)
      character (len=25) :: e_lab (me)
      character (len=3)  :: s_lab (me), t_lab (mt,me)
      character (len=10) :: z_lab
      character (len=8)  :: l_lab
      character (len=5)  :: r_name
      character (len=30) :: line
      double precision  dat(mx,mz,my,mf), da2(mx,my,mg)
      double precision  wk (mx,mz,my, 6), uav(mz), vav(mz)
      double precision  av1, av2, av3, uw, vw, tt, duz, dvz
      dimension  vpro(mz,mt,me)
      dimension  xsta(me), xend(me), lbx(me),  xx(mz), yy(mz)
      dimension  newp(mt)
c
      data  f_name/ 't___', 'q___', 'u___', 'v___', 'w___',
     :              'fm__', 'fh__', 'pd__', 'fub_', 'flt_', 'flq_'/
      data  e_lab / 'Normalized TKE budget    ',
     :              '$Normalized <#q^2> budget'/
      data  s_lab /  '(a)',  '(b)'/
      data  z_lab / 'Height (m)'/, l_lab / '0000 LST'/
      data  t_lab / 'S  ', 'B  ', 'T+P', 'D  ',
     :              '   ', 'M  ', 'T  ', 'D  '/
      data  newp  /   4,  14,  54,  34/
c
      namelist  /les1/  nrun, nstep,  iout,  jout,  lout
      namelist  /les2/  isgs,  isfc,  irad,  icon,  isca,
     :                  jmin,  rlat,    dt,    dx,    dy,    dz,
     :                         ugsf,  vgsf,         aglw,  agmd,
     :                  gulw,  gvlw,  gumd,  gvmd,
     :                  tref,   tsf,   qsf,   psf,  hglw,  hgmd,
     :                  gtlw,  gqlw,  gtmd,  gqmd,  gamt,  gamq,
     :                   z0m,   z0h,  tfmx,  qfmx, phour, dhour,
     :                 tdeep,  swet,  crso,  fkso,
     :                  elat,  albd,  clov,  ulov,
     :                 nflay, frate,
     :                  nspl,  nspu,   csp, nstot
c
      open (1,file='/home/naka/les_for_es/figure/meanscale.dat')
        ne = 0
      do i = 1,999
        read (1,'(a)',end=10) line
        if ( line(1:1) .ne. 'B' ) cycle
        ne = ne +1
        read (line(10:30),*) xsta(ne), xend(ne), lbx(ne)
        if ( ne        .eq. me  ) exit
      end do
   10 close(1)
c
      write(6,*) 'Run + Restart number (xx.xx) =?'
      read (5,'(a)')  r_name
      write(6,*) 'Record number =?'
      read (5,*)  idmy, idmy, itplt
c
      open (10,file='para'//r_name,status='old',iostat=ios)
      if ( ios .ne. 0 ) stop 'Para-file not found.'
c
      read (10,nml=les1)
      read (10,nml=les2)
      close(10)
c
      rsum = 1.0/dble((nx-2)*(ny-2))
c
      do m = 1,mf+mg
        open (m+10,file=f_name(m)//r_name,form='unformatted',
     :             status='old',iostat=ios)
        if ( ios .ne. 0 ) stop 'Data-file not found.'
      end do
c
      do ll = 1,itplt
        jhour = ( jmin +nint(ll*jout*dt)/60 )/60
c
        do m = 1,mf
          read (m+10,   end=100) (((dat(i,k,j,m),i=1,mx),k=1,mz),j=1,my)
        end do
        do m = 1,mg
          read (m+10+mf,end=100) ( (da2(i,  j,m),i=1,mx),        j=1,my)
        end do
      end do
c
  100   continue
c
c  ***  for TKE  ***
        call epestm( 1, dat(1,1,1,3), dat(1,1,1,4), dat(1,1,1,5),
     :                  dat(1,1,1,1), dat(1,1,1,6), dat(1,1,1,7),
     :               mx, mz, nx, nz, ny, dx, dz, dy, 9.81, tref,
     :               wk (1,1,1,1), wk (1,1,1,2), wk (1,1,1,3),
     :               wk (1,1,1,4), wk (1,1,1,5), wk (1,1,1,6),
     :               uav, vav, vpro(1,4,1) )
c
        do k = 1,nz
          duz = 2.0*uav(k)
          dvz = 2.0*vav(k)
        do j = 1,ny
        do i = 1,nx
          wk(i,k,j,1) = ( dat(i,k,j,1)+tref )
     :                 *( 1.0+0.61*dat(i,k,j,2) )
          wk(i,k,j,2) = dat( i , k , j ,8)
     :       +0.125*( ( dat(i+1, k , j ,3)+dat(i,k,j,3)-duz )**2
     :               +( dat( i , k ,j+1,4)+dat(i,k,j,4)-dvz )**2
     :               +( dat( i ,k+1, j ,5)+dat(i,k,j,5)     )**2 )
        end do
        end do
        end do
c
        do k = 2,nz
          duz = ( uav(k)-uav(k-1) ) / dz
          dvz = ( vav(k)-vav(k-1) ) / dz
c
          av1 = 0.0
          av2 = 0.0
          av3 = 0.0
          do j = 2,ny-1
          do i = 2,nx-1
            uw = wk(i,k,j,6) -0.25*( dat(i,k,j,3)+dat( i ,k-1, j ,3) )
     :                            *( dat(i,k,j,5)+dat(i-1, k , j ,5) )
            vw = wk(i,k,j,5) -0.25*( dat(i,k,j,4)+dat( i ,k-1, j ,4) )
     :                            *( dat(i,k,j,5)+dat( i , k ,j-1,5) )
            tt = 0.5*( wk (i,k,j,1)+wk (i,k-1,j,1) ) * dat(i,k,j,5)
     :          -0.5*( dat(i,k,j,7)+dat(i,k-1,j,7) ) / dz
     :      *( ( 0.5*( dat(i,k,j,2)+dat(i,k-1,j,2) )*0.61 + 1.0 )
     :              *( dat(i,k,j,1)-dat(i,k-1,j,1) )
     :        +( 0.5*( dat(i,k,j,1)+dat(i,k-1,j,1) )+tref )*0.61
     :              *( dat(i,k,j,2)-dat(i,k-1,j,2) ) )
c
            av1 = av1 +uw*duz +vw*dvz
            av2 = av2 +tt
            av3 = av3 +0.5*( wk(i,k,j,2)+wk(i,k-1,j,2) ) * dat(i,k,j,5)
          end do
          end do
c
          vpro(k,1,1) = av1 * rsum
          vpro(k,2,1) = av2 * rsum
          vpro(k,3,1) = av3 * rsum
        end do
c
        av2 = 0.0
        av3 = 0.0
        do j = 2,ny-1
        do i = 2,nx-1
          av2 = av2 +da2(i,j,1)*( 0.61*  dat(i,1,j,2) + 1.0  )
          av3 = av3 +da2(i,j,2)*  0.61*( dat(i,1,j,1) + tref )
        end do
        end do
c
        vpro(1,2,1) = av2*rsum + av3*rsum
        ust  = dat(1,nz+1,1,mf)
c
        call ziestm( vpro(1,2,1),nz, dz, 9.81,tref,ust, zi,wst,rate )
c
        write(6,*) 'zi,wst,erate =', zi, wst, rate
c
        tst = vpro(1,2,1) / wst
c
        do k = 1,nz
          vpro(k,2,1) =    vpro( k ,2,1)               * 9.81/tref
          vpro(k,3,1) = -( vpro(k+1,3,1)-vpro(k,3,1) ) / dz
        end do
c
c  ***  for Temperature Variance  ***
        call etestm( 1, dat(1,1,1,1), dat(1,1,1,6), dat(1,1,1,7),
     :               mx, mz, nx, nz, ny, dx, dz, dy,
     :               wk (1,1,1,1), wk (1,1,1,2), wk (1,1,1,3),
     :               uav, vpro(1,4,2) )
c
        do k = 1,nz
          duz = uav(k)
          do j = 1,ny
          do i = 1,nx
            wk(i,k,j,2) = 0.5*( dat(i,k,j,1)-duz )**2
          end do
          end do
        end do
c
        do k = 2,nz
          duz = ( uav(k)-uav(k-1) ) / dz
c
          av2 = 0.0
          av3 = 0.0
          do j = 2,ny-1
          do i = 2,nx-1
            uw = wk(i,k,j,3) -0.5*( dat(i,k,j,1)+dat( i ,k-1, j ,1) )
     :                           *  dat(i,k,j,5)
c
            av2 = av2 +uw*duz
            av3 = av3 +0.5*( wk(i,k,j,2)+wk(i,k-1,j,2) ) * dat(i,k,j,5)
          end do
          end do
c
          vpro(k,2,2) = av2 * rsum
          vpro(k,3,2) = av3 * rsum
        end do
c
        do k = 2,nz
          vpro(k,3,2) = -( vpro(k+1,3,2)-vpro(k,3,2) ) / dz
        end do
c
        do l = 1,mt
        do k = 1,mz
          vpro(k,l,1) = vpro(k,l,1)     * zi/wst**3
          vpro(k,l,2) = vpro(k,l,2)*2.0 * zi/tst**2/wst
        end do
        end do
c
      wx   = 7.4
      wy   = 8.0
      shft = 0.2
c
      xmv  = wx +2.1
      x0   = 2.2
      y0   = 7.0
c
      kz   = nz
c     kz   = 40
      zmax = dz * kz
      lbz  = nint( zmax/100.0 ) +400
c
      write(l_lab(1:2),'(i2.2)') jhour
c
cx    call winnam( 'Budget' )
      call winfac( 2.5 )
      call plots ( 0.0, 0.0,  2 )
      call factor( 10.0 )
      call plot  (  x0,  y0, -3 )
      call newfnt( 4 )
c
      do m = 1,me
        scl = ( xend(m)-xsta(m) )/mod(lbx(m),100)*max(lbx(m)/100,2)
                                      lnx  = -1
        if ( scl .ne. int(scl)      ) lnx  =  1
c
        ypls = -1.5*( m-1 )
c
        call newpen( 3 )
        call symbol( 0.80,  wy-1.0, 0.60, s_lab (m), 0.0,  3 )
        call symbol( wx-0.6,wy-1.0, 0.45, l_lab,     0.0,208 )
        if ( mod(m,2) .eq. 1 )
     :  call symbol(-1.50,  wy*0.5, 0.50, z_lab,    90.0,110 )
        call symbol( 0.5*wx, -1.20, 0.50, e_lab (m), 0.0,125 )
        call graph ( wx, wy, xsta(m), xend(m), 0.0, zmax, facx, facy,
     :        lbx(m),lbz,lnx,-1, '      ', '      ', 0, 999.0, shft )
c
        if ( xsta(m) .lt. 0.0 ) then
          call newpen( 0 )
          call plot  ( -xsta(m)*facx, 0.0, 3 )
          call plot  ( -xsta(m)*facx,  wy, 2 )
        end if
c
        call rclip( 1, 0.0, 0.0, wx, wy )
c
        do l = 1,mt
          if ( t_lab(l,m)(1:1) .eq. ' ' ) cycle
c
          call newpen( newp(l) )
c
            call plot  (0.6,wy-l*0.5-1.3+ypls, 3)
            call plot  (1.3,wy-l*0.5-1.3+ypls, 2)
            call symbol(1.5,wy-l*0.5-1.3+ypls,0.45,t_lab(l,m),0.0,303)
c
                          zst = 1.0
          if ( l .ge. 3 ) zst = 0.5
c
          do k = 2,kz
            xx(k) = ( vpro(k,l,m)-xsta(m) )*facx
            yy(k) = ( k-zst )*dz           *facy +shft
          end do
c
          call polygn( xx(2), yy(2), kz-1, 0 )
c
        end do
c
        call rclip( 0, 0.0, 0.0, wx, wy )
c
        if ( mod(m,2) .eq. 1 ) then
          call plot (  xmv,  0.0, -3 )
        else
          call plot ( -xmv,  0.0, -3 )
          call cls  ( 1 )
        end if
c
      end do
c
      call plote
c
      stop
      end
