c **********************************************************************
c *   Vertical profiles of vorticity budgets                           *
c *                                                                    *
c *                                   Dec/2006  M. Nakanishi (N.D.A)   *
c **********************************************************************
c
      include  "sub/graph.f"
      include  "sub/ziestm.f"
      include  "sub/vordif.f"
      include  "../src/Parameter.h"
c
      parameter ( mf=7, mg=3, me=3, mt=6 )
      character (len=4)  :: f_name(mf+mg)
      character (len=20) :: e_lab (me)
      character (len=3)  :: s_lab (me)
      character (len=10) :: z_lab
      character (len=8)  :: l_lab
      character (len=5)  :: t_lab (mt,me)
      character (len=5)  :: r_name
      character (len=30) :: line
      double precision  dat(mx,mz,my,mf), da2(mx,my,mg)
      double precision  wk (mx,mz,my, 7), trm(mx,my,mt), del
      dimension  vpro(mz,mt,me)
      dimension  xx(mz), yy(mz)
      dimension  newp(mt)
c
      data  f_name/ 'u___', 'v___', 'w___', 't___', 'q___',
     :              'fm__', 'fub_','flm_', 'flt_', 'flq_'/
      data  e_lab / '$<#x> budget (s^-^2)',
     :              '$<#h> budget (s^-^2)',
     :              '$<#z> budget (s^-^2)'/
      data  s_lab /  '(a)',  '(b)',  '(c)'/
      data  z_lab / 'Height (m)'/, l_lab / '0000 LST'/
      data  t_lab / '$S_#x','$T_#x','$G_#x','$C_#x','$D_#x','$A_#x',
     :              '$S_#h','$T_#h','$G_#h','$C_#h','$D_#h','$A_#h',
     :              '$S_#z','$T_#z','     ','$C_#z','$D_#z','$A_#z'/
      data  newp  /   4,  14,  54,  34,  44,  64/
c
      namelist  /les1/  nrun, nstep,  iout,  jout,  lout
      namelist  /les2/  isgs,  isfc,  irad,  icon,  isca,
     :                  jmin,  rlat,    dt,    dx,    dy,    dz,
     :                         ugsf,  vgsf,         aglw,  agmd,
     :                  gulw,  gvlw,  gumd,  gvmd,
     :                  tref,   tsf,   qsf,   psf,  hglw,  hgmd,
     :                  gtlw,  gqlw,  gtmd,  gqmd,  gamt,  gamq,
     :                   z0m,   z0h,  tfmx,  qfmx, phour, dhour,
     :                 tdeep,  swet,  crso,  fkso,
     :                  elat,  albd,  clov,  ulov,
     :                 nflay, frate,
     :                  nspl,  nspu,   csp, nstot
c
      rrd = 1.0/100000.0
c
      open (1,file='/home/naka/les_for_es/figure/meanscale.dat')
      do i = 1,999
        read (1,'(a)',end=10) line
        if ( line(1:1) .ne. 'V' ) cycle
        read (line(10:30),*) xsta, xend, lbx
        exit
      end do
   10 close(1)
c
      write(6,*) 'Run + Restart number (xx.xx) =?'
      read (5,'(a)')  r_name
      write(6,*) 'Record number =?'
      read (5,*)  idmy, idmy, itplt
      write(6,*) 'Skip'
      read (5,*)
      write(6,*) 'Skip'
      read (5,*)
      write(6,*) 'Grid numbers for averaging =?'
      read (5,*)  ist, ied, jst, jed
c
      ist = max( ist+1, 2 )
      jst = max( jst+1, 2 )
      ied = min( ied+1, nx-1 )
      jed = min( jed+1, ny-1 )
c
      open (10,file='para'//r_name,status='old',iostat=ios)
      if ( ios .ne. 0 ) stop 'Para-file not found.'
c
      read (10,nml=les1)
      read (10,nml=les2)
      close(10)
c
      rsum = 1.0/dble((nx-2)*(ny-2))
c
      tlat = rlat * 3.141593/180.0
      fs   = 2.0*7.292e-5*sin( tlat )
      fc   = 2.0*7.292e-5*cos( tlat )
c
      do m = 1,mf+mg
        open (m+10,file=f_name(m)//r_name,form='unformatted',
     :             status='old',iostat=ios)
        if ( ios .ne. 0 ) stop 'Data-file not found.'
      end do
c
      do ll = 1,itplt
        jhour = ( jmin +nint(ll*jout*dt)/60 )/60
c
        do m = 1,mf
          read (m+10,   end=100) (((dat(i,k,j,m),i=1,mx),k=1,mz),j=1,my)
        end do
        do m = 1,mg
          read (m+10+mf,end=100) ( (da2(i,  j,m),i=1,mx),        j=1,my)
        end do
      end do
c
  100   continue
c
        call vordif ( 1, dat(1,1,1,1), dat(1,1,1,2), dat(1,1,1,3),
     :                   dat(1,1,1,6), da2(1,1,1),
     :               mx, mz, nx, nz, ny, dx, dz, dy,
     :               wk (1,1,1,1), wk (1,1,1,2), wk (1,1,1,3),
     :               wk (1,1,1,4), wk (1,1,1,5), wk (1,1,1,6),
     :               wk (1,1,1,4), wk (1,1,1,5), wk (1,1,1,6) )
c
        do k = 2,nz+1
          m  = k -1
          do j = 2,ny
          do i = 1,nx
            wk(i,k,j,1) = ( dat(i,k,j,3)-dat( i , k ,j-1,3) ) / dy
     :                   -( dat(i,k,j,2)-dat( i ,k-1, j ,2) ) / dz
          end do
          end do
          do j = 1,ny
          do i = 2,nx
            wk(i,k,j,2) = ( dat(i,k,j,1)-dat( i ,k-1, j ,1) ) / dz
     :                   -( dat(i,k,j,3)-dat(i-1, k , j ,3) ) / dx
          end do
          end do
          do j = 2,ny
          do i = 2,nx
            wk(i,m,j,3) = ( dat(i,m,j,2)-dat(i-1, m , j ,2) ) / dx
     :                   -( dat(i,m,j,1)-dat( i , m ,j-1,1) ) / dy
          end do
          end do
          do j = 1,ny
          do i = 1,nx
            wk(i,m,j,7) = ( dat(i,m,j,4)+tref )
     :                   *( 1.0+0.61*dat(i,m,j,5) )
          end do
          end do
        end do
c
c  ***  for xi  ***
        do k = 2,nz
          do j = 2,ny-1
          do i = 2,nx-1
            del =        0.5 *( dat( i , k , j ,1)-dat(i,k-1, j ,1)
     :                         +dat( i , k ,j-1,1)-dat(i,k-1,j-1,1) )/dz
c
            trm(i,j,1) = 0.25*  wk ( i , k , j ,1)
     :                       *( dat(i+1, k , j ,1)-dat(i, k , j ,1)
     :                         +dat(i+1,k-1, j ,1)-dat(i,k-1, j ,1)
     :                         +dat(i+1, k ,j-1,1)-dat(i, k ,j-1,1)
     :                         +dat(i+1,k-1,j-1,1)-dat(i,k-1,j-1,1) )/dx
            trm(i,j,2) = 0.25*( wk ( i , k , j ,2)+wk (i, k ,j-1,2) )
     :                       *( dat( i , k , j ,1)-dat(i, k ,j-1,1)
     :                         +dat( i ,k-1, j ,1)-dat(i,k-1,j-1,1) )/dy
     :              +del*0.5 *( wk ( i , k , j ,3)+wk (i,k-1, j ,3) )
            trm(i,j,3) = 0.5 *( wk ( i , k , j ,7)-wk (i, k ,j-1,7)
     :                         +wk ( i ,k-1, j ,7)-wk (i,k-1,j-1,7) )/dy
            trm(i,j,4) = del *( fs
     :              +rrd*0.25*( dat( i , k , j ,2)+dat( i ,k-1,j,2)
     :                         +dat(i-1, k , j ,2)+dat(i-1,k-1,j,2) ) )
     :                  +0.5 *( dat( i , k , j ,2)-dat( i ,k-1,j,2)
     :                         +dat(i-1, k , j ,2)-dat(i-1,k-1,j,2) )/dz
     :              *rrd*0.25*( dat( i , k , j ,1)+dat(i,k-1, j ,1)
     :                         +dat( i , k ,j-1,1)+dat(i,k-1,j-1,1) )
            trm(i,j,5) =   wk ( i , k , j ,4)
            trm(i,j,6) =
     :          -0.125*( ( wk (i+1, k , j ,1)+wk ( i , k , j ,1) )
     :                  *( dat(i+1, k , j ,1)+dat(i+1,k-1, j ,1)
     :                    +dat(i+1, k ,j-1,1)+dat(i+1,k-1,j-1,1) )
     :                  -( wk ( i , k , j ,1)+wk (i-1, k , j ,1) )
     :                  *( dat( i , k , j ,1)+dat( i ,k-1, j ,1)
     :                    +dat( i , k ,j-1,1)+dat( i ,k-1,j-1,1) ) )/dx
     :          -0.125*( ( wk ( i , k ,j+1,1)+wk ( i , k , j ,1) )
     :                  *( dat( i , k ,j+1,2)+dat( i ,k-1,j+1,2)
     :                    +dat( i , k , j ,2)+dat( i ,k-1, j ,2) )
     :                  -( wk ( i , k , j ,1)+wk ( i , k ,j-1,1) )
     :                  *( dat( i , k , j ,2)+dat( i ,k-1, j ,2)
     :                    +dat( i , k ,j-1,2)+dat( i ,k-1,j-1,2) ) )/dy
     :          -0.125*( ( wk ( i ,k+1, j ,1)+wk ( i , k , j ,1) )
     :                  *( dat( i ,k+1, j ,3)+dat( i ,k+1,j-1,3)
     :                    +dat( i , k , j ,3)+dat( i , k ,j-1,3) )
     :                  -( wk ( i , k , j ,1)+wk ( i ,k-1, j ,1) )
     :                  *( dat( i , k , j ,3)+dat( i , k ,j-1,3)
     :                    +dat( i ,k-1, j ,3)+dat( i ,k-1,j-1,3) ) )/dz
          end do
          end do
c
          call xaverage( 0,1,trm(1,1,1),mx,nx,ny, 2,nx-1, 2,ny-1, xav )
          call xaverage( 0,1,trm(1,1,1),mx,nx,ny,ist,ied,jst,jed, yav )
          vpro(k,1,1) = yav -xav
          call xaverage( 1,1,trm(1,1,2),mx,nx,ny, 2,nx-1, 2,ny-1, xav )
          call xaverage( 1,1,trm(1,1,2),mx,nx,ny,ist,ied,jst,jed, yav )
          vpro(k,2,1) = yav -xav
          call xaverage( 0,1,trm(1,1,3),mx,nx,ny,ist,ied,jst,jed, yav )
          vpro(k,3,1) = yav *9.81/tref
          call xaverage( 1,1,trm(1,1,4),mx,nx,ny, 2,nx-1, 2,ny-1, xav )
          call xaverage( 1,1,trm(1,1,4),mx,nx,ny,ist,ied,jst,jed, yav )
          vpro(k,4,1) = yav -xav
          call xaverage( 0,1,trm(1,1,5),mx,nx,ny, 2,nx-1, 2,ny-1, xav )
          call xaverage( 0,1,trm(1,1,5),mx,nx,ny,ist,ied,jst,jed, yav )
          vpro(k,5,1) = yav -xav
          call xaverage( 0,1,trm(1,1,6),mx,nx,ny, 2,nx-1, 2,ny-1, xav )
          call xaverage( 0,1,trm(1,1,6),mx,nx,ny,ist,ied,jst,jed, yav )
          vpro(k,6,1) = yav -xav
        end do
c
c  ***  for eta  ***
        do k = 2,nz
          do j = 2,ny-1
          do i = 2,nx-1
            del =        0.5 *( dat( i , k , j ,2)-dat( i ,k-1,j,2)
     :                         +dat(i-1, k , j ,2)-dat(i-1,k-1,j,2) )/dz
c
            trm(i,j,1) = 0.25*  wk ( i , k , j ,2)
     :                       *( dat( i , k ,j+1,2)-dat( i , k ,j,2)
     :                         +dat( i ,k-1,j+1,2)-dat( i ,k-1,j,2)
     :                         +dat(i-1, k ,j+1,2)-dat(i-1, k ,j,2)
     :                         +dat(i-1,k-1,j+1,2)-dat(i-1,k-1,j,2) )/dy
            trm(i,j,2) = 0.25*( wk ( i , k , j ,1)+wk (i-1, k ,j,1) )
     :                       *( dat( i , k , j ,2)-dat(i-1, k ,j,2)
     :                         +dat( i ,k-1, j ,2)-dat(i-1,k-1,j,2) )/dx
     :              +del*0.5 *( wk ( i , k , j ,3)+wk (i,k-1, j ,3) )
            trm(i,j,3) =-0.5 *( wk ( i , k , j ,7)-wk (i-1, k ,j,7)
     :                         +wk ( i ,k-1, j ,7)-wk (i-1,k-1,j,7) )/dx
            trm(i,j,4) = del *( fs
     :              +rrd*0.5 *( dat( i , k , j ,2)+dat( i ,k-1,j,2)
     :                         +dat(i-1, k , j ,2)+dat(i-1,k-1,j,2) ) )
            trm(i,j,5) =   wk ( i , k , j ,5)
            trm(i,j,6) =
     :          -0.125*( ( wk (i+1, k , j ,2)+wk ( i , k , j ,2) )
     :                  *( dat(i+1, k , j ,1)+dat(i+1,k-1, j ,1)
     :                    +dat( i , k , j ,1)+dat( i ,k-1, j ,1) )
     :                  -( wk ( i , k , j ,2)+wk (i-1, k , j ,2) )
     :                  *( dat( i , k , j ,1)+dat( i ,k-1, j ,1)
     :                    +dat(i-1, k , j ,1)+dat( i ,k-1, j ,1) ) )/dx
     :          -0.125*( ( wk ( i , k ,j+1,2)+wk ( i , k , j ,2) )
     :                  *( dat( i , k ,j+1,2)+dat( i ,k-1,j+1,2)
     :                    +dat(i-1, k ,j+1,2)+dat(i-1,k-1,j+1,2) )
     :                  -( wk ( i , k , j ,2)+wk ( i , k ,j-1,2) )
     :                  *( dat( i , k , j ,2)+dat( i ,k-1, j ,2)
     :                    +dat(i-1, k , j ,2)+dat(i-1,k-1, j ,2) ) )/dy
     :          -0.125*( ( wk ( i ,k+1, j ,2)+wk ( i , k , j ,2) )
     :                  *( dat( i ,k+1, j ,3)+dat(i-1,k+1, j ,3)
     :                    +dat( i , k , j ,3)+dat(i-1, k , j ,3) )
     :                  -( wk ( i , k , j ,2)+wk ( i ,k-1, j ,2) )
     :                  *( dat( i , k , j ,3)+dat(i-1, k , j ,3)
     :                    +dat( i ,k-1, j ,3)+dat(i-1,k-1, j ,3) ) )/dz
          end do
          end do
c
          call xaverage( 1,0,trm(1,1,1),mx,nx,ny, 2,nx-1, 2,ny-1, xav )
          call xaverage( 1,0,trm(1,1,1),mx,nx,ny,ist,ied,jst,jed, yav )
          vpro(k,1,2) = yav -xav
          call xaverage( 1,1,trm(1,1,2),mx,nx,ny, 2,nx-1, 2,ny-1, xav )
          call xaverage( 1,1,trm(1,1,2),mx,nx,ny,ist,ied,jst,jed, yav )
          vpro(k,2,2) = yav -xav
          call xaverage( 1,0,trm(1,1,3),mx,nx,ny,ist,ied,jst,jed, yav )
          vpro(k,3,2) = yav *9.81/tref
          call xaverage( 1,1,trm(1,1,4),mx,nx,ny, 2,nx-1, 2,ny-1, xav )
          call xaverage( 1,1,trm(1,1,4),mx,nx,ny,ist,ied,jst,jed, yav )
          vpro(k,4,2) = yav -xav
          call xaverage( 1,0,trm(1,1,5),mx,nx,ny, 2,nx-1, 2,ny-1, xav )
          call xaverage( 1,0,trm(1,1,5),mx,nx,ny,ist,ied,jst,jed, yav )
          vpro(k,5,2) = yav -xav
          call xaverage( 1,0,trm(1,1,6),mx,nx,ny, 2,nx-1, 2,ny-1, xav )
          call xaverage( 1,0,trm(1,1,6),mx,nx,ny,ist,ied,jst,jed, yav )
          vpro(k,6,2) = yav -xav
        end do
c
c  ***  for zeta  ***
        do k = 1,nz
          do j = 2,ny-1
          do i = 2,nx-1
            del =        0.25*( dat( i ,k+1, j ,3)-dat( i ,k, j ,3)
     :                         +dat(i-1,k+1, j ,3)-dat(i-1,k, j ,3)
     :                         +dat( i ,k+1,j-1,3)-dat( i ,k,j-1,3)
     :                         +dat(i-1,k+1,j-1,3)-dat(i-1,k,j-1,3) )/dz
c
            trm(i,j,1) =        wk ( i , k , j ,3)*del
            trm(i,j,2) = 0.25*( wk ( i , k , j ,1)+wk (i-1,k, j ,1) )
     :                       *( dat( i , k , j ,3)-dat(i-1,k, j ,3)
     :                         +dat( i , k ,j-1,3)-dat(i-1,k,j-1,3) )/dx
     :                  +0.25*( wk ( i , k , j ,2)+wk ( i ,k,j-1,2) )
     :                       *( dat( i , k , j ,3)-dat( i ,k,j-1,3)
     :                         +dat(i-1, k , j ,3)-dat(i-1,k,j-1,3) )/dy
            trm(i,j,4) = del *( fs
     :              +rrd*0.5 *( dat( i , k , j ,2)+dat(i-1,k, j ,2) ) )
     :                  -     ( dat( i , k , j ,2)-dat(i-1,k, j ,2) )/dx
     :              *rrd*0.5 *( dat( i , k , j ,1)+dat( i ,k,j-1,1) )
     :                  -0.25*( dat( i , k ,j+1,2)-dat( i ,k,j-1,2)
     :                         +dat(i-1, k ,j+1,2)-dat(i-1,k,j-1,2) )/dy
     :              *rrd*0.5 *( dat( i , k , j ,2)+dat(i-1,k, j ,2) )
            trm(i,j,5) =   wk ( i , k , j ,6)
            trm(i,j,6) =
     :          -0.125*( ( wk (i+1, k , j ,3)+wk ( i , k , j ,3) )
     :                  *( dat(i+1, k , j ,1)+dat(i+1, k ,j-1,1)
     :                    +dat( i , k , j ,1)+dat( i , k ,j-1,1) )
     :                  -( wk ( i , k , j ,3)+wk (i-1, k , j ,3) )
     :                  *( dat( i , k , j ,1)+dat( i , k ,j-1,1)
     :                    +dat(i-1, k , j ,1)+dat(i-1, k ,j-1,1) ) )/dx
     :          -0.125*( ( wk ( i , k ,j+1,3)+wk ( i , k , j ,3) )
     :                  *( dat( i , k ,j+1,2)+dat(i-1, k ,j+1,2)
     :                    +dat( i , k , j ,2)+dat(i-1, k , j ,2) )
     :                  -( wk ( i , k , j ,3)+wk ( i , k ,j-1,3) )
     :                  *( dat( i , k , j ,2)+dat(i-1, k , j ,2)
     :                    +dat( i , k ,j-1,2)+dat(i-1, k ,j-1,2) ) )/dy
     :          -0.125*( ( wk ( i ,k+1, j ,3)+wk ( i , k , j ,3) )
     :                  *( dat( i ,k+1, j ,3)+dat( i ,k+1,j-1,3)
     :                    +dat(i-1,k+1, j ,3)+dat(i-1,k+1,j-1,3) )
     :                  -( wk ( i , k , j ,3)+wk ( i ,k-1, j ,3) )
     :                  *( dat( i , k , j ,3)+dat( i , k ,j-1,3)
     :                    +dat(i-1, k , j ,3)+dat(i-1, k ,j-1,3) ) )/dz
          end do
          end do
c
          call xaverage( 1,1,trm(1,1,1),mx,nx,ny, 2,nx-1, 2,ny-1, xav )
          call xaverage( 1,1,trm(1,1,1),mx,nx,ny,ist,ied,jst,jed, yav )
          vpro(k,1,3) = yav -xav
          call xaverage( 1,1,trm(1,1,2),mx,nx,ny, 2,nx-1, 2,ny-1, xav )
          call xaverage( 1,1,trm(1,1,2),mx,nx,ny,ist,ied,jst,jed, yav )
          vpro(k,2,3) = yav -xav
          call xaverage( 1,1,trm(1,1,4),mx,nx,ny, 2,nx-1, 2,ny-1, xav )
          call xaverage( 1,1,trm(1,1,4),mx,nx,ny,ist,ied,jst,jed, yav )
          vpro(k,4,3) = yav -xav
          call xaverage( 1,1,trm(1,1,5),mx,nx,ny, 2,nx-1, 2,ny-1, xav )
          call xaverage( 1,1,trm(1,1,5),mx,nx,ny,ist,ied,jst,jed, yav )
          vpro(k,5,3) = yav -xav
          call xaverage( 1,1,trm(1,1,6),mx,nx,ny, 2,nx-1, 2,ny-1, xav )
          call xaverage( 1,1,trm(1,1,6),mx,nx,ny,ist,ied,jst,jed, yav )
          vpro(k,6,3) = yav -xav
        end do
c
        do l = 1,mt
        do m = 1,me
        do k = 1,mz
          vpro(k,l,m) = vpro(k,l,m) * 1.0e5
        end do
        end do
        end do
c
      wx   = 6.0
      wy   = 8.0
      shft = 0.2
c
      xmv  = wx +0.6
      x0   = 4.5
      y0   = 7.0
c
      kz   = nz
c     kz   = 40
      zmax = dz * kz
      lbz  = nint( zmax/100.0 ) +400
c
      write(l_lab(1:2),'(i2.2)') jhour
c
cx    call winnam( 'Budget' )
      call winfac( 2.5 )
      call plots ( 0.0, 0.0, -2 )
      call factor( 10.0 )
      call plot  (  x0,  y0, -3 )
      call newfnt( 4 )
c
        scl = ( xend-xsta )/mod(lbx,100)*max(lbx/100,2)
                                      lnx  = -1
                                      lny  = -1
        if ( scl .ne. int(scl)      ) lnx  =  1
c
      do m = 1,me
        if ( m   .gt. 1             ) lny  = -9
c
        call newpen( 3 )
        call symbol( 0.80,  wy-1.0, 0.60, s_lab (m), 0.0,  3 )
        call symbol( wx-0.6,wy-1.0, 0.45, l_lab,     0.0,208 )
        if ( m .eq. 1 )
     :  call symbol(-1.50,  wy*0.5, 0.50, z_lab,    90.0,110 )
        call symbol( 0.5*wx, -1.20, 0.50, e_lab (m), 0.0,120 )
        call graph ( wx, wy, xsta, xend, 0.0, zmax, facx, facy,
     :        lbx,lbz,lnx,lny, '      ', '      ', 0, 999.0, shft )
c
        if ( xsta .lt. 0.0 ) then
          call newpen( 0 )
          call plot  ( -xsta*facx, 0.0, 3 )
          call plot  ( -xsta*facx,  wy, 2 )
        end if
c
        call rclip( 1, 0.0, 0.0, wx, wy )
c
c       do l = 1,mt
        do l = 1,5
          if ( t_lab(l,m)(1:1) .eq. ' ' ) cycle
c
          call newpen( newp(l) )
c
            call plot  (0.6,wy-l*0.5-1.3+ypls, 3)
            call plot  (1.3,wy-l*0.5-1.3+ypls, 2)
            call symbol(1.5,wy-l*0.5-1.3+ypls,0.45,t_lab(l,m),0.0,305)
c
                          zst = 1.0
          if ( l .ge. 3 ) zst = 0.5
c
          do k = 2,kz
            xx(k) = ( vpro(k,l,m)-xsta )*facx
            yy(k) = ( k-zst )*dz        *facy +shft
          end do
c
          call polygn( xx(2), yy(2), kz-1, 0 )
c
        end do
c
        call rclip( 0, 0.0, 0.0, wx, wy )
c
          call plot (  xmv,  0.0, -3 )
c
      end do
c
      call cls  ( 1 )
      call plote
c
      stop
      end
c
      subroutine  xaverage ( iw, jw, x, mx, nx, ny,
     :                       ist, ied, jst, jed, xav )
c
c     iw, jw : = 0; x is defined at the center of the grid
c              = 1; x is defined on the wall of the grid
c
      double precision  x (mx,*), ave
c
      rsum = 1.0/max( real((ied-ist+1)*(jed-jst+1)), 1.0 )
      ave  = 0.0
c
      do j = jst,jed
      do i = ist,ied
        ipiw = i +iw
        jpjw = j +jw
        if ( ipiw .ge. nx ) ipiw = ipiw -nx +2
        if ( jpjw .ge. ny ) jpjw = jpjw -ny +2
c
        ave = ave +x (ipiw,jpjw) +x (ipiw,j   )
     :            +x (i   ,jpjw) +x (i   ,j   )
      end do
      end do
c
      xav = ave * 0.25 * rsum
c
      return
      end
