c **********************************************************************
c *   Horizontal distributions of quantities at a height specified     *
c *                                                                    *
c *                                   May/2005  M. Nakanishi (N.D.A)   *
c **********************************************************************
c
      include  "sub/contln.f"
      include  "sub/scale.f"
      include  "sub/vector.f"
      include  "../src/Parameter.h"
c
      parameter ( mf=5, me=6, mv=11, mvh=mv/2 )
      character (len=4)  :: f_name(mf), e_lab (me)
      character (len=3)  :: s_lab (me)
      character (len=22) :: z_lab
      character (len=5)  :: r_name
      double precision  dat(mx,mz,my), ave
      dimension  hdis(mx,my,me), vint(me)
      dimension  vave(me), vmax(me), vmin(me),  xx(mx,me), yy(my,me)
      dimension  val(mv,me), iro(mv)
      data  iro /mv*-1/
c
      data  f_name/ 'u___', 'v___', 'w___', 't___', 'ql__'/
      data  e_lab / 'u   ', 'v   ', 'w   ', '$#q ', '$q_l', '$#z '/
      data  s_lab /  '(a)',  '(b)',  '(c)',  '(d)',  '(e)',  '(f)'/
      data  z_lab / 'z =0000m  at  0000 LST'/
c
      namelist  /les1/  nrun, nstep,  iout,  jout,  lout
      namelist  /les2/  isgs,  isfc,  irad,  icon,  isca,
     :                  jmin,  rlat,    dt,    dx,    dy,    dz,
     :                         ugsf,  vgsf,         aglw,  agmd,
     :                  gulw,  gvlw,  gumd,  gvmd,
     :                  tref,   tsf,   qsf,   psf,  hglw,  hgmd,
     :                  gtlw,  gqlw,  gtmd,  gqmd,  gamt,  gamq,
     :                   z0m,   z0h,  tfmx,  qfmx, phour, dhour,
     :                 tdeep,  swet,  crso,  fkso,
     :                  elat,  albd,  clov,  ulov,
     :                 nflay, frate,
     :                  nspl,  nspu,   csp, nstot
c
      write(6,*) 'Run + Restart number (xx.xx) =?'
      read (5,'(a)')  r_name
      write(6,*) 'Vertical grid number =?'
      read (5,*)  izplt, idmy, itplt
      write(6,*) 'Skip'
      read (5,*)
      write(6,*) 'Contour intervals for u, v, ..., zeta =?'
      read (5,*) ( vint(i),i=1,me )
c
      open (10,file='para'//r_name,status='old',iostat=ios)
      if ( ios .ne. 0 ) stop 'Para-file not found.'
c
      read (10,nml=les1)
      read (10,nml=les2)
      close(10)
c
      ne = me
c
      rsum = 1.0/dble((nx-2)*(ny-2))
c
      do m = 1,mf
        open (11,file=f_name(m)//r_name,form='unformatted',
     :           status='old',iostat=ios)
        if ( ios .ne. 0 ) then
          ne = m -1
          exit
        end if
c
        do it = 1,itplt
          read (11,end=100) dat
        end do
c
  100   itplt = it -1
c
        close(11)
c
                                     ad = 0.0
        if ( f_name(m) .eq. 'w___' ) ad = 0.5
                                     bd = 1.0 -ad
c
          ave     =  0.0
          vmax(m) = -1.0e10
          vmin(m) =  1.0e10
        do j = 2,ny-1
        do i = 2,nx-1
          dd      = ad*dat(i,izplt+1,j) + bd*dat(i,izplt,j)
          ave     =      ave     +dd
          vmax(m) = max( vmax(m), dd )
          vmin(m) = min( vmin(m), dd )
        end do
        end do
          vave(m) = ave     * rsum
          vmax(m) = vmax(m) - vave(m)
          vmin(m) = vmin(m) - vave(m)
c
        do j = 1,ny
        do i = 1,nx
          dd      = ad*dat(i,izplt+1,j) + bd*dat(i,izplt,j)
          hdis(i,j,m) = dd - vave(m)
        end do
        end do
c
        if ( f_name(m) .eq. 't___' ) vave(m) = vave(m) +tref
      end do
c
          vmax(6) = -1.0e10
          vmin(6) =  1.0e10
        do j = 2,ny
        do i = 2,nx
          hdis(i,j,6) = ( hdis(i,j,2)-hdis(i-1, j ,2) ) / dx
     :                 -( hdis(i,j,1)-hdis( i ,j-1,1) ) / dy
          vmax(6) = max( vmax(6), hdis(i,j,6) )
          vmin(6) = min( vmin(6), hdis(i,j,6) )
        end do
        end do
          vave(6) = 0.0
c
        do j = 1,ny
          hdis(1,j,6) = hdis(nx-1,   j,6)
        end do
        do i = 1,nx
          hdis(i,1,6) = hdis(   i,ny-1,6)
        end do
c
      wx   = 7.4
      wy   = wx*( dy*(ny-2) )/( dx*(nx-2) )
c
      xmv  = wx +2.1
      ymv  = wy +2.2
      x0   =  2.2
      y0   = 19.5
c
      do m = 1,me
        if ( vint(m) .gt. 0.0 ) then
          del  = vint(m)
        else
          del  = max( vmax(m), -vmin(m) ) / dble(mvh)
          vl   = log10( del )
          colm = 10.0**( int(vl)-1+int(vl-int(vl)+1) )
          del  = colm*int( del/colm*2.0 )/2.0
        end if
c
        do i = 1,mv
          val(i,m) = del*(i-mvh-1)
        end do
        write(6,*) e_lab(m), ' ave,max,min,del =',
     :             vave(m), vmax(m), vmin(m), del
      end do
c
      facx = wx/( dx*(nx-2) )
      facy = wy/( dy*(ny-2) )
      fkm  = 1000.0
      scx  = nint( dx*(nx-2)/(5.0*fkm) )
c
      do m = 1,me
        dfx = 1.5
        dfy = 1.5
        if ( e_lab(m) .eq. 'u   ' .or. e_lab(m) .eq. '$#z ' ) dfx = 2.0
        if ( e_lab(m) .eq. 'v   ' .or. e_lab(m) .eq. '$#z ' ) dfy = 2.0
      do i = 1,nx
        xx(i,m) = dx*( i-dfx ) * facx
      end do
      do j = 1,ny
        yy(j,m) = dy*( j-dfy ) * facy
      end do
      end do
c
      itplt = jmin +nint(itplt*jout*dt)/60
      write(z_lab( 4: 7),'(i4)'  ) nint( dz*(izplt-0.5) )
      write(z_lab(15:18),'(i4.4)') itplt/60*100+mod(itplt,60)
      th = atan2( vave(2), vave(1) )
c
cx    call winnam( 'Horizontal' )
      call winfac( 2.0 )
      call plots ( 0.0, 0.0,  2 )
      call factor( 10.0 )
      call plot  (  x0,  y0, -3 )
      call newfnt( 4 )
c
      n  = 0
c
      do m = 1,ne
        n  = n +1
c
        call newpen( 3 )
        call symbol(    0.2, wy+0.3, 0.48, s_lab(n), 0.0,  3 )
        call symbol(    1.0, wy+0.3, 0.48, e_lab(m), 0.0,  4 )
        call symbol( wx-1.0, wy+0.3, 0.40, z_lab,    0.0,222 )
        call symbol(   -1.1, wy*0.5, 0.40, 'y (km)',90.0,106 )
        call symbol(   0.5*wx,-1.05, 0.40, 'x (km)', 0.0,106 )
        call rect  ( 0.0, 0.0, wx, wy, 0.0, 0 )
c
        call sscale( 0.0,0.0, scx,dx*(nx-2)/fkm,facx*fkm, 0.36, 0 )
        call sscale( 0.0,0.0, scx,dy*(ny-2)/fkm,facy*fkm, 0.36,-1 )
c
        call newpen( 2 )
        call vector( wx-0.45, wy+0.45, cos(th), sin(th), 0.5, 1 )
c
        call rclip ( 1, 0.0, 0.0, wx, wy )
c
        if ( m .ne. 6 ) then
        call contln( hdis(1,1,m), mx, nx, ny, xx(1,m), yy(1,m),
     :               0.0, -1, 1, 0.25, -1, 0 )
        end if
        call newpen( 0 )
        call contln( hdis(1,1,m), mx, nx, ny, xx(1,m), yy(1,m),
     :               val(mvh+2,m), iro(mvh+2), mv-mvh-1, 0.25, 2, 0 )
        call newpen( 50 )
        call contln( hdis(1,1,m), mx, nx, ny, xx(1,m), yy(1,m),
     :               val(1,m),     iro,        mvh, 0.25, 2, 0 )
c
        call rclip ( 0, 0.0, 0.0, wx, wy )
c
        if ( mod(n,2) .eq. 1 ) then
          call plot (  xmv,  0.0, -3 )
        else
          call plot ( -xmv, -ymv, -3 )
        end if
      end do
c
      call cls  ( 1 )
      call plote
c
      stop
      end
