c **********************************************************************
c *   Vertical profiles of horizontally-averaged quantities            *
c *                                                                    *
c *                                   May/2005  M. Nakanishi (N.D.A)   *
c **********************************************************************
c
      include  "sub/graph.f"
      include  "../src/Parameter.h"
c
      parameter ( me=6 )
      character (len=4)  :: e_name(me)
      character (len=5)  :: r_name
      character (len=10) :: z_lab
      double precision  dat(mx,mz,my)
      dimension  vpro(mz,me)
      dimension  xsta(me), xdel(me),  xx(mz), yy(mz)
c
      data  e_name/ 'u___', 'v___', 'w___', 't___', 'q___', 'ql__'/
      data  z_lab / 'Height (m)'/
      data  xsta  /-20.0,  0.0, -0.4,  0.0,  0.0,  0.0/
      data  xdel  / 40.0, 40.0,  1.0, 20.0, 10.0,  1.0/
c
      namelist  /les2/  isgs,  isfc,  irad,  icon,  isca,
     :                  jmin,  rlat,    dt,    dx,    dy,    dz,
     :                         ugsf,  vgsf,         aglw,  agmd,
     :                  gulw,  gvlw,  gumd,  gvmd,
     :                  tref,   tsf,   qsf,   psf,  hglw,  hgmd,
     :                  gtlw,  gqlw,  gtmd,  gqmd,  gamt,  gamq,
     :                   z0m,   z0h,  tfmx,  qfmx, phour, dhour,
     :                 tdeep,  swet,  crso,  fkso,
     :                  elat,  albd,  clov,  ulov,
     :                 nflay, frate,
     :                  nspl,  nspu,   csp, nstot
c
      write(6,*) 'Run + Restart number (xx.xx) =?'
      read (5,'(a)')  r_name
      read (5,*)  idmy, idmy, itplt
c
      open (10,file='para'//r_name,status='old',iostat=ios)
      if ( ios .ne. 0 ) stop
c
      read (10,nml=les2)
      close(10)
c
      do m = 1,me
      do k = 1,mz
        vpro(k,m) = 0.0
      end do
      end do
c
      xsta(4) = int( tref ) - 0.5*xdel(4)
c
      rsum = 1.0/dble((nx-2)*(ny-2))
c
      do m = 1,me
        open (11,file=e_name(m)//r_name,form='unformatted',
     :           status='old',iostat=ios)
        if ( ios .ne. 0 ) cycle
c
        do it = 1,itplt
          read (11,end=100) dat
        end do
c
  100   close(11)
c
        do k = 1,nz
          ave = 0.0
        do j = 2,ny-1
        do i = 2,nx-1
          ave = ave +dat(i,k,j)
        end do
        end do
          vpro(k,m) = ave * rsum
c
          if ( e_name(m) .eq. 't___' ) vpro(k,m) = vpro(k,m) +tref
          if ( e_name(m) .eq. 'q___' ) vpro(k,m) = vpro(k,m)*1.0e3
        end do
c
      end do
c
c  #####
      do k = 2,6
        write(6,*) 'k, z*du/dz, t =', k,
     :       (k-1)*sqrt( ( vpro(k,1)-vpro(k-1,1) )**2
     :                  +( vpro(k,2)-vpro(k-1,2) )**2 ), vpro(k,4)
      end do
c  #####
c
      wx   = 6.0
      wy   = 6.0
      shft = 0.2
c
      xmv  = wx +2.0
      ymv  = wy +2.0
      x0   =  3.5
      y0   = 20.0
c
      zmax = dz * nz
      zdel = zmax/10.0
      colm = 10.0**int( log10( zdel ) )
      lbz  = zmax/( colm*int( zdel/colm ) )
c     lbz  = 10
c
cx    call winnam( 'Profile' )
      call winfac( 2.0 )
      call plots ( 0.0, 0.0,  2 )
      call factor( 10.0 )
      call plot  (  x0,  y0, -3 )
      call newfnt( 4 )
c
      do m = 1,me
        xend = xsta(m) + xdel(m)
c
        call newpen( 2 )
        call symbol( 0.5, wy+0.2, 0.45, e_name(m), 0.0, 2 )
        call graph ( wx, wy, xsta(m), xend, 0.0, zmax, facx, facy,
     :         10, lbz, 1, 1, '      ', '      ', 0, 999.0, shft )
c
        if ( xsta(m) .lt. 0.0 ) then
          call newpen( 0 )
          call plot  ( -xsta(m)*facx, 0.0, 3 )
          call plot  ( -xsta(m)*facx,  wy, 2 )
        end if
c
        do k = 1,nz
          xx(k) = ( vpro(k,m)-xsta(m) )*facx
          yy(k) = ( k-0.5 )*dz         *facy +shft
        end do
c
        call newpen( 4 )
        call polygn( xx, yy, nz, 0 )
c
        if ( mod(m,2) .eq. 1 ) then
          call plot (  xmv,  0.0, -3 )
        else
          call plot ( -xmv, -ymv, -3 )
        end if
c
      end do
c
      call cls  ( 1 )
      call plote
c
      stop
      end
