c **********************************************************************
c *   Vertical profiles of horizontally-averaged quantities (2)        *
c *                                                                    *
c *                                   Sep/2005  M. Nakanishi (N.D.A)   *
c **********************************************************************
c
      include  "sub/graph.f"
      include  "sub/ziestm.f"
      include  "sub/epestm.f"
      include  "sub/fsestm.f"
      include  "sub/fmestm.f"
      include  "../src/Parameter.h"
c
      parameter ( mf=8, mg=2, me=16, mt=5 )
      character (len=4)  :: f_name(mf+mg), t_lab
      character (len=25) :: e_lab (me)
      character (len=3)  :: s_lab (2)
      character (len=10) :: z_lab
      character (len=5)  :: r_name
      character (len=30) :: line
      double precision  dat(mx,mz,my,mf), da2(mx,my,mg)
      double precision  wk (mx,mz,my, 6), uav(mz), vav(mz)
      double precision  av0, av1, av2, av3
      dimension  vpro(mz,mt,me)
      dimension  xsta(me), xend(me), lbx(me),  xx(mz), yy(mz)
      dimension  newp(mt), ihour(mt)
c
      data  f_name/ 't___', 'q___', 'u___', 'v___', 'w___',
     :              'fm__', 'fh__', 'fub_', 'flt_', 'flq_'/
      data  e_lab / '$Potential temp. (#6C)   ',
     :              '$Water vapor (g kg^-^1)  ',
     :              '$U component (m s^-^1)   ',
     :              '$V component (m s^-^1)   ',
     :              '$<w#q> (10^-^2 K m s^-^1)',
     :              '$<wq_v> (10^-^5 m s^-^1) ',
     :              '$<uw> (m^2 s^-^2)        ',
     :              '$<vw> (m^2 s^-^2)        ',
     :              '$TKE (m^2 s^-^2)         ',
     :              'Length scale (m)         ',
     :              '$<u^2>/u_*^2             ',
     :              '$<u^3>/u_*^3             ',
     :              '$<v^2>/u_*^2             ',
     :              '$<v^3>/u_*^3             ',
     :              '$<w^2>/u_*^2             ',
     :              '$<w^3>/u_*^3             '/
cx   :              '$<w^3>/<w^2>^3^/^2       '/
      data  s_lab /  '(a)',  '(b)'/
      data  z_lab / 'Height (m)'/, t_lab /'  00'/
      data  newp  /   4,  14,  54,  34,  44/
c
      namelist  /les1/  nrun, nstep,  iout,  jout,  lout
      namelist  /les2/  isgs,  isfc,  irad,  icon,  isca,
     :                  jmin,  rlat,    dt,    dx,    dy,    dz,
     :                         ugsf,  vgsf,         aglw,  agmd,
     :                  gulw,  gvlw,  gumd,  gvmd,
     :                  tref,   tsf,   qsf,   psf,  hglw,  hgmd,
     :                  gtlw,  gqlw,  gtmd,  gqmd,  gamt,  gamq,
     :                   z0m,   z0h,  tfmx,  qfmx, phour, dhour,
     :                 tdeep,  swet,  crso,  fkso,
     :                  elat,  albd,  clov,  ulov,
     :                 nflay, frate,
     :                  nspl,  nspu,   csp, nstot
c
      open (1,file='/home/naka/les_for_es/figure/meanscale.dat')
        ne = 0
      do i = 1,999
        read (1,'(a)',end=10) line
        if ( line(1:1) .ne. 'M' ) cycle
        ne = ne +1
        read (line(10:30),*) xsta(ne), xend(ne), lbx(ne)
        if ( ne        .eq. me  ) exit
      end do
   10 close(1)
c
      write(6,*) 'Run + Restart number (xx.xx) =?'
      read (5,'(a)')  r_name
      write(6,*) 'Skip'
      read (5,*)
      write(6,*) 'Plot (number and hours; up to 5 hours) =?'
      read (5,*)  nt, ( ihour(i),i=1,nt )
c
      open (10,file='para'//r_name,status='old',iostat=ios)
      if ( ios .ne. 0 ) stop 'Para-file not found.'
c
      read (10,nml=les1)
      read (10,nml=les2)
      close(10)
c
      rsum = 1.0/dble((nx-2)*(ny-2))
c
      tpls = tref -273.15
      cel  =( 0.1*(dx*dy*dz)**(1.0/3.0) )**2
c
      do m = 1,mf+mg
        open (m+10,file=f_name(m)//r_name,form='unformatted',
     :             status='old',iostat=ios)
        if ( ios .ne. 0 ) stop 'Data-file not found.'
      end do
c
      do ll = 1,999
        jhour = ( jmin +nint(ll*jout*dt)/60 )/60
c
        do m = 1,mf
          read (m+10,   end=200) (((dat(i,k,j,m),i=1,mx),k=1,mz),j=1,my)
        end do
        do m = 1,mg
          read (m+10+mf,end=200) ( (da2(i,  j,m),i=1,mx),        j=1,my)
        end do
c
        do l = 1,nt
          if ( jhour .eq. ihour(l) ) goto 100
        end do
        cycle
c
  100   continue
c
        do m = 1,4
        do k = 1,nz
          av1 = 0.0
          do j = 2,ny-1
          do i = 2,nx-1
            av1 = av1 +dat(i,k,j,m)
          end do
          end do
c
          vpro(k,l,m) = av1 * rsum
        end do
        end do
c
        call fsestm( 1, dat(1,1,1,1), dat(1,1,1,5), dat(1,1,1,7),
     :               mx, mz, nx, nz, ny, dx, dz, dy,
     :               vpro(1,l,5) )
        call fsestm( 1, dat(1,1,1,2), dat(1,1,1,5), dat(1,1,1,7),
     :               mx, mz, nx, nz, ny, dx, dz, dy,
     :               vpro(1,l,6) )
        call fmestm( 1, dat(1,1,1,3), dat(1,1,1,4), dat(1,1,1,5),
     :                  dat(1,1,1,6),
     :               mx, mz, nx, nz, ny, dx, dz, dy, cel,
     :               uav, vav, vpro(1,l,7), vpro(1,l,8),
     :               vpro(1,l,11), vpro(1,l,13), vpro(1,l,15),
     :               vpro(1,l,12), vpro(1,l,14), vpro(1,l,16) )
c
        av0 = 0.0
        av1 = 0.0
        av2 = 0.0
        av3 = 0.0
        do j = 2,ny-1
        do i = 2,nx-1
          av0 = av0 +da2(i,j,1)
          av1 = av1 +da2(i,j,2)
          av2 = av2 +da2(i,j,1)*( 0.61*  dat(i,1,j,2) + 1.0  )
          av3 = av3 +da2(i,j,2)*  0.61*( dat(i,1,j,1) + tref )
        end do
        end do
c
        vpro(1,l,5) = av0 * rsum
        vpro(1,l,6) = av1 * rsum
        bpro = av2*rsum + av3*rsum
        ust  = dat(1,nz+1,1,mf)
c
        th   = atan2( vav(1), uav(1) )
        vpro(1,l,7) = -ust**2 * cos(th)
        vpro(1,l,8) = -ust**2 * sin(th)
c
        call ziestm( vpro(1,l,5),nz, dz, 9.81,tref,ust, zi,wst,rate )
c
        if ( bpro .gt. 0.0 ) wst = ( 9.81/tref*bpro*zi )**( 1.0/3.0 )
        write(6,*) 'zi,ust,wst,erate =', zi, ust, wst, rate
c       write(6,*) 'zi,wst,flx,erate =', zi, wst, vpro(1,l,5), rate
c
        call epestm( 1, dat(1,1,1,3), dat(1,1,1,4), dat(1,1,1,5),
     :                  dat(1,1,1,1), dat(1,1,1,6), dat(1,1,1,7),
     :               mx, mz, nx, nz, ny, dx, dz, dy, 9.81, tref,
     :               wk (1,1,1,1), wk (1,1,1,2), wk (1,1,1,3),
     :               wk (1,1,1,4), wk (1,1,1,5), wk (1,1,1,6),
     :               uav, vav, vpro(1,l,10) )
c
        do k = 1,nz
          vpro(k,l, 1) = vpro(k,l,1) +tpls
          vpro(k,l, 2) = vpro(k,l,2) *1.0e3
          vpro(k,l, 5) = vpro(k,l,5) *1.0e2
          vpro(k,l, 6) = vpro(k,l,6) *1.0e5
          vpro(k,l, 9) = 0.5*(vpro(k,l,11)+vpro(k,l,13)+vpro(k,l,15))
          vpro(k,l,10) = (  2.0*     vpro(k,l, 9) )**1.5
     :                  /( 24.0*max(-vpro(k,l,10),2.5e-4) )
c
          do m = 11,15,2
            vpro(k,l, m) = vpro(k,l,m) / ust**2
          end do
          do m = 12,16,2
            vpro(k,l, m) = vpro(k,l,m) / ust**3
          end do
cx          vpro(k,l,16) = av3*rsum
cx   :                  /( max(vpro(k,l,15)*ust**2,1.0e-10) )**1.5
        end do
c
          vpro(1,l,10) = vpro(2,l,10) / 3.0
c
      end do
c
  200 continue
c
      wx   = 6.0
      wy   = 8.0
      shft = 0.2
c
      xmv  = wx +1.6
      x0   = 4.5
      y0   = 7.0
c
      kz   = nz
c     kz   = 40
      zmax = dz * kz
      lbz  = nint( zmax/100.0 ) +400
c
cx    call winnam( 'Profile' )
      call winfac( 2.5 )
      call plots ( 0.0, 0.0,  2 )
      call factor( 10.0 )
      call plot  (  x0,  y0, -3 )
      call newfnt( 4 )
c
      do m = 1,ne
        mm = mod(m-1,2) +1
                                       lsta = 1
                                       xpls = 0.0
                                       ypls = 0.0
        if ( m .ge. 5 .and. m .le. 8 ) xpls = 2.95
                                       zst  = 0.5
        if ( m .ge. 5 .and. m .le. 8 ) zst  = 1.0
c
        scl = ( xend(m)-xsta(m) )/mod(lbx(m),100)*max(lbx(m)/100,2)
                                      lnx  = -1
        if ( scl .ne. int(scl)      ) lnx  =  1
c
        call newpen( 3 )
        call symbol( 0.80+xpls, wy-1.0, 0.60, s_lab (mm), 0.0,  3 )
        if ( mod(m,2) .eq. 1 )
     :  call symbol(-1.50, wy*0.5, 0.50, z_lab,    90.0,110 )
        call symbol( 0.5*wx,-1.20, 0.50, e_lab (m), 0.0,125 )
        call graph ( wx, wy, xsta(m), xend(m), 0.0, zmax, facx, facy,
     :        lbx(m),lbz,lnx,-1, '      ', '      ', 0, 999.0, shft )
c
        if ( xsta(m) .lt. 0.0 ) then
          call newpen( 0 )
          call plot  ( -xsta(m)*facx, 0.0, 3 )
          call plot  ( -xsta(m)*facx,  wy, 2 )
        end if
c
        do l = lsta,nt
        ll = l -lsta +1
          call newpen( newp(l) )
c
          if ( mod(m,2) .eq. 1 ) then
            write(t_lab(1:2),'(i2.2)') ihour(l)
            call plot  (0.6+xpls,wy-ll*0.5-1.3+ypls, 3)
            call plot  (1.3+xpls,wy-ll*0.5-1.3+ypls, 2)
            call symbol(1.5+xpls,wy-ll*0.5-1.3+ypls,0.45,t_lab,0.0,304)
          end if
c
          do k = 1,kz
            xx(k) = ( vpro(k,l,m)-xsta(m) )*facx
            yy(k) = ( k-zst )*dz           *facy +shft
          end do
c
          call polygn( xx, yy, kz, 0 )
c
        end do
c
        if ( mod(m,2) .eq. 1 ) then
          call plot (  xmv,  0.0, -3 )
        else
          call plot ( -xmv,  0.0, -3 )
          call cls  ( 1 )
        end if
c
      end do
c
      call plote
c
      stop
      end
