c **********************************************************************
c *   Vertical profiles of horizontally-averaged quantities (2)        *
c *                                                                    *
c *                                   Sep/2005  M. Nakanishi (N.D.A)   *
c **********************************************************************
c
      include  "graph.f"
      include  "ziestm.f"
      include  "../src/Parameter.h"
c
      parameter ( mf=7, me=10, mt=5 )
      character (len=4)  :: f_name(mf), t_lab
      character (len=25) :: e_lab (me)
      character (len=3)  :: s_lab (me)
      character (len=10) :: z_lab
      character (len=5)  :: r_name
      double precision  dat(mx,mz,my,mf), ave, std, flx, tri, fff
      dimension  vpro(mz,mt,me)
      dimension  xsta(me), xdel(me), lbx(me),  xx(mz), yy(mz)
      dimension  newp(mt), ihour(mt)
c
      data  f_name/ 't___', 'q___', 'u___', 'v___',
     :              'fm__', 'fh__', 'w___'/
      data  e_lab / '$Potential temp. (#6C)   ',
     :              '$Water vapor (g kg^-^1)  ',
     :              '$U component (m s^-^1)   ',
     :              '$V component (m s^-^1)   ',
     :              '$TKE (m^2 s^-^2)         ',
     :              'Length scale (m)         ',
     :              '$<w#q> (10^-^2 K m s^-^1)',
     :              '$<wq_v> (10^-^5 m s^-^1) ',
     :              '$<w^2>/w_*^2             ',
     :              '$<w^3>/<w^2>^3^/^2       '/
      data  s_lab /  '(a)',  '(b)',  '(a)',  '(b)',  '(a)',  '(b)',
     :               '(a)',  '(b)',  '(a)',  '(b)'/
      data  z_lab / 'Height (m)'/, t_lab /'  00'/
      data  xsta  / 2.0, 0.0,-6.0,-4.0, 0.0, 0.0,-6.0,-2.0, 0.0,-1.0/
      data  xdel  /16.0, 5.0, 8.0, 8.0, 3.0,250.,30.0,10.0, 0.6, 3.0/
      data  lbx   / 416,  10,   8,   8,   6,  10, 315,  10,   6,   6/
      data  newp  /   4,  14,  54,  34,  44/
      data  ihour /   9,  10,  12,  14,  16/
c
      namelist  /les1/  nrun, nstep,  iout,  jout,  lout
      namelist  /les2/  isgs,  isfc,  irad,  icon,  isca,
     :                  jmin,  rlat,    dt,    dx,    dy,    dz,
     :                         ugsf,  vgsf,         aglw,  agmd,
     :                  gulw,  gvlw,  gumd,  gvmd,
     :                  tref,   tsf,   qsf,   psf,  hglw,  hgmd,
     :                  gtlw,  gqlw,  gtmd,  gqmd,  gamt,  gamq,
     :                   z0m,   z0h,  tfmx,  qfmx, dhour,
     :                 tdeep,  swet,  crso,  fkso,
     :                  elat,  albd,  clov,  ulov,
     :                 nflay, frate,
     :                  nspl,  nspu,   csp, nstot
c
      jpls = 1
c
      write(6,*) 'Run + Restart number (xx.xx) =?'
      read (5,'(a)')  r_name
c
      open (10,file='para'//r_name,status='old',iostat=ios)
      if ( ios .ne. 0 ) stop 'Para-file not found.'
c
      read (10,nml=les1)
      read (10,nml=les2)
      close(10)
c
      do m = 1,mf
        open (m+10,file=f_name(m)//r_name,form='unformatted',
     :             status='old',iostat=ios)
        if ( ios .ne. 0 ) stop 'Data-file not found.'
      end do
c
      do m = 1,me
      do l = 1,mt
      do k = 1,mz
        vpro(k,l,m) = 0.0
      end do
      end do
      end do
c
      rsum = 1.0/dble((nx-2)*(ny-2))
      tpls = tref -273.15
      cel  =( 0.1 *(dx*dy*dz)**(1.0/3.0) )**2
      sel  =( 0.18*(dx*dy*dz)**(1.0/3.0) )**4 / 24.0
c
      do ll = 1,999
        jhour = ( jmin+nint((ll-1)*jout*dt)/60 )/60 +jpls
c
        do m = 1,mf
          read (m+10,end=200) (((dat(i,k,j,m),i=1,mx),k=1,mz),j=1,my)
        end do
c
        do l = 1,mt
          if ( jhour .eq. ihour(l) ) goto 100
        end do
        cycle
c
  100   continue
c
        do m = 1,4
        do k = 1,nz
          ave = 0.0
          do j = 2,ny-1
          do i = 2,nx-1
            ave = ave +dat(i,k,j,m)
          end do
          end do
          ave = ave * rsum
c
          vpro(k,l,m) = ave
        end do
        end do
c
        do m = 3,5
        do k = 1,nz
          ave = 0.0
          std = 0.0
          do j = 2,ny-1
          do i = 2,nx-1
            ave = ave +dat(i,k,j,m)
            std = std +dat(i,k,j,m)**2
          end do
          end do
          ave = ave * rsum
          std = std * rsum
c
          if ( m .eq. 5 ) then
            vpro(k,l,5) = vpro(k,l,5) +std /cel
          else
            vpro(k,l,5) = vpro(k,l,5) +0.5*( std-ave**2 )
          end if
        end do
        end do
c
        do m = 1,2
        do k = 2,nz
          flx = 0.0
          do j = 2,ny-1
          do i = 2,nx-1
            fff =      0.5*( dat(i,k,j,6)+dat(i,k-1,j,6) )
            flx = flx +0.5*( dat(i,k,j,m)+dat(i,k-1,j,m) )*dat(i,k,j,7)
     :                -fff*( dat(i,k,j,m)-dat(i,k-1,j,m) )/dz
          end do
          end do
          flx = flx * rsum
c
          vpro(k,l,m+6) = flx
        end do
        end do
c
        if ( dhour .gt. 0.0 ) then
          chour = ihour(l) -jpls
          hcos  = cos( 1.570796*( chour-12.0 )/( 0.5*dhour ) )
          vpro(1,l,7) = tfmx*hcos
          vpro(1,l,8) = qfmx*hcos
        else
          vpro(1,l,7) = tfmx
          vpro(1,l,8) = qfmx
        end if
c
        call ziestm( vpro(1,l,7),nz, dz, 9.81,tref,ust, zi,wst,rate )
        write(6,*) 'zi,wst,erate =', zi, wst, rate
c
        do k = 1,nz
          ave = 0.0
          std = 0.0
          flx = 0.0
          tri = 0.0
          do j = 2,ny-1
          do i = 2,nx-1
            fff = 2.0*  dat(i, k ,j,5)
            ave = ave +0.125*( dat(i,k+1,j,7)+dat(i,k,j,7) )**3
            std = std +0.25 *( dat(i,k+1,j,7)+dat(i,k,j,7) )**2
            flx = flx -fff  *( dat(i,k+1,j,7)-dat(i,k,j,7) ) / dz
     :                +2.0  *  dat(i, k ,j,5)**2/( 3.0*cel )
            tri = tri +        dat(i, k ,j,5)**3
          end do
          end do
          ave = ave * rsum
          std = std * rsum
          flx = flx * rsum
          tri = tri * rsum
c
          vpro(k,l, 5) = vpro(k,l,5) +0.5*  std
          vpro(k,l, 9) =( std+flx )/wst**2
          vpro(k,l,10) = ave /( max(std+flx,1.0d-10) )**1.5
c
          vpro(k,l, 1) = vpro(k,l,1) +tpls
          vpro(k,l, 2) = vpro(k,l,2) *1.0e3
          vpro(k,l, 7) = vpro(k,l,7) *1.0e2
          vpro(k,l, 8) = vpro(k,l,8) *1.0e5
c
          vpro(k,l, 6) = sel*(2.0*vpro(k,l,5))**1.5 / max(tri,0.5)
        end do
c
      end do
c
  200 continue
c
      wx   = 6.0
      wy   = 9.0
      shft = 0.2
c
      xmv  = wx +1.6
      x0   = 5.5
      y0   = 7.0
c
      zmax = dz * nz
c     zdel = zmax/10.0
c     colm = 10.0**int( log10( zdel ) )
c     lbz  = zmax/( colm*int( zdel/colm ) )
      lbz  = 420
c
cx    call winnam( 'Profile' )
      call winfac( 2.5 )
      call plots ( 0.0, 0.0,  2 )
      call factor( 10.0 )
      call plot  (  x0,  y0, -3 )
      call newfnt( 4 )
c
      do m = 1,me
        xend = xsta(m) + xdel(m)
                        xpls = 0.0
        if ( m .eq. 3 ) xpls = 3.1
        if ( m .gt. 3 ) xpls = 3.0
                        ypls = 0.0
        if ( m .eq. 3 ) ypls =-3.0
                        ls   = 1
        if ( m .ge. 5 ) ls   = 2
                                      zs = 0.5
        if ( m .eq. 7 .or. m .eq. 8 ) zs = 1.0
                        lnx  = -1
        if ( m .ge. 9 ) lnx  =  1
c
        call newpen( 3 )
        call symbol( 0.8+xpls, wy-1.0, 0.45, s_lab (m), 0.0,  3 )
        if ( mod(m,2) .eq. 1 )
     :  call symbol(-1.4, wy*0.5, 0.45, z_lab,    90.0,110 )
        call symbol( 0.5*wx,-1.1, 0.45, e_lab (m), 0.0,125 )
        call graph ( wx, wy, xsta(m), xend, 0.0, zmax, facx, facy,
     :        lbx(m),lbz,lnx,-1, '      ', '      ', 0, 999.0, shft )
c
        if ( xsta(m) .lt. 0.0 ) then
          call newpen( 0 )
          call plot  ( -xsta(m)*facx, 0.0, 3 )
          call plot  ( -xsta(m)*facx,  wy, 2 )
        end if
c
        do l = ls,mt
        ll = l -ls +1
          call newpen( newp(l) )
c
          if ( mod(m,2) .eq. 1 ) then
            write(t_lab(1:2),'(i2.2)') ihour(l)
            call plot  ( 0.6+xpls,wy-ll*0.5-1.3+ypls, 3 )
            call plot  ( 1.3+xpls,wy-ll*0.5-1.3+ypls, 2 )
            call symbol( 1.5+xpls,wy-ll*0.5-1.4+ypls,0.4,t_lab,0.0,4 )
          end if
c
          do k = 1,nz
            xx(k) = ( vpro(k,l,m)-xsta(m) )*facx
            yy(k) = ( k-zs )*dz            *facy +shft
          end do
c
          call polygn( xx, yy, nz, 0 )
c
        end do
c
        if ( mod(m,2) .eq. 1 ) then
          call plot (  xmv,  0.0, -3 )
        else
          call plot ( -xmv,  0.0, -3 )
          call cls  ( 1 )
        end if
c
      end do
c
      call plote
c
      stop
      end
