c **********************************************************************
c *   Vertical profiles of horizontally-averaged quantities (2)        *
c *                                                                    *
c *                                   Sep/2005  M. Nakanishi (N.D.A)   *
c **********************************************************************
c
      include  "sub/graph.f"
      include  "sub/ziestm.f"
      include  "sub/epestm.f"
      include  "sub/fsestm.f"
      include  "../src/Parameter.h"
c
      parameter ( mf=8, me=12, mt=5 )
      character (len=4)  :: f_name(mf), t_lab
      character (len=25) :: e_lab (me)
      character (len=3)  :: s_lab (me)
      character (len=10) :: z_lab
      character (len=5)  :: r_name
      character (len=30) :: line
      double precision  dat(mx,mz,my,mf), av1,av2,av3,av4, uavk,vavk
      double precision  wk (mx,mz,my, 6), uav(mz), vav(mz)
      dimension  vpro(mz,mt,me)
      dimension  xsta(me), xend(me), lbx(me),  xx(mz), yy(mz)
      dimension  newp(mt), ihour(mt)
c
      data  f_name/ 't___', 'q___', 'u___', 'v___',
     :              'fm__', 'fh__', 'w___', 'fub_'/
      data  e_lab / '$Potential temp. (#6C)   ',
     :              '$Water vapor (g kg^-^1)  ',
     :              '$U component (m s^-^1)   ',
     :              '$V component (m s^-^1)   ',
     :              '$TKE (m^2 s^-^2)         ',
     :              'Length scale (m)         ',
     :              '$<w#q> (10^-^2 K m s^-^1)',
     :              '$<wq_v> (10^-^5 m s^-^1) ',
     :              '$<w^2>/w_*^2             ',
     :              '$<w^3>/w_*^3             ',
cx   :              '$<w^3>/<w^2>^3^/^2       ',
     :              '$<v^2>/w_*^2             ',
     :              '$<v^3>/w_*^3             '/
      data  s_lab /  '(a)',  '(b)',  '(a)',  '(b)',  '(a)',  '(b)',
     :               '(a)',  '(b)',  '(a)',  '(b)',  '(a)',  '(b)'/
      data  z_lab / 'Height (m)'/, t_lab /'  00'/
      data  newp  /   4,  14,  54,  34,  44/
c
      namelist  /les1/  nrun, nstep,  iout,  jout,  lout
      namelist  /les2/  isgs,  isfc,  irad,  icon,  isca,
     :                  jmin,  rlat,    dt,    dx,    dy,    dz,
     :                         ugsf,  vgsf,         aglw,  agmd,
     :                  gulw,  gvlw,  gumd,  gvmd,
     :                  tref,   tsf,   qsf,   psf,  hglw,  hgmd,
     :                  gtlw,  gqlw,  gtmd,  gqmd,  gamt,  gamq,
     :                   z0m,   z0h,  tfmx,  qfmx, phour, dhour,
     :                 tdeep,  swet,  crso,  fkso,
     :                  elat,  albd,  clov,  ulov,
     :                 nflay, frate,
     :                  nspl,  nspu,   csp, nstot
c
      open (1,file='/home/naka/les_for_es/figure/meanscale.dat')
        ne = 0
      do i = 1,999
        read (1,'(a)',end=10) line
        if ( line(1:1) .eq. '#' ) cycle
        ne = ne +1
        read (line(10:30),*) xsta(ne), xend(ne), lbx(ne)
      end do
   10 close(1)
c
      write(6,*) 'Run + Restart number (xx.xx) =?'
      read (5,'(a)')  r_name
      write(6,*) 'Skip'
      read (5,*)
      write(6,*) 'Plot (number and hours; up to 5 hours) =?'
      read (5,*)  nt, ( ihour(i),i=1,nt )
c
      open (10,file='para'//r_name,status='old',iostat=ios)
      if ( ios .ne. 0 ) stop 'Para-file not found.'
c
      read (10,nml=les1)
      read (10,nml=les2)
      close(10)
c
      do m = 1,mf
        open (m+10,file=f_name(m)//r_name,form='unformatted',
     :             status='old',iostat=ios)
        if ( ios .ne. 0 ) stop 'Data-file not found.'
      end do
c
      rsum = 1.0/dble((nx-2)*(ny-2))
c
      tpls = tref -273.15
      cel  =( 0.1*(dx*dy*dz)**(1.0/3.0) )**2
c
      do ll = 1,999
        jhour = ( jmin +nint(ll*jout*dt)/60 )/60
c
        do m = 1,mf
          read (m+10,end=200) (((dat(i,k,j,m),i=1,mx),k=1,mz),j=1,my)
        end do
c
        do l = 1,nt
          if ( jhour .eq. ihour(l) ) goto 100
        end do
        cycle
c
  100   continue
c
        do m = 1,4
        do k = 1,nz
          av1 = 0.0
          do j = 2,ny-1
          do i = 2,nx-1
            av1 = av1 +dat(i,k,j,m)
          end do
          end do
c
          vpro(k,l,m) = av1 * rsum
        end do
        end do
c
        call fsestm( 1, dat(1,1,1,1), dat(1,1,1,7), dat(1,1,1,6),
     :               mx, mz, nx, nz, ny, dx, dz, dy,
     :               vpro(1,l,7) )
        call fsestm( 1, dat(1,1,1,2), dat(1,1,1,7), dat(1,1,1,6),
     :               mx, mz, nx, nz, ny, dx, dz, dy,
     :               vpro(1,l,8) )
c
        if ( dhour .gt. 0.0 ) then
          chour = ihour(l)
          hcos  = cos( 1.570796*( chour-phour )/( 0.5*dhour ) )
          vpro(1,l,7) = tfmx*hcos
          vpro(1,l,8) = qfmx*hcos
        else
          vpro(1,l,7) = tfmx
          vpro(1,l,8) = qfmx
        end if
c
        av1 = 0.0
        av2 = 0.0
        do j = 2,ny-1
        do i = 2,nx-1
          av1 = av1 +0.61*  dat(i,1,j,2) + 1.0
          av2 = av2 +0.61*( dat(i,1,j,1) + tref )
        end do
        end do
        av1 = av1 * rsum
        av2 = av2 * rsum
c
        bpro = vpro(1,l,7)*av1 + vpro(1,l,8)*av2
        ust  = dat(1,nz+1,1,mf)
c
        call ziestm( vpro(1,l,7),nz, dz, 9.81,tref,ust, zi,wst,rate )
c
        if ( bpro .gt. 0.0 ) wst = ( 9.81/tref*bpro*zi )**( 1.0/3.0 )
        write(6,*) 'zi,wst,flx,erate =', zi, wst, vpro(1,l,7), rate
c
        call epestm( 1, dat(1,1,1,3), dat(1,1,1,4), dat(1,1,1,7),
     :                  dat(1,1,1,1), dat(1,1,1,5), dat(1,1,1,6),
     :               mx, mz, nx, nz, ny, dx, dz, dy, 9.81, tref,
     :               wk (1,1,1,1), wk (1,1,1,2), wk (1,1,1,3),
     :               wk (1,1,1,4), wk (1,1,1,5), wk (1,1,1,6),
     :               uav, vav, vpro(1,l,6) )
c
        do k = 1,nz
          uavk = 2.0*uav(k)
          vavk = 2.0*vav(k)
c
          av1 = 0.0
          do j = 2,ny-1
          do i = 2,nx-1
            av1 = av1 +        dat(i,k,j,5)**2/cel
     :                +0.125*( dat(i,k,j,3)+dat(i+1,k,j,3)-uavk )**2
     :                +0.125*( dat(i,k,j,4)+dat(i,k,j+1,4)-vavk )**2
     :                +0.125*( dat(i,k,j,7)+dat(i,k+1,j,7)      )**2
          end do
          end do
c
          vpro(k,l,5) = av1 * rsum
c
          av1 = 0.0
          av2 = 0.0
          av3 = 0.0
          av4 = 0.0
          do j = 2,ny-1
          do i = 2,nx-1
            av1 = av1 +0.125*( dat(i,k+1,j,7)+dat(i,k,j,7) )**3
            av2 = av2 +0.25 *( dat(i,k+1,j,7)+dat(i,k,j,7) )**2
     :                -2.0  *  dat(i, k ,j,5)
     :                      *( dat(i,k+1,j,7)-dat(i,k,j,7) ) / dz
     :                +2.0  *  dat(i, k ,j,5)**2/( 3.0*cel )
            av3 = av3 +0.125*( dat(i,k,j+1,4)+dat(i,k,j,4)-vavk )**3
            av4 = av4 +0.25 *( dat(i,k,j+1,4)+dat(i,k,j,4)-vavk )**2
     :                -2.0  *  dat(i, k ,j,5)
     :                      *( dat(i,k,j+1,4)-dat(i,k,j,4) ) / dy
     :                +2.0  *  dat(i, k ,j,5)**2/( 3.0*cel )
          end do
          end do
c
          vpro(k,l, 9) = av2*rsum /  wst**2
          vpro(k,l,10) = av1*rsum /  wst**3
cx        vpro(k,l,10) = av1*rsum /( max(av2,1.0d-10) )**1.5
          vpro(k,l,11) = av4*rsum /  wst**2
          vpro(k,l,12) = av3*rsum /  wst**3
c
          vpro(k,l, 1) = vpro(k,l,1) +tpls
          vpro(k,l, 2) = vpro(k,l,2) *1.0e3
          vpro(k,l, 7) = vpro(k,l,7) *1.0e2
          vpro(k,l, 8) = vpro(k,l,8) *1.0e5
c
          vpro(k,l, 6) = (  2.0*     vpro(k,l,5) )**1.5
     :                  /( 24.0*max(-vpro(k,l,6),2.5e-4) )
        end do
c
          vpro(1,l, 6) = vpro(2,l,6) / 3.0
c
      end do
c
  200 continue
c
      wx   = 6.0
      wy   = 8.0
      shft = 0.2
c
      xmv  = wx +1.6
      x0   = 5.5
      y0   = 7.0
c
      kz   = nz
c     kz   = 40
      zmax = dz * kz
      lbz  = nint( zmax/100.0 ) +400
c
cx    call winnam( 'Profile' )
      call winfac( 2.5 )
      call plots ( 0.0, 0.0,  2 )
      call factor( 10.0 )
      call plot  (  x0,  y0, -3 )
      call newfnt( 4 )
c
      do m = 1,ne
                                      lsta = 1
                                      xpls = 0.0
                                      ypls = 0.0
        if ( m .eq. 7 .or. m .eq. 8 ) xpls = 2.95
                                      zs   = 0.5
        if ( m .eq. 7 .or. m .eq. 8 ) zs   = 1.0
c
        scl = ( xend(m)-xsta(m) )/mod(lbx(m),100)*max(lbx(m)/100,2)
                                      lnx  = -1
        if ( scl .ne. int(scl)      ) lnx  =  1
c
        call newpen( 3 )
        call symbol( 0.80+xpls, wy-1.0, 0.60, s_lab (m), 0.0,  3 )
        if ( mod(m,2) .eq. 1 )
     :  call symbol(-1.50, wy*0.5, 0.50, z_lab,    90.0,110 )
        call symbol( 0.5*wx,-1.20, 0.50, e_lab (m), 0.0,125 )
        call graph ( wx, wy, xsta(m), xend(m), 0.0, zmax, facx, facy,
     :        lbx(m),lbz,lnx,-1, '      ', '      ', 0, 999.0, shft )
c
        if ( xsta(m) .lt. 0.0 ) then
          call newpen( 0 )
          call plot  ( -xsta(m)*facx, 0.0, 3 )
          call plot  ( -xsta(m)*facx,  wy, 2 )
        end if
c
        do l = lsta,nt
        ll = l -lsta +1
          call newpen( newp(l) )
c
          if ( mod(m,2) .eq. 1 ) then
            write(t_lab(1:2),'(i2.2)') ihour(l)
            call plot  (0.6+xpls,wy-ll*0.5-1.3+ypls, 3)
            call plot  (1.3+xpls,wy-ll*0.5-1.3+ypls, 2)
            call symbol(1.5+xpls,wy-ll*0.5-1.3+ypls,0.45,t_lab,0.0,304)
          end if
c
          do k = 1,kz
            xx(k) = ( vpro(k,l,m)-xsta(m) )*facx
            yy(k) = ( k-zs )*dz            *facy +shft
          end do
c
          call polygn( xx, yy, kz, 0 )
c
        end do
c
        if ( mod(m,2) .eq. 1 ) then
          call plot (  xmv,  0.0, -3 )
        else
          call plot ( -xmv,  0.0, -3 )
          call cls  ( 1 )
        end if
c
      end do
c
      call plote
c
      stop
      end
