c **********************************************************************
c *   Vertical profiles of observational quantities                    *
c *                                                                    *
c *                                   Oct/2005  M. Nakanishi (N.D.A)   *
c **********************************************************************
c
      include  "graph.f"
c
      parameter ( me=4, mt=6, mz=201 )
      character (len=4)  :: t_lab (mt)
      character (len=24) :: e_lab (me)
      character (len=3)  :: s_lab (me)
      character (len=10) :: z_lab
      dimension  vpro(mz,mt,me), alt(mz,mt), prs(mz,mt)
      dimension  xsta(me), xdel(me), lbx(me),  xx(mz), yy(mz)
      dimension  newp(mt)
c
      data  e_lab / '$Potential temp. (#6C)  ',
     :              '$Water vapor (g kg^-^1) ',
     :              '$U component (m s^-^1)  ',
     :              '$V component (m s^-^1)  '/
      data  s_lab /  '(a)',  '(b)',  '(a)',  '(b)'/
      data  z_lab / 'Height (m)'/
c  For Wangara data
c     data  xsta  /  2.0,  0.0, -6.0, -4.0/
c     data  xdel  / 16.0,  5.0,  8.0,  8.0/
c     data  lbx   /  416,   10,    8,    8/
      data  xsta  /  6.6,  0.0, -3.0, -3.0/
      data  xdel  /  0.8,  5.0,  6.0,  6.0/
      data  lbx   /  520,   10,   12,   12/
      data  newp  /    4,   14,   54,   34,   64,   44/
c
c  For Wangara data
c     open (11,file='../obs/WNG.OBS',status='old')
      open (11,file='../obs/KH.OBS',status='old')
c
      do l = 1,999
        read (11,'(i5,16x,a4)',end=200) nz, t_lab(l)
        read (11,'(51f5.0)') ( alt (k,l),  k=1,nz )
        read (11,'(51f5.1)') ( prs (k,l),  k=1,nz )
        read (11,'(51f5.1)') ( vpro(k,l,1),k=1,nz )
        read (11,'(51f5.1)') ( vpro(k,l,2),k=1,nz )
        read (11,'(51f5.2)') ( vpro(k,l,3),k=1,nz )
        read (11,'(51f5.2)') ( vpro(k,l,4),k=1,nz )
      end do
c
  200 nt = l -1
c
      close(11)
c
      do l = 1,nt
      do k = 1,nz
        vpro(k,l,1) = ( vpro(k,l,1)+273.15 )
     :               *( 1000.0/prs(k,l) )**( 287.0/1004.0 ) -273.15
      end do
      end do
c
      wx   = 6.0
      wy   = 9.0
      shft = 0.2
c
      xmv  = wx +1.6
      x0   = 5.5
      y0   = 7.0
c
      zmax = alt(nz,1)
c     zdel = zmax/10.0
c     colm = 10.0**int( log10( zdel ) )
c     lbz  = zmax/( colm*int( zdel/colm ) )
      lbz  = 420
c
cx    call winnam( 'Profile' )
      call winfac( 2.5 )
      call plots ( 0.0, 0.0, -2 )
      call factor( 10.0 )
      call plot  (  x0,  y0, -3 )
      call newfnt( 4 )
c
      do m = 1,me
        xend = xsta(m) + xdel(m)
c
                        ks = 1
        if ( m .gt. 2 ) ks = 2
                                nbx = -1
        if ( xdel(m) .lt. 1.0 ) nbx =  1
c
        call newpen( 3 )
        call symbol( 0.80, wy-1.0, 0.60, s_lab (m), 0.0,  3 )
        if ( mod(m,2) .eq. 1 )
     :  call symbol(-1.50, wy*0.5, 0.50, z_lab,    90.0,110 )
        call symbol( 0.5*wx,-1.20, 0.50, e_lab (m), 0.0,124 )
        call graph ( wx, wy, xsta(m), xend, 0.0, zmax, facx, facy,
     :        lbx(m), lbz,nbx,-1, '      ', '      ', 0, 999.0, shft )
c
        if ( xsta(m) .lt. 0.0 ) then
          call newpen( 0 )
          call plot  ( -xsta(m)*facx, 0.0, 3 )
          call plot  ( -xsta(m)*facx,  wy, 2 )
        end if
c
        ll = 0
c
        do l = 1,nt
          if ( vpro(1,l,m) .gt. 99.0 ) cycle
c
        ll = ll +1
          call newpen( newp(l) )
c
          if     ( m .eq. 1 ) then
            call plot  ( 0.6,wy-ll*0.5-1.3, 3 )
            call plot  ( 1.3,wy-ll*0.5-1.3, 2 )
            call symbol( 1.5,wy-ll*0.5-1.3,0.45,t_lab(l),0.0,304 )
          elseif ( m .eq. 3 ) then
            call plot  ( 3.7,wy-ll*0.5-4.3, 3 )
            call plot  ( 4.4,wy-ll*0.5-4.3, 2 )
            call symbol( 4.6,wy-ll*0.5-4.3,0.45,t_lab(l),0.0,304 )
          end if
c
          do k = ks,nz
            xx(k) = ( vpro(k,l,m)-xsta(m) )*facx
            yy(k) =   alt (k,l)            *facy +shft
          end do
c
          call rclip ( 1, 0.0, 0.0, wx, wy )
          call polygn( xx(ks), yy(ks), nz+1-ks, 0 )
          call rclip ( 0, 0.0, 0.0, wx, wy )
c
        end do
c
        if ( mod(m,2) .eq. 1 ) then
          call plot (  xmv,  0.0, -3 )
        else
          call plot ( -xmv,  0.0, -3 )
          call cls  ( 1 )
        end if
c
      end do
c
      call plote
c
      stop
      end
