c
      subroutine  cforce (
     i                     iflag, u, v,
     i                     mx, mz, nx, nz, ny, fs, r,
     w                     vv, uv, uav, vav,
     o                     cfu, cfv )
c
c     Input variables:
c       iflag           : = 0; calculates Coriolis force
c                         <>0; calculates Coriolis + centrifugal forces
c       r               : radius
c
      double precision  u (mx,mz,ny), v (mx,mz,ny)
      double precision  vv(mx,mz,ny), uv(mx,mz,ny)
      double precision  uav(*), vav(*), av1, av2, uvv
      dimension  cfu(nz), cfv(nz)
c
      rsum = 1.0/dble((nx-2)*(ny-2))
c
      do k = 1,nz+1
        uav(k) = 0.0
        vav(k) = 0.0
        do j = 2,ny-1
        do i = 2,nx-1
          uav(k) = uav(k) +u(i,k,j)
          vav(k) = vav(k) +v(i,k,j)
        end do
        end do
        uav(k) = uav(k) * rsum
        vav(k) = vav(k) * rsum
      end do
c
c  **  Calculates Coriolis force  **
      do j = 1,ny-1
      do k = 1,nz
      do i = 1,nx-1
        vv(i,k,j) = 0.25*( v( i ,k,j+1)+v( i ,k, j )-2.0*vav(k) )**2
        uv(i,k,j) = 0.25*( u(i+1,k, j )+u( i ,k, j )-2.0*uav(k) )
     :                  *( v( i ,k,j+1)+v( i ,k, j )-2.0*vav(k) )
      end do
      end do
      end do
c
      do k = 1,nz
        av1 = 0.0
c
        do j = 2,ny-1
        do i = 2,nx-1
          av1 = av1 +uv(i,k,j)
        end do
        end do
c
        cfu(k) = av1 * rsum * fs
        cfv(k) =-av1 * rsum * fs
      end do
c
      if ( iflag .eq. 0 ) return
c
c  **  Calculates centrifugal force  **
      do k = 1,nz
        av1 = 0.0
        av2 = 0.0
c
        do j = 2,ny-1
        do i = 2,nx-1
          uvv = 0.5*uv(i,k,j)*( v( i ,k,j+1)+v( i ,k, j ) )
c
          av1 = av1 +uvv +uv(i,k,j)*vav(k)
          av2 = av2 -uvv -vv(i,k,j)*uav(k)
        end do
        end do
c
        cfu(k) = cfu(k) + av1 * rsum / r
        cfv(k) = cfv(k) + av2 * rsum / r
      end do
c
      return
      end
