c
      subroutine  fmestm (
     i                     iflag, u, v, w, fm,
     i                     mx, mz, nx, nz, ny, dx, dz, dy, cel,
     w                     uav, vav,
     o                     ufx, vfx, usq, vsq, wsq, ucb, vcb, wcb )
c
c     Input variables:
c       iflag           : = 0; resolved-scale
c                         <>0; total
c
      double precision  u (mx,mz,ny), v (mx,mz,ny), w (mx,mz,ny)
      double precision  fm(mx,mz,ny)
      double precision  uav(*), vav(*), av1, av2, av3, av4, av5, av6
      dimension  ufx(nz), vfx(nz), usq(nz), vsq(nz), wsq(nz),
     :                             ucb(nz), vcb(nz), wcb(nz)
c
      anu  = 1.5e-5
      rsum = 1.0/dble((nx-2)*(ny-2))
c
      do k = 1,nz+1
        uav(k) = 0.0
        vav(k) = 0.0
        do j = 2,ny-1
        do i = 2,nx-1
          uav(k) = uav(k) +u(i,k,j)
          vav(k) = vav(k) +v(i,k,j)
        end do
        end do
        uav(k) = uav(k) * rsum
        vav(k) = vav(k) * rsum
      end do
c
c  **  Calculates the resolved-scale vertical fluxes  **
      do k = 2,nz
        av1 = 0.0
        av2 = 0.0
c
        do j = 2,ny-1
        do i = 2,nx-1
          av1 = av1 +0.25*( u (i,k,j)+u ( i ,k-1, j ) )
     :                   *( w (i,k,j)+w (i-1, k , j ) )
          av2 = av2 +0.25*( v (i,k,j)+v ( i ,k-1, j ) )
     :                   *( w (i,k,j)+w ( i , k ,j-1) )
        end do
        end do
c
        ufx(k) = av1*rsum
        vfx(k) = av2*rsum
      end do
c
      do k = 1,nz
        av1 = 0.0
        av2 = 0.0
        av3 = 0.0
        av4 = 0.0
        av5 = 0.0
        av6 = 0.0
c
        do j = 2,ny-1
        do i = 2,nx-1
          av1 = av1 +0.25 *( u (i+1, k , j )+u (i,k,j)-2.0*uav(k) )**2
          av2 = av2 +0.25 *( v ( i , k ,j+1)+v (i,k,j)-2.0*vav(k) )**2
          av3 = av3 +0.25 *( w ( i ,k+1, j )+w (i,k,j)            )**2
          av4 = av4 +0.125*( u (i+1, k , j )+u (i,k,j)-2.0*uav(k) )**3
          av5 = av5 +0.125*( v ( i , k ,j+1)+v (i,k,j)-2.0*vav(k) )**3
          av6 = av6 +0.125*( w ( i ,k+1, j )+w (i,k,j)            )**3
        end do
        end do
c
        usq(k) = av1*rsum
        vsq(k) = av2*rsum
        wsq(k) = av3*rsum
        ucb(k) = av4*rsum
        vcb(k) = av5*rsum
        wcb(k) = av6*rsum
      end do
c
      if ( iflag .eq. 0 ) return
c
c  **  Calculates the subgrid-scale vertical fluxes  **
      do k = 2,nz
        av1 = 0.0
        av2 = 0.0
c
        do j = 2,ny-1
        do i = 2,nx-1
          av1 = av1 -( 0.25*( fm(i, k ,j)+fm(i-1, k , j )
     :                       +fm(i,k-1,j)+fm(i-1,k-1, j ) )+anu )
     :                   *( ( u (i, k ,j)-u ( i ,k-1, j ) ) / dz
     :                     +( w (i, k ,j)-w (i-1, k , j ) ) / dx )
          av2 = av2 -( 0.25*( fm(i, k ,j)+fm( i , k ,j-1)
     :                       +fm(i,k-1,j)+fm( i ,k-1,j-1) )+anu )
     :                   *( ( v (i, k ,j)-v ( i ,k-1, j ) ) / dz
     :                     +( w (i, k ,j)-w ( i , k ,j-1) ) / dy )
        end do
        end do
c
        ufx(k) = ufx(k) + av1*rsum
        vfx(k) = vfx(k) + av2*rsum
      end do
c
      do k = 1,nz
        av1 = 0.0
        av2 = 0.0
        av3 = 0.0
c
        do j = 2,ny-1
        do i = 2,nx-1
          av1 = av1 -2.0  *( fm( i , k , j ) +anu )
     :                    *( u (i+1, k , j )-u (i,k,j) ) / dx
     :              +2.0/3.0*fm( i , k , j )**2 / cel
          av2 = av2 -2.0  *( fm( i , k , j ) +anu )
     :                    *( v ( i , k ,j+1)-v (i,k,j) ) / dy
     :              +2.0/3.0*fm( i , k , j )**2 / cel
          av3 = av3 -2.0  *( fm( i , k , j ) +anu )
     :                    *( w ( i ,k+1, j )-w (i,k,j) ) / dz
     :              +2.0/3.0*fm( i , k , j )**2 / cel
        end do
        end do
c
        usq(k) = usq(k) + av1*rsum
        vsq(k) = vsq(k) + av2*rsum
        wsq(k) = wsq(k) + av3*rsum
      end do
c
      return
      end
