c
      subroutine  t2estm (
     i                     iflag, t, fm, fh,
     i                     mx, mz, nx, nz, ny, dx, dz, dy,
     w                     uu, vv, ww, uv,
     o                     tsq )
c
c     Input variables:
c       iflag           : = 0; resolved-scale
c                         <>0; total
c
      double precision  t (mx,mz,ny), fm(mx,mz,ny), fh(mx,mz,ny)
      double precision  uu(mx,mz,ny), vv(mx,mz,ny), ww(mx,mz,ny),
     :                  uv(mx,mz,ny)
      double precision  ave, f1, f2, f3, tnu
      dimension  tsq(nz)
c
      tnu  = 2.1d-5
      cel  = 2.0*( dx*dy*dz )**( 2.0/3.0 ) * 0.1/2.1
      rsum = 1.0/dble((nx-2)*(ny-2))
c
c  **  Calculates the resolved-scale temperature variance  **
      do k = 1,nz
        f1  = 0.0
        f2  = 0.0
c
        do j = 2,ny-1
        do i = 2,nx-1
          f1  = f1  +t(i,k,j)
          f2  = f2  +t(i,k,j)**2
        end do
        end do
c
        tsq(k) = f2*rsum - (f1*rsum)**2
      end do
c
      if ( iflag .eq. 0 ) return
c
c  **  Calculates the subgrid-scale temperature variance  **
      do j = 1,ny
      do k = 1,nz+1
      do i = 1,nx
        uv(i,k,j) = cel*( fh(i,k,j)+tnu )/max( fm(i,k,j), tnu )
      end do
      end do
      end do
c
      do j = 2,ny-1
      do k = 2,nz+1
      do i = 2,nx-1
        f1 = 0.5 *( uv(i,k,j)+uv(i-1, k , j ) )
        f2 = 0.5 *( uv(i,k,j)+uv( i , k ,j-1) )
        f3 = 0.5 *( uv(i,k,j)+uv( i ,k-1, j ) )
c
        uu(i,k,j) = f1*( ( t(i,k,j)-t(i-1, k , j ) )/dx )**2
        vv(i,k,j) = f2*( ( t(i,k,j)-t( i , k ,j-1) )/dy )**2
        ww(i,k,j) = f3*( ( t(i,k,j)-t( i ,k-1, j ) )/dz )**2
      end do
      end do
      end do
c
      do k = 2,nz
        ave = 0.0
c
        do j = 2,ny-1
        do i = 2,nx-1
          ave = ave +      uu( i , k , j )
     :              +      vv( i , k , j )
     :              +0.5*( ww( i ,k+1, j )+ww(i,k,j) )
        end do
        end do
c
        tsq(k) = tsq(k) + ave * rsum
      end do
c
      return
      end
