c
      subroutine vscale( x, y, u, v, facx, facy, h, mgx, mgy )
c
c    @ draw vector scale @
c
c     input data :
c      x,    y     ---  p̂wAxWB           (mm.or.cm)
c      u,    v     ---  wAx̕B              (m/s)
c      facx, facy  ---  P^̒B     (mm.or.cm)
c      h           ---  ̍B                   (mm.or.cm)
c      mgx,  mgy   ---  wAx̒PʁB
c
      character*4  mgx, mgy
c
      xx = x +h* 4.0/7.0
cx    xy = x -h*16.0/7.0
      xy = xx
      yy = y +0.7*v*facy
      hh = h*11.0/7.0
c
      call vector( x,y, u ,0.0,facx,0 )
      call vector( x,y,0.0, v ,facy,0 )
c
      call number( xx    ,y-hh  ,h,u  ,0.0,-1 )
      if ( u .lt. 10.0 ) call symbol( 9999.0,9999.0,h,' ',0.0,1 )
      call symbol( 9999.0,9999.0,h,mgx,0.0, 4 )
c
      xx = xy +h*4.0/7.0
      if ( v .lt. 1.0 ) then
        nn =  1
        xx = xx -h*4.0/7.0
      else
        nn = -1
        if ( v .ge.  10.0 ) xx = xx -h*2.0/7.0
        if ( v .ge. 100.0 ) xx = xx -h*2.0/7.0
      end if
c
cx    call number( xx,yy      ,h,v  ,0.0,nn )
      call number( xy,yy      ,h,v  ,0.0,nn )
      call symbol( xy,yy-h*1.0,h,mgy,0.0, 4 )
c
      return
      end
c
      subroutine vector( x, y, u, v, fact, ivec )
c
c    @ draw vector @
c
c     input data :
c      fact  ---  P^̃xNg̒B (mm.or.cm)
c      ivec  ---  0 = _̓xNg̍B
c                 1 = _̓xNg̒SB
c
      data  pi /3.141593/, dg /12.0/
c
c?    if ( u .eq. 0.0 .and. v .eq. 0.0 ) return
c
      uu  = u*fact
      vv  = v*fact
      vec = sqrt( uu*uu+vv*vv )/2.2
      if ( uu .eq. 0.0 ) then
        if ( vv .ge. 0.0 ) th =  0.5*pi
        if ( vv .lt. 0.0 ) th = -0.5*pi
      else
                           th =  atan2( vv,uu )
      end if
c
      if ( ivec .eq. 0 ) then
        xx = x
        yy = y
      else
        xx = x -0.5*uu
        yy = y -0.5*vv
      end if
      xu  = xx +uu
      yv  = yy +vv
c
      th  = th +pi
      dgd = dg *pi/180.0
      x1  = vec*cos( th-dgd )
      y1  = vec*sin( th-dgd )
      x2  = vec*cos( th+dgd )
      y2  = vec*sin( th+dgd )
c
      call plot ( xx   ,yy   ,3 )
      call plot ( xu   ,yv   ,2 )
      call plot ( xu+x1,yv+y1,2 )
      call plot ( xu   ,yv   ,3 )
      call plot ( xu+x2,yv+y2,2 )
c
      return
      end
