c
      subroutine  vordif (
     i                     iflag, u, v, w, fm, flm,
     i                     mx, mz, nx, nz, ny, dx, dz, dy,
     w                     uu, vv, ww, uv, vw, wu,
     o                     vdu, vdv, vdw )
c
c     Calculates the diffusion term in the vorticity equation
c
c     Input variables:
c       iflag           : dummy
c
      double precision  u (mx,mz,ny), v (mx,mz,ny), w (mx,mz,ny)
      double precision  fm(mx,mz,ny), flm(mx,ny)
      double precision  uu(mx,mz,ny), vv(mx,mz,ny), ww(mx,mz,ny),
     :                  uv(mx,mz,ny), vw(mx,mz,ny), wu(mx,mz,ny)
      double precision  f1, f2
      double precision  vdu(mx,mz,ny),vdv(mx,mz,ny),vdw(mx,mz,ny)
c
      anu  = 1.5e-5
      rsum = 1.0/dble((nx-2)*(ny-2))
c
      do j = 1,ny-1
      do k = 1,nz
      do i = 1,nx-1
        f1 = 2.0 *( fm(i,k,j) +anu )
c
        uu(i,k,j) = f1*( u(i+1, k , j )-u(i,k,j) ) / dx
        vv(i,k,j) = f1*( v( i , k ,j+1)-v(i,k,j) ) / dy
        ww(i,k,j) = f1*( w( i ,k+1, j )-w(i,k,j) ) / dz
      end do
      end do
      end do
c
      do j = 2,ny
      do k = 1,nz
      do i = 2,nx
        f2 = 0.25*( fm( i ,k, j )+fm(i-1,k, j )
     :             +fm( i ,k,j-1)+fm(i-1,k,j-1) ) +anu
c
        uv(i,k,j) = f2*( ( u(i,k,j)-u( i ,k,j-1) ) / dy
     :                  +( v(i,k,j)-v(i-1,k, j ) ) / dx )
      end do
      end do
      end do
c
      do j = 2,ny
      do k = 2,nz+1
      do i = 2,nx
        f1 = 0.25*( fm(i, k ,j)+fm(i-1, k , j )
     :             +fm(i,k-1,j)+fm(i-1,k-1, j ) ) +anu
        f2 = 0.25*( fm(i, k ,j)+fm( i , k ,j-1)
     :             +fm(i,k-1,j)+fm( i ,k-1,j-1) ) +anu
c
        wu(i,k,j) = f1*( ( u(i,k,j)-u( i ,k-1, j ) ) / dz
     :                  +( w(i,k,j)-w(i-1, k , j ) ) / dx )
        vw(i,k,j) = f2*( ( v(i,k,j)-v( i ,k-1, j ) ) / dz
     :                  +( w(i,k,j)-w( i , k ,j-1) ) / dy )
      end do
      end do
      end do
c
      do j = 2,ny-1
      do i = 2,nx-1
        wu(i,1,j) = -0.5*( flm(i,j)+flm(i-1, j ) )*u (i,1,j)
        vw(i,1,j) = -0.5*( flm(i,j)+flm( i ,j-1) )*v (i,1,j)
      end do
      end do
c
      do j = ny-1,2,-1
      do k = nz,1,-1
      do i = nx-1,2,-1
        uu(i, k ,j) = ( uu( i , k , j )-uu(i-1, k , j ) ) / dx
     :               +( uv( i , k ,j+1)-uv( i , k , j ) ) / dy
     :               +( wu( i ,k+1, j )-wu( i , k , j ) ) / dz
        vv(i, k ,j) = ( uv(i+1, k , j )-uv( i , k , j ) ) / dx
     :               +( vv( i , k , j )-vv( i , k ,j-1) ) / dy
     :               +( vw( i ,k+1, j )-vw( i , k , j ) ) / dz
        ww(i,k+1,j) = ( wu(i+1,k+1, j )-wu( i ,k+1, j ) ) / dx
     :               +( vw( i ,k+1,j+1)-vw( i ,k+1, j ) ) / dy
     :               +( ww( i ,k+1, j )-ww( i , k , j ) ) / dz
      end do
      end do
      end do
c
      call bc_value ( uu, mx, mz, nx, nz, ny )
      call bc_value ( vv, mx, mz, nx, nz, ny )
      call bc_value ( ww, mx, mz, nx, nz, ny )
c
      do j = 2,ny-1
      do k = 2,nz+1
      do i = 2,nx-1
        vdu(i, k ,j) = ( ww( i , k , j )-ww( i , k ,j-1) ) / dy
     :                -( vv( i , k , j )-vv( i ,k-1, j ) ) / dz
        vdv(i, k ,j) = ( uu( i , k , j )-uu( i ,k-1, j ) ) / dz
     :                -( ww( i , k , j )-ww(i-1, k , j ) ) / dx
        vdw(i,k-1,j) = ( vv( i ,k-1, j )-vv(i-1,k-1, j ) ) / dx
     :                -( uu( i ,k-1, j )-uu( i ,k-1,j-1) ) / dy
      end do
      end do
      end do
c
      return
      end
c
      subroutine  bc_value ( tq, mx, mz, nx, nz, ny )
c
      double precision  tq(mx,mz,ny)
c
      do j = 2,ny-1
      do k = 1,nz
        tq( 1, k, j) = tq(nx-1,  k ,  j )
        tq(nx, k, j) = tq(  2 ,  k ,  j )
      end do
      end do
c
      do k = 1,nz
      do i = 1,mx
        tq( i, k, 1) = tq(  i ,  k ,ny-1)
        tq( i, k,ny) = tq(  i ,  k ,  2 )
      end do
      end do
c
      do j = 1,ny
      do i = 1,mx
        tq(i,nz+1,j) = 0.0
      end do
      end do
c
      return
      end
