c
      subroutine  ziestm (
     i                     bflx, nz, dz, g, tref, ust,
     o                     zi, wst, rate )
c
c     Input variables:
c       bflx            : Buoyancy flux at the wall of the grid box
c                         bflx(1) is the flux at the ground surface.
c
c     Output variables:
c       wst             : Convective velocity for unstable conditions
c                       : Friction velocity for the other conditions
c       rate            : Entrainment rate
c
      dimension  bflx(nz)
c
c  **  Unstable  **
      if ( bflx(1) .ge. 0.0 ) then
        buoy = 1.0e10
c
        do k = 1,nz
          if ( bflx(k) .gt. buoy ) cycle
          buoy = bflx(k)
          zi   = dz*( k-1 )
        end do
c
        wst  =( g/tref*bflx(1)*zi )**( 1.0/3.0 )
        rate = buoy/max( bflx(1), 1.0e-10 )
c
c  **  Stable  **
      else
        buoy = 0.05 * bflx(1)
c
        do k = 1,nz
          zi1  = dz*( k-1 )
          if ( bflx(k) .gt. buoy ) exit
        end do
c
        buoy = -1.0e10
c
        do k = 1,nz
          if ( bflx(k) .lt. buoy ) cycle
          buoy = bflx(k)
          zi2  = dz*( k-1 )
        end do
c
        zi  = min( zi1, zi2 )
c
      end if
c
      if ( bflx(1) .le. 0.0 ) wst = ust
c
      return
      end
