c **********************************************************************
c *   Vertical distributions of quantities                             *
c *                                                                    *
c *                                   May/2005  M. Nakanishi (N.D.A)   *
c **********************************************************************
c
      include  "sub/contln.f"
      include  "sub/scale.f"
      include  "sub/vector.f"
      include  "../src/Parameter.h"
c
      parameter ( mxy=max(mx,my) )
      parameter ( mf=5, me=6, mv=17, mvh=mv/2 )
      character (len=4)  :: f_name(mf), e_lab (me)
      character (len=22) :: x_lab
      character (len=5)  :: r_name
      character (len=6)  :: h_lab
      character (len=9)  :: u_lab
      double precision  dat(mx,mz,my), ave
      dimension  vdis(mxy,mz,me), vint(me)
      dimension  vave(mz,me), vmax(me), vmin(me), xx(mxy,me), zz(mz)
      dimension  val(mv,me), iro(mv)
      data  iro /mv*-1/
c
      data  f_name/ 'u___', 'v___', 'w___', 't___', 'ql__'/
      data  e_lab / 'u   ', 'v   ', 'w   ', '$#Q ', '$q_l', 'd_t '/
      data  x_lab / 'y =0000m  at  0000 LST'/
c
      namelist  /les1/  nrun, nstep,  iout,  jout,  lout
      namelist  /les2/  isgs,  isfc,  irad,  icon,  isca,
     :                  jmin,  rlat,    dt,    dx,    dy,    dz,
     :                         ugsf,  vgsf,         aglw,  agmd,
     :                  gulw,  gvlw,  gumd,  gvmd,
     :                  tref,   tsf,   qsf,   psf,  hglw,  hgmd,
     :                  gtlw,  gqlw,  gtmd,  gqmd,  gamt,  gamq,
     :                   z0m,   z0h,  tfmx,  qfmx, phour, dhour,
     :                 tdeep,  swet,  crso,  fkso,
     :                  elat,  albd,  clov,  ulov,
     :                 nflay, frate,
     :                  nspl,  nspu,   csp, nstot
c
      vfac  = 0.15
c
      write(6,*) 'Run + Restart number (xx.xx) =?'
      read (5,'(a)')  r_name
      write(6,*) 'Horizontal grid number (ix*1000+iy) =?'
      read (5,*)  idmy, ihplt, itplt
      write(6,*) 'Skip'
      read (5,*)
      write(6,*) 'Contour intervals for u, v, ..., zeta =?'
      read (5,*) ( vint(i),i=1,me )
c
      ixplt =     ihplt/1000  +1
      iyplt = mod(ihplt,1000) +1
c
      open (10,file='para'//r_name,status='old',iostat=ios)
      if ( ios .ne. 0 ) stop 'Para-file not found.'
c
      read (10,nml=les1)
      read (10,nml=les2)
      close(10)
c
      ne = me
c
      rsum = 1.0/dble((nx-2)*(ny-2))
c
      do m = 1,mf
        open (11,file=f_name(m)//r_name,form='unformatted',
     :           status='old',iostat=ios)
        if ( ios .ne. 0 ) then
          ne = m -1
          exit
        end if
c
        do it = 1,itplt
          read (11,end=100) dat
        end do
c
  100   itplt = it -1
c
        close(11)
c
                                     ad = 0.0
        if ( f_name(m) .eq. 'w___' ) ad = 0.5
                                     bd = 1.0 -ad
c
        do k = 1,nz
          ave       = 0.0
        do j = 2,ny-1
        do i = 2,nx-1
          ave       = ave + ad*dat(i,k+1,j) + bd*dat(i,k,j)
        end do
        end do
          vave(k,m) = ave * rsum
        end do
c
        vmax(m) = -1.0e10
        vmin(m) =  1.0e10
c
        if ( iyplt .gt. 1 ) then
          nxy = nx
          dxy = dx
                                       ae = 0.0
          if ( f_name(m) .eq. 'v___' ) ae = 0.5
                                       be = 1.0 -ae
c
          do k = 1,nz
          do i = 1,nx
            dd = ae*( ad*dat(i,k+1,iyplt+1) + bd*dat(i,k,iyplt+1) )
     :          +be*( ad*dat(i,k+1,iyplt  ) + bd*dat(i,k,iyplt  ) )
            vdis(i,k,m) = dd
            vmax(m) = max( vmax(m), dd-vave(k,m) )
            vmin(m) = min( vmin(m), dd-vave(k,m) )
          end do
          end do
        else
          nxy = ny
          dxy = dy
                                       ae = 0.0
          if ( f_name(m) .eq. 'u___' ) ae = 0.5
                                       be = 1.0 -ae
c
          do j = 1,ny
          do k = 1,nz
            dd = ae*( ad*dat(ixplt+1,k+1,j) + bd*dat(ixplt+1,k,j) )
     :          +be*( ad*dat(ixplt  ,k+1,j) + bd*dat(ixplt  ,k,j) )
            vdis(j,k,m) = dd
            vmax(m) = max( vmax(m), dd-vave(k,m) )
            vmin(m) = min( vmin(m), dd-vave(k,m) )
          end do
          end do
        end if
      end do
c
      do k = 1,nz
      do i = 1,nxy
        vdis(i,k,1) = vdis(i,k,1) -vave(k,1)
        vdis(i,k,2) = vdis(i,k,2) -vave(k,2)
      end do
      end do
c
      wx   = 14.8
      wy   = wx*( dz*nz )/( dxy*(nxy-2) )
c
      ymv  = wy +2.5
      x0   =  3.2
      y0   = 19.5
c
      do m = 1,ne
        if ( f_name(m) .eq. 'ql__' ) then
            del  = 0.5e-4
            vl   = del - del*(1-mvh-1)
        else
          if ( vint(m) .gt. 0.0 ) then
            del  = vint(m)
          else
            del  = max( vmax(m), -vmin(m) ) / dble(mvh)
            vl   = log10( del )
            colm = 10.0**( int(vl)-1+int(vl-int(vl)+1) )
            del  = colm*int( del/colm*2.0 )/2.0
          end if
            vl   = 0.0
        end if
c
        if ( f_name(m) .eq. 't___' ) then
            del6 = colm*int( del/colm )
            del  = 0.5
            vl   = int( vave(nz,m)*2.0 )/2.0 - del*(mv-mvh-1)
        end if
c
          do i = 1,mv
            val(i,m) = vl + del*(i-mvh-1)
          end do
          write(6,*) e_lab(m), ' max,min,del =', vmax(m), vmin(m), del
      end do
c
      facx = wx/( dxy*(nxy-2) )
      facy = wy/( dz * nz     )
      fkm  = 1000.0
      scx  = 0.5*nint( dxy*(nxy-2)/(5.0*fkm) )
      scy  = 0.5
c
      do m = 1,me
        dfx = 1.5
        if ( iyplt .gt. 1 .and. e_lab(m) .eq. 'u   ' ) dfx = 2.0
        if ( iyplt .le. 1 .and. e_lab(m) .eq. 'v   ' ) dfx = 2.0
      do i = 1,nxy
        xx(i,m) = dxy*( i-dfx ) * facx
      end do
      end do
      do k = 1,nz
        zz(k)   = dz *( k-0.5 ) * facy
      end do
c
      if ( iyplt .gt. 1 ) then
        u_lab      = '(u, w) & '
        h_lab      = 'x (km)'
        x_lab(1:1) = 'y'
        write(x_lab( 4: 7),'(i4)'  ) nint( dxy*(iyplt-1.5) )
      else
        u_lab      = '(v, w) & '
        h_lab      = 'y (km)'
        x_lab(1:1) = 'x'
        write(x_lab( 4: 7),'(i4)'  ) nint( dxy*(ixplt-1.5) )
      end if
        itplt = jmin +nint(itplt*jout*dt)/60
        write(x_lab(15:18),'(i4.4)') itplt/60*100+mod(itplt,60)
c
cx    call winnam( 'Vertical' )
      call winfac( 2.0 )
      call plots ( 0.0, 0.0,  2 )
      call factor( 10.0 )
      call plot  (  x0,  y0, -3 )
      call newfnt( 4 )
c
      do m = 3,ne
        call newpen( 3 )
        call symbol(    0.6, wy+0.3, 0.48, u_lab,     0.0,  9 )
        call symbol( 9999.9, 9999.9, 0.48, e_lab(m),  0.0,  4 )
        call symbol( wx-3.6, wy+0.3, 0.40, x_lab,     0.0,222 )
        call symbol(   -1.1, wy*0.5, 0.40, 'z (km)', 90.0,106 )
        call symbol( wx*0.5,  -1.05, 0.40, h_lab,     0.0,106 )
        call rect  ( 0.0, 0.0, wx, wy, 0.0, 0 )
c
        call sscale( 0.0,0.0, scx,dxy*(nxy-2)/fkm,facx*fkm, 0.36, 0 )
        call sscale( 0.0,0.0, scy,dz * nz    /fkm,facy*fkm, 0.36,-1 )
c
        call newpen( 2 )
        call vector( 12.3, wy+0.4, 3.0, 0.0, vfac, 0 )
        call symbol( 13.0, wy+0.3, 0.40, '$3 m s^-^1', 0.0,10 )
c
        call rclip ( 1, 0.0, 0.0, wx, wy )
c
                            j = 2
        if ( iyplt .gt. 1 ) j = 1
c
        do k = 1,nz, 2
        do i = 2,nxy-1,2
          uu = 0.5*( vdis(i+1,k,j)+vdis(i,k,j) )
          call vector( xx(i,3),zz(k), uu,vdis(i,k,3), vfac,1 )
        end do
        end do
c
        if ( f_name(m) .eq. 't___' ) then
          call contln( vdis(1,1,m), mxy, nxy, nz, xx(1,m), zz,
     :                 val(1,m),     iro,        mv,  0.25, 2, 0 )
        else
          call contln( vdis(1,1,m), mxy, nxy, nz, xx(1,m), zz,
     :                 0.0, -1, 1, 0.25, -1, 0 )
          call newpen( 0 )
          call contln( vdis(1,1,m), mxy, nxy, nz, xx(1,m), zz,
     :                 val(mvh+2,m), iro(mvh+2), mvh, 0.25, 2, 0 )
          call newpen( 50 )
          call contln( vdis(1,1,m), mxy, nxy, nz, xx(1,m), zz,
     :                 val(1,m),     iro,        mvh, 0.25, 2, 0 )
        end if
c
        call rclip ( 0, 0.0, 0.0, wx, wy )
c
        call plot ( 0.0, -ymv, -3 )
      end do
c
      call cls  ( 1 )
      call plote
c
      stop
      end
