c **********************************************************
c *  Statistics for turbulent energy                       *
c **********************************************************
c
      subroutine  statistics
c
      include  "lesparm"
      dimension  sta(mz,13), wok(mz,12)
      common  /uvw/ u(mx,my,mz), v(mx,my,mz), w(mx,my,mz), s(mx,my,mz)
      common  /tqp/ t(mx,my,mz), q(mx,my,mz), ql(mx,my,mz),
     :              pi(mx,my,mz), pi0(mx,my,mz), p(mx,my,mz)
      common  /qel/ qq(mx,my,mz), el(mx,my,mz)
      common  /fmt/ fm(mx,my,mz), ft(mx,my,mz),
     :              fwu(mz), fvw(mz), gam(mz)
      common  /nhd/ pd(mx,my,mz)
      common  /vtq/ vt(mx,my,mz), vq(mx,my,mz)
      common  /gfx/ flu(mx,my), flt(mx,my), flq(mx,my),
     :              ust(mx,my), fhm(mx,my), fhh(mx,my), duz
      common  /flx/ uu(mx,my,mz), vv(mx,my,mz), ww(mx,my,mz),
     :              uv(mx,my,mz), vw(mx,my,mz), wu(mx,my,mz),
     :              tv(mx,my,mz)
      common  /xyz/ dxc(mx), dxf(mx), axf(mx), axb(mx),
     :              dyc(my), dyf(my), ayf(my), ayb(my),
     :              dzc(mz), dzf(mz), azf(mz), azb(mz),
     :              z(mz), zw(mz), ztop
      common  /dlm/ dcb(mx,my,mz), hzc(mx,my,mz), hzf(mx,my,mz)
      common  /nxy/ nx, ny, nz, nxp1, nyp1, nzp1, nxm1, nym1, nzm1
      common  /cns/ g, rg, cp, pk, p0, ev, roh, tm
c
      dx1 = dxf(1)
      dy1 = dyf(1)
c
      anyu = 1.5e-5
      gtm  = g/tm
      tv0  = 0.61*tm
      tv1  = 1.61*tm
      sum  = 1.0/float((nx-2)*(ny-2))
c
      do 110 k = 1,nz
       do 110 j = 1,my
        do 110 i = 1,mx
         pp  = 2.0*ev/( pi0(i,j,k+1)+pi0(i,j,k) )
         s(i,j,k) = ( t(i,j,k)+tm+pp*ql(i,j,k) )
     :             *( 1.0+0.61*q(i,j,k)-1.61*ql(i,j,k) )
cx       s(i,j,k) = t(i,j,k) +tv0*q(i,j,k) +( pp-tv1 )*ql(i,j,k)
  110 continue
c
      do 130 k = 1,nzp1
       km1  = max0( k-1,1 )
c
       uav  = 0.0
       vav  = 0.0
       tvav = 0.0
       ufav = 0.0
       vfav = 0.0
       tfav = 0.0
       spav = 0.0
       sbav = 0.0
       fmav = 0.0
       wuav = 0.0
       vwav = 0.0
c
       qlav = 0.0
       clav = 0.0
c
       do 120 j = 2,nym1
        do 120 i = 2,nxm1
         uav  = uav  +u (i,j,k)
         vav  = vav  +v (i,j,k)
         tvav = tvav +s (i,j,k)
         ufav = ufav +0.25*( u(i,j,k)+u( i , j ,km1) )
     :                    *( w(i,j,k)+w(i-1, j , k ) )
         vfav = vfav +0.25*( v(i,j,k)+v( i , j ,km1) )
     :                    *( w(i,j,k)+w( i ,j-1, k ) )
         tfav = tfav +0.5 *( s(i,j,k)+s( i , j ,km1) ) * w(i,j,k)
         spav = spav +fm(i,j,k)*uu(i,j,k)
cx       sbav = sbav -ft(i,j,k)*vv(i,j,k)
         sbav = sbav -0.5 *( ft(i,j,k)+ft(i,j,km1) )
     :             *( 0.5 *( vt(i,j,k)+vt(i,j,km1) )
     :                    *( t (i,j,k)-t (i,j,km1) )
     :               +0.5 *( vq(i,j,k)+vq(i,j,km1) )
     :                    *( q (i,j,k)-q (i,j,km1) ) )/hzc(i,j,k)
         fmav = fmav +fm(i,j,k)
         wuav = wuav +wu(i,j,k)
         vwav = vwav +vw(i,j,k)
c
         qlav = qlav +ql(i,j,k)
         if ( ql(i,j,k) .gt. 0.0 ) clav = clav +1.0
  120  continue
c
       wok(k,1) = uav *sum
       wok(k,2) = vav *sum
       wok(k,6) = tvav*sum
       wok(k,3) = ufav*sum
       wok(k,4) = vfav*sum
       wok(k,5) = tfav*sum
cSGS
       wok(k, 7) = spav*sum * gam(k)
       wok(k, 8) = sbav*sum
       wok(k, 9) = fmav*sum
       wok(k,11) = wuav*sum
       wok(k,12) = vwav*sum
cSGS
       sta(k,7) = qlav*sum
       sta(k,8) = clav*sum
  130 continue
c
      sbav = 0.0
      do 140 j = 2,nym1
       do 140 i = 2,nxm1
  140   sbav = sbav +flt(i,j) +tv0*flq(i,j)
      wok(1,8) = sbav*sum
c
      do 145 k = 2,nz
       if ( gam(k) .ge. 1.0 ) then
         wok(k,10) = 0.0
       else
         wok(k,10) = 0.5*( fwu(k+1)*(wok(k+1,1)-wok( k ,1))/dzc(k+1)
     :                    +fwu( k )*(wok( k ,1)-wok(k-1,1))/dzc( k )
     :                    +fvw(k+1)*(wok(k+1,2)-wok( k ,2))/dzc(k+1)
     :                    +fvw( k )*(wok( k ,2)-wok(k-1,2))/dzc( k ) )
     :              +gam(k)*wok(k,9)*( wok(k,11)**2+wok(k,12)**2 )
       end if
  145 continue
c ***** To set sta(1,10) to be zero.
      wok(1,10) = -wok(1,7)
c *****
c
      do 150 k = 1,nz
       sta(k, 9) = gtm*dzc(k)*( wok(k,6)-wok(k-1,6) )
     :                     /( ( wok(k,1)-wok(k-1,1) )**2
     :                       +( wok(k,2)-wok(k-1,2) )**2+1.0e-30 )
       sta(k,10) =       wok( k ,10)+wok(k, 7)
       sta(k,11) = 0.5*( wok(k+1, 8)+wok(k, 8) ) *gtm
c
       sta(k,1) = -0.5*( wok(k+1,3)
     :                *( wok(k+1,1)-wok( k ,1) )/dzc(k+1)
     :                  +wok( k ,3)
     :                *( wok( k ,1)-wok(k-1,1) )/dzc( k ) )
     :            -0.5*( wok(k+1,4)
     :                *( wok(k+1,2)-wok( k ,2) )/dzc(k+1)
     :                  +wok( k ,4)
     :                *( wok( k ,2)-wok(k-1,2) )/dzc( k ) )
     :            +      sta( k ,10)
       sta(k,2) =  0.5*( wok(k+1,5)+wok(k,5) )*gtm
     :            +      sta( k ,11)
  150 continue
c *****
      sta(1,10) = fhm(2,2)*ust(2,2)**4 -sta(1,1)
      sta(1, 1) = sta(1,1) +sta(1,10)
c *****
c
      do 220 k = 1,nz
       uav  = 2.0*wok(k,1)
       vav  = 2.0*wok(k,2)
       tvav = wok(k,6)
c
       do 210 j = 1,my
        do 210 i = 1,mx
         ww(i,j,k) = 0.125*( ( u(i+1, j , k )+u(i,j,k)-uav )**2
     :                      +( v( i ,j+1, k )+v(i,j,k)-vav )**2
     :                      +( w( i , j ,k+1)+w(i,j,k)     )**2 )
         uu(i,j,k) = ( s(i,j,k)-tvav )**2
  210  continue
  220 continue
c
      do 270 k = 1,nz
       km1  = max0( k-1,1 )
c
       efav = 0.0
       pfav = 0.0
       tfav = 0.0
       qqav = 0.0
       qsav = 0.0
c
       do 250 j = 2,nym1
        do 250 i = 1,mx
cx       s(i,j,1) = 0.5*( w(i,j,k+1)*( ww(i,j,k+1)+ww(i,j, k ) )
cx   :                   -w(i,j, k )*( ww(i,j, k )+ww(i,j,km1) )
cx   :                   )/hzf(i,j,k)
cx       s(i,j,2) = 0.5*( w(i,j,k+1)*( pd(i,j,k+1)+pd(i,j, k ) )
cx   :                   -w(i,j, k )*( pd(i,j, k )+pd(i,j,km1) )
cx   :                   )/hzf(i,j,k)
         s(i,j,1) = 0.5*  w(i,j, k )*( ww(i,j, k )+ww(i,j,km1) )
         s(i,j,2) = 0.5*  w(i,j, k )*( pd(i,j, k )+pd(i,j,km1) )
         s(i,j,3) = 0.5*  w(i,j, k )*( uu(i,j, k )+uu(i,j,km1) )
  250  continue
c
       do 260 j = 2,nym1
        do 260 i = 2,nxm1
         efav = efav -s (i,j,1)
         pfav = pfav -s (i,j,2)
         tfav = tfav -s (i,j,3)
         qqav = qqav +ww(i,j,k)
         qsav = qsav +qq(i,j,k)
  260  continue
c
       sta(k, 3) = pfav*sum
       sta(k, 4) = efav*sum
       sta(k,13) = tfav*sum
       sta(k, 6) = qqav*sum +qsav*sum
       sta(k,12) = qsav*sum
  270 continue
c
      do 310 k = 1,nz
       gamk = gam(k)
c
       do 310 j = 1,my
        do 310 i = 1,mx
         f1 = 2.0 *( gamk*  fm(i,j,k) +anyu )
         f2 = 0.25*  gamk*( fm( i , j ,k)+fm(i-1, j ,k)
     :                     +fm( i ,j-1,k)+fm(i-1,j-1,k) ) +anyu
c
         uu(i,j,k) = f1  *( u(i+1, j , k )-u(i,j,k) )/dx1
         vv(i,j,k) = f1  *( v( i ,j+1, k )-v(i,j,k) )/dy1
         ww(i,j,k) = f1  *( w( i , j ,k+1)-w(i,j,k) )/hzf(i,j,k)
c
         uv(i,j,k) = f2*( ( u(i,j,k)-u( i ,j-1,k) )/dy1
     :                   +( v(i,j,k)-v(i-1, j ,k) )/dx1 )
  310 continue
c
      do 320 k = 2,nzp1
       gamk = 0.5*( gam(k)+gam(k-1) )
c
       do 320 j = 1,my
        do 320 i = 1,mx
         f1 = 0.25*gamk*( fm(i,j, k )+fm(i-1, j , k )
     :                   +fm(i,j,k-1)+fm(i-1, j ,k-1) ) +anyu
         f2 = 0.25*gamk*( fm(i,j, k )+fm( i ,j-1, k )
     :                   +fm(i,j,k-1)+fm( i ,j-1,k-1) ) +anyu
c
         wu(i,j,k) = f1*( ( u(i,j,k)-u( i , j ,k-1) )/hzc(i,j,k)
     :                   +( w(i,j,k)-w(i-1, j , k ) )/dx1 )
         vw(i,j,k) = f2*( ( v(i,j,k)-v( i , j ,k-1) )/hzc(i,j,k)
     :                   +( w(i,j,k)-w( i ,j-1, k ) )/dy1 )
  320 continue
c
      do 330 j = 2,nym1
       do 330 i = 1,mx
         wu(i,j,1) = -0.5*( flu(i,j)+flu(i-1, j ) )*u(i,j,1)
  330    vw(i,j,1) = -0.5*( flu(i,j)+flu( i ,j-1) )*v(i,j,1)
c
      do 370 k = 1,nz
       km1  = max0( k-1,1 )
c
       uav  = wok(k,1)
       vav  = wok(k,2)
       dfav = 0.0
c
       do 350 j = 2,nym1
        do 350 i = 1,mx
         s(i,j,1) = ( u(i,j,k)-uav )
     :           *( ( uu( i , j , k )-uu(i-1, j ,k) )/dx1
     :             +( uv( i ,j+1, k )-uv( i , j ,k) )/dy1
     :             +( wu( i , j ,k+1)-wu( i , j ,k) )/hzf(i,j,k) )
     :             +( v(i,j,k)-vav )
     :           *( ( uv(i+1, j , k )-uv( i , j ,k) )/dx1
     :             +( vv( i , j , k )-vv( i ,j-1,k) )/dy1
     :             +( vw( i , j ,k+1)-vw( i , j ,k) )/hzf(i,j,k) )
     :             +0.5*w(i,j,k+1)
     :           *( ( wu(i+1, j ,k+1)-wu(i,j,k+1) )/dx1
     :             +( vw( i ,j+1,k+1)-vw(i,j,k+1) )/dy1
     :             +( ww( i , j ,k+1)-ww(i,j, k ) )/hzc(i,j,k+1) )
     :             +0.5*w(i,j, k )
     :           *( ( wu(i+1, j , k )-wu(i,j, k ) )/dx1
     :             +( vw( i ,j+1, k )-vw(i,j, k ) )/dy1
     :             +( ww( i , j , k )-ww(i,j,km1) )/hzc(i,j, k ) )
  350  continue
c
       do 360 j = 2,nym1
        do 360 i = 2,nxm1
  360    dfav = dfav +s(i,j,1)
c
       sta(k,5) = dfav*sum -sta(k,10) -sta(k,11)
  370 continue
c
      do 410 k = 1,nz
       do 410 j = 1,my
        do 410 i = 1,mx
  410    wu(i,j,k) = ft(i,j,k)/amax1( sqrt(qq(i,j,k)),1.0e-10 )
c
      call bndlts( wu, mx, my, nx, ny, nzp1 )
      call bndup ( wu, mx, my, nx, ny, nzp1, 0.0 )
c
      do 415 k = 2,nzp1
       do 415 j = 1,my
        do 415 i = 1,mx
         f1 = 0.5*( wu(i,j,k)+wu(i-1, j , k ) )
         f2 = 0.5*( wu(i,j,k)+wu( i ,j-1, k ) )
         f3 = 0.5*( wu(i,j,k)+wu( i , j ,k-1) )
c
         uu(i,j,k) = f1*( ( t(i,j,k)-t(i-1, j ,k) )/dx1 )**2
         vv(i,j,k) = f2*( ( t(i,j,k)-t( i ,j-1,k) )/dy1 )**2
         ww(i,j,k) = f3*( ( t(i,j,k)-t(i,j,k-1) )/hzc(i,j,k) )**2
  415 continue
c
      do 440 k = 2,nz
       dfav = 0.0
c
       do 420 j = 2,nym1
        do 420 i = 1,mx
  420    s(i,j,1) = 0.5*dcb(i,j,k)*( uu(i+1, j , k )+uu(i,j,k)
     :                              +vv( i ,j+1, k )+vv(i,j,k)
     :                              +ww( i , j ,k+1)+ww(i,j,k) )
c
       do 430 j = 2,nym1
        do 430 i = 2,nxm1
  430    dfav = dfav +s(i,j,1)
c
       sta(k,8) = dfav*sum
  440 continue
c
      write(50) ( ( sta(k,i),k=1,nz ),i=1,13 )
c
      return
      end
