c **********************************************************************
c *   A large-eddy simulation (LES) model for the Earth Simulator      *
c *                                                                    *
c *                                   Sep/2005  M. Nakanishi (N.D.A)   *
c *                                             naka@nda.ac.jp         *
c *                                                                    *
c *   Description:                                                     *
c *     This file specifies the parameter statement.                   *
c *     mx, mz, and my are the sizes of array in the x, z, and y       *
c *     directions, respectively, while nx, nz, and ny are the sizes   *
c *     for simulation. Since both side boundaries in the horizontal   *
c *     directions are used for the boundary condition, however, the   *
c *     actual sizes are two grids smaller than nx and ny.             *
c *                                                                    *
c *     mx should be an odd number to avoid the bank-conflict.         *
c *     nx-2 should be in multiples of 256 for high vectorization.     *
c *     my and ny should be in multiples of the number of processors   *
c *        to save the computer resources.                             *
c *     nz must be smaller than mz for the upper boundary condition.   *
c *                                                                    *
c *     The loop in the y direction will be parallelized.              *
c **********************************************************************
c
c     parameter ( mx=242, mz=61,   my=242 )
c     parameter ( nx=242, nz=mz-1, ny=my  )
c
      parameter ( mx=127, mz=51,   my=127 )
      parameter ( nx=127, nz=mz-1, ny=my  )
c
c     Coarse grid
c     parameter ( mx=65, mz=51,   my=65 )
c     parameter ( nx=65, nz=mz-1, ny=my )
