c **********************************************************************
c *   Lateral boundary condition (Cyclic)                              *
c *                                                                    *
c *   Contents:                                                        *
c *     1. bc_lat_moment (for momentum)                                *
c *     2. bc_lat_scalar (for scalar. Nearly the same as above)        *
c **********************************************************************
c
      subroutine  bc_lat_moment
c
      include  "Declare.h"
c
      do j = 2,ny-1
      do k = 1,nz
        u ( 1, k, j) = u (nx-1,  k ,  j )
        v ( 1, k, j) = v (nx-1,  k ,  j )
        w ( 1, k, j) = w (nx-1,  k ,  j )
        u (nx, k, j) = u (  2 ,  k ,  j )
        v (nx, k, j) = v (  2 ,  k ,  j )
        w (nx, k, j) = w (  2 ,  k ,  j )
      end do
      end do
c
      do k = 1,nz
      do i = 1,mx
        u ( i, k, 1) = u (  i ,  k ,ny-1)
        v ( i, k, 1) = v (  i ,  k ,ny-1)
        w ( i, k, 1) = w (  i ,  k ,ny-1)
        u ( i, k,ny) = u (  i ,  k ,  2 )
        v ( i, k,ny) = v (  i ,  k ,  2 )
        w ( i, k,ny) = w (  i ,  k ,  2 )
      end do
      end do
c
      return
      end
c
      subroutine  bc_lat_scalar ( tq )
c
      include  "Declare.h"
c
      dimension  tq(mx,mz,my)
!hpf$ distribute (*,*,block) :: tq
c
      do j = 2,ny-1
      do k = 1,nz
        tq( 1, k, j) = tq(nx-1,  k ,  j )
        tq(nx, k, j) = tq(  2 ,  k ,  j )
      end do
      end do
c
      do k = 1,nz
      do i = 1,mx
        tq( i, k, 1) = tq(  i ,  k ,ny-1)
        tq( i, k,ny) = tq(  i ,  k ,  2 )
      end do
      end do
c
      return
      end
c
      subroutine  bc_lat_scalar2 ( tq )
c
      include  "Declare.h"
c
      dimension  tq(mx,my)
!hpf$ distribute (*,block) :: tq
c
      do j = 2,ny-1
        tq( 1, j) = tq(nx-1,  j )
        tq(nx, j) = tq(  2 ,  j )
      end do
c
      do i = 1,nx
        tq( i, 1) = tq(  i ,ny-1)
        tq( i,ny) = tq(  i ,  2 )
      end do
c
      return
      end
