c **********************************************************************
c *   Input/Output of the simulated distributions                      *
c *                                                                    *
c *   Input variables:                                                 *
c *     f_io          : Portion of the file name relevant to Run no.   *
c *                                                                    *
c *   # I/O device numbers for 3-D, 2-D, and 1-D data are equal to     *
c *     or larger than 20, 50, and 80, respectively.                   *
c **********************************************************************
c
      block data io_file_name
c
      include  "IOfile.h"
c
      data  f_3d / 'u___', 'v___', 'w___', 't___', 'q___',
     :             'fub_', 'fvb_', 'fwb_', 'ftb_', 'fqb_',
     :             'pd__', 'fm__', 'fh__', 'ql__', 'wsb_',
     :             'rhr_', 'rfx_', 'sa__', 'fab_', 'xxxx'/
      data  f_2d / 'flm_', 'flt_', 'flq_', 'ts__'/
      data  f_1d / 'gam_', 'fwu_', 'fvw_'/
c
      end
c **********************************************************************
c
      subroutine  data_selection ( isgs, isfc, irad, icon, isca )
c
      include  "IOfile.h"
c
      do i = 1,mf3d
        select case ( f_3d(i) )
cx        case ( 'q___', 'fqb_' ); if ( icon .lt. 0 ) f_3d(i) = 'xxxx'
          case (         'fqb_' ); if ( icon .lt. 0 ) f_3d(i) = 'xxxx'
          case ( 'ql__'         ); if ( icon .lt. 1 ) f_3d(i) = 'xxxx'
          case ( 'wsb_'         ); if ( isfc .lt. 3 ) f_3d(i) = 'xxxx'
          case ( 'rhr_', 'rfx_' ); if ( irad .eq. 0 ) f_3d(i) = 'xxxx'
          case ( 'sa__', 'fab_' ); if ( isca .eq. 0 ) f_3d(i) = 'xxxx'
          case default
        end select
      end do
c
      do i = 1,mf2d
        select case ( f_2d(i) )
          case ( 'ts__'         ); if ( isfc .ne. 0 ) f_2d(i) = 'xxxx'
          case default
        end select
      end do
c
      if ( isgs .eq. 0 ) then
        do i = 1,mf1d
          f_1d(i) = 'xxxx'
        end do
      end if
c
      return
      end
c **********************************************************************
c
      subroutine  data_open ( f_io )
c
      include  "IOfile.h"
c
      character (len=5) :: f_io
c
      do i = 1,mf3d
        if ( f_3d(i) .ne. 'xxxx' )
     :    open ( i+19,file=f_3d(i)//f_io,form='unformatted' )
      end do
      do i = 1,mf2d
        if ( f_2d(i) .ne. 'xxxx' )
     :    open ( i+49,file=f_2d(i)//f_io,form='unformatted' )
      end do
      do i = 1,mf1d
        if ( f_1d(i) .ne. 'xxxx' )
     :    open ( i+79,file=f_1d(i)//f_io,form='unformatted' )
      end do
c
      return
      end
c **********************************************************************
c
      subroutine  data_close
c
      include  "IOfile.h"
c
      do i = 1,mf3d
        close ( i+19 )
      end do
      do i = 1,mf2d
        close ( i+49 )
      end do
      do i = 1,mf1d
        close ( i+79 )
      end do
c
      return
      end
c **********************************************************************
c
      subroutine  data_output
c
      include  "Declare.h"
      include  "IOfile.h"
c
      do i = 1,mf3d
        mt = i +19
c
        select case ( f_3d(i) )
          case ( 'u___' );  write(mt)  u
          case ( 'v___' );  write(mt)  v
          case ( 'w___' );  write(mt)  w
          case ( 't___' );  write(mt)  t
          case ( 'q___' );  write(mt)  q
          case ( 'fub_' );  write(mt)  fub
          case ( 'fvb_' );  write(mt)  fvb
          case ( 'fwb_' );  write(mt)  fwb
          case ( 'ftb_' );  write(mt)  ftb
          case ( 'fqb_' );  write(mt)  fqb
          case ( 'pd__' );  write(mt)  pd
          case ( 'fm__' );  write(mt)  fm
          case ( 'fh__' );  write(mt)  fh
          case ( 'ql__' );  write(mt)  ql
          case ( 'wsb_' );  write(mt)  wsb
          case ( 'rhr_' );  write(mt)  rhr
          case ( 'rfx_' );  write(mt)  rfx
          case ( 'sa__' );  write(mt)  sa
          case ( 'fab_' );  write(mt)  fab
          case default
        end select
c
      end do
c
      do i = 1,mf2d
        mt = i +49
c
        select case ( f_2d(i) )
          case ( 'flm_' );  write(mt)  flm
          case ( 'flt_' );  write(mt)  flt
          case ( 'flq_' );  write(mt)  flq
          case ( 'ts__' );  write(mt)  ts
          case default
        end select
c
      end do
c
      do i = 1,mf1d
        mt = i +79
c
        select case ( f_1d(i) )
          case ( 'gam_' );  write(mt)  gam
          case ( 'fwu_' );  write(mt)  fwu
          case ( 'fvw_' );  write(mt)  fvw
          case default
        end select
c
      end do
c
      return
      end
c **********************************************************************
c
      subroutine  data_restart ( f_io )
c
      include  "Declare.h"
      include  "IOfile.h"
c
      character (len=5) :: f_io
c
      call data_open ( f_io )
c
      do i = 1,mf3d
        mt = i +19
c
      do j = 1,999
        select case ( f_3d(i) )
          case ( 'u___' );  read (mt,end=100)  u
          case ( 'v___' );  read (mt,end=100)  v
          case ( 'w___' );  read (mt,end=100)  w
          case ( 't___' );  read (mt,end=100)  t
          case ( 'q___' );  read (mt,end=100)  q
          case ( 'fub_' );  read (mt,end=100)  fub
          case ( 'fvb_' );  read (mt,end=100)  fvb
          case ( 'fwb_' );  read (mt,end=100)  fwb
          case ( 'ftb_' );  read (mt,end=100)  ftb
          case ( 'fqb_' );  read (mt,end=100)  fqb
          case ( 'pd__' );  read (mt,end=100)  pd
          case ( 'fm__' );  read (mt,end=100)  fm
          case ( 'fh__' );  read (mt,end=100)  fh
          case ( 'ql__' );  read (mt,end=100)  ql
          case ( 'wsb_' );  read (mt,end=100)  wsb
          case ( 'rhr_' );  read (mt,end=100)  rhr
          case ( 'rfx_' );  read (mt,end=100)  rfx
          case ( 'sa__' );  read (mt,end=100)  sa
          case ( 'fab_' );  read (mt,end=100)  fab
          case default;     goto 100
        end select
      end do
c
  100 continue
      end do
c
      do i = 1,mf2d
        mt = i +49
c
      do j = 1,999
        select case ( f_2d(i) )
          case ( 'ts__' );  read (mt,end=200)  ts
          case default;     goto 200
        end select
      end do
c
  200 continue
      end do
c
      call data_close
c
      return
      end
