c **********************************************************************
c *   Scalar flux (Advection + Diffusion)                              *
c **********************************************************************
c
      subroutine  flux_scalar ( tq, fq, sflx, fac, qnu )
c
      include  "Declare.h"
c
      dimension  tq(mx,mz,my), fq(mx,mz,my), sflx(mx,my)
!hpf$ distribute (*,*,block) :: tq, fq
!hpf$ distribute   (*,block) :: sflx
c
      do j = 2,ny
      do k = 1,nz
      do i = 2,nx
c
c  ***  Upstream difference scheme  ***
cx      f1 = 0.5*fac*( fq(i,k,j)+fq(i-1,k, j ) ) +0.5*dx*abs(u(i,k,j))
cx      f2 = 0.5*fac*( fq(i,k,j)+fq( i ,k,j-1) ) +0.5*dy*abs(v(i,k,j))
c
        f1 = 0.5*fac*( fq(i,k,j)+fq(i-1, k , j ) ) +qnu
        f2 = 0.5*fac*( fq(i,k,j)+fq( i , k ,j-1) ) +qnu
c
        uu(i,k,j) = -0.5*( tq(i,k,j)+tq(i-1, k , j ) ) * u (i,k,j)
     :              +f1 *( tq(i,k,j)-tq(i-1, k , j ) ) / dx
        vv(i,k,j) = -0.5*( tq(i,k,j)+tq( i , k ,j-1) ) * v (i,k,j)
     :              +f2 *( tq(i,k,j)-tq( i , k ,j-1) ) / dy
      end do
      end do
      end do
c
      do j = 2,ny-1
      do k = 2,nz+1
      do i = 1,mx
c
c  ***  Upstream difference scheme  ***
cx      f1 = 0.5*fac*( fq(i,k,j)+fq(i,k-1,j) ) +0.5*dz*abs(w(i,k,j))
c
        f1 = 0.5*fac*( fq(i,k,j)+fq( i ,k-1, j ) ) +qnu
c
        ww(i,k,j) = -0.5*( tq(i,k,j)+tq( i ,k-1, j ) ) * w (i,k,j)
     :              +f1 *( tq(i,k,j)-tq( i ,k-1, j ) ) / dz
      end do
      end do
      end do
c
c  ***  Lower boundary condition  ***
      do j = 2,ny-1
      do i = 2,nx-1
        ww(i,1,j) = -sflx(i,j)
      end do
      end do
c
      return
      end
